
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_check {

RF_DECL (AS_To_Ref);

RF_DECL (Check_Vars);

RF_DECL (Check_Inputs);

RF_DECL (Print_Error);

RF_DECL (RFP_Check);

RF_DECL (Print_Pragma);

RF_DECL (Get_Cuts);

RF_DECL (Update_Vars);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_format {

RF_DECL (Format_Exp);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (Lookup_Func);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_format {

RF_DECL (IsSubformat);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_check {

RF_DECL (Satisfies_Format);

}

}

}

}

}

namespace refal {

namespace Access {

RF_DECL (L);

RF_DECL (Middle);

RF_DECL (Length);

}

}

namespace refal {

namespace Arithm {

RF_DECL (Add);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

RF_DECL (Get);

}

}

namespace refal {

namespace Access {

RF_DECL (R);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToChars);

}

}

namespace refal {

namespace List {

RF_DECL (Reverse);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrintLnCh);

RF_DECL (PrintCh);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_err {

extern Expr Error_Counter;

}

}

}

}

}

namespace refal {

namespace StdIO {

extern Expr StdErr;

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

extern Expr RFP_Options;

}

}

}

}

}

namespace refal {

namespace Table {

RF_DECL (Lookup);

}

}

namespace refal {

namespace Compare {

RF_DECL (Gt);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Vars);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_check {

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_42;

static Expr _c_5;

static Expr _c_60;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_32;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_46;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_44;

static Expr _c_30;

static Expr _c_31;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_56;

static Expr _c_36;

static Expr _c_50;

static Expr _c_37;

static Expr _c_53;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_41;

static Expr _c_43;

static Expr _c_45;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_51;

static Expr _c_52;

static Expr _c_54;

static Expr _c_55;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

RF_FUNC (RFP_Check, (RF_ARG _ve_Items;;), RF_VOID)
  {
    if (_ve_Items.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_Items, 0, _ve__dollar_tmp_m_36_m_14, _v_lsplit__Items);
    for ( ; ; RF_iter(_ve_Items)++)
    {
      {
        if (!RF_iter(_ve_Items))
        {
          goto _block1__branch1;
        }
        int _v_len1 = _v_lsplit__Items.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_36_m_23 = (_v_len1 - _v_len2);
        Expr _vt_item;
        _vt_item = Expr (_v_lsplit__Items, 0, 1);
        Expr _ve__dollar_tmp_m_36_m_23;
        _ve__dollar_tmp_m_36_m_23 = Expr (_v_lsplit__Items, (0 + 1), _v_len___dollar_tmp_m_36_m_23);
        {
          {
            Expr _v_Lookup1;
            if (!RF_CALL (::refal::Table::Lookup, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_0), _v_Lookup1))
            {
              goto _block2__branch1;
            }
            int _v_len3 = _v_Lookup1.get_len ();
            int _v_len4 = 0;
            if (_v_len3 < (_v_len4 + 1))
            {
              goto _block2__branch1;
            }
            int _v_len__targets = (_v_len3 - _v_len4);
            Expr _vv_targets;
            _vv_targets = Expr (_v_Lookup1, 0, _v_len__targets);
            if (_v_len__targets < 1)
            {
              goto _continue1;
            }
            if (_vt_item.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__item (Expr (_vt_item, 0));
            int _v_len5 = _v_deref__item.get_len ();
            int _v_len6 = 4;
            if (_v_len5 < _v_len6)
            {
              goto _continue1;
            }
            int _v_len___dollar_tmp_m_40_m_33 = (_v_len5 - _v_len6);
            Expr _vt__dollar_tmp_m_40_m_20;
            _vt__dollar_tmp_m_40_m_20 = Expr (_v_deref__item, 0, 1);
            Expr _vt__dollar_tmp_m_40_m_22;
            _vt__dollar_tmp_m_40_m_22 = Expr (_v_deref__item, (0 + 1), 1);
            Expr _vt__dollar_tmp_m_40_m_24;
            _vt__dollar_tmp_m_40_m_24 = Expr (_v_deref__item, (0 + 1 + 1), 1);
            Expr _vt_name;
            _vt_name = Expr (_v_deref__item, (0 + 1 + 1 + 1), 1);
            Expr _ve__dollar_tmp_m_40_m_33;
            _ve__dollar_tmp_m_40_m_33 = Expr (_v_deref__item, (0 + 1 + 1 + 1 + 1), _v_len___dollar_tmp_m_40_m_33);
            RF_lsplit (_vv_targets, 0, _ve__dollar_tmp_m_39_m_22, _v_lsplit__targets);
            for ( ; ; RF_iter(_vv_targets)++)
            {
              {
                if (!RF_iter(_vv_targets))
                {
                  goto _continue1;
                }
                int _v_len7 = _v_lsplit__targets.get_len ();
                int _v_len8 = 1;
                if (_v_len7 < _v_len8)
                {
                  goto _continue1;
                }
                int _v_len___dollar_tmp_m_39_m_31 = (_v_len7 - _v_len8);
                if (!_vt_name.term_eq (_v_lsplit__targets, 0))
                {
                  goto _continue2;
                }
                Expr _ve__dollar_tmp_m_39_m_31;
                _ve__dollar_tmp_m_39_m_31 = Expr (_v_lsplit__targets, (0 + 1), _v_len___dollar_tmp_m_39_m_31);
                goto _exit2;
              }
          _continue2: {}
            }
          _exit2: {}
            goto _block2;
          }
        _block2__branch1: {}
        }
      _block2: {}
        if (_vt_item.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__item2 (Expr (_vt_item, 0));
        if (_v_deref__item2.get_len () != 7)
        {
          goto _continue1;
        }
        if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1 + 1)))
        {
          goto _continue1;
        }
        if (_v_deref__item2.symbol_at ((0 + 1 + 1 + 1 + 1 + 1)))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__item2 (Expr (_v_deref__item2, (0 + 1 + 1 + 1 + 1)));
        Expr _v_deref__deref__item22 (Expr (_v_deref__item2, (0 + 1 + 1 + 1 + 1 + 1)));
        int _v_len9 = _v_deref__deref__item22.get_len ();
        int _v_len10 = 0;
        if (_v_len9 < _v_len10)
        {
          goto _continue1;
        }
        int _v_len__out = (_v_len9 - _v_len10);
        int _v_len11 = _v_deref__deref__item2.get_len ();
        int _v_len12 = 0;
        if (_v_len11 < _v_len12)
        {
          goto _continue1;
        }
        int _v_len__in = (_v_len11 - _v_len12);
        if (!_v_deref__item2.symbol_at (0))
        {
          goto _continue1;
        }
        if (!_v_deref__item2.symbol_at ((0 + 1)))
        {
          goto _continue1;
        }
        Expr _vs_linkage;
        _vs_linkage = Expr (_v_deref__item2, 0, 1);
        Expr _vs_tag;
        _vs_tag = Expr (_v_deref__item2, (0 + 1), 1);
        Expr _vt_pragma;
        _vt_pragma = Expr (_v_deref__item2, (0 + 1 + 1), 1);
        Expr _vt_name;
        _vt_name = Expr (_v_deref__item2, (0 + 1 + 1 + 1), 1);
        Expr _vt_branch;
        _vt_branch = Expr (_v_deref__item2, (0 + 1 + 1 + 1 + 1 + 1 + 1), 1);
        Expr _ve_in;
        _ve_in = Expr (_v_deref__deref__item2, 0, _v_len__in);
        Expr _ve_out;
        _ve_out = Expr (_v_deref__deref__item22, 0, _v_len__out);
        {
          {
            if (!_vs_tag.term_eq (_c_1, 0))
            {
              goto _block3__branch1;
            }
            goto _block3;
          }
        _block3__branch1: {}
          {
            if (!_vs_tag.term_eq (_c_2, 0))
            {
              goto _block3__branch2;
            }
            goto _block3;
          }
        _block3__branch2: {}
          if (!_vs_tag.term_eq (_c_3, 0))
          {
            goto _continue1;
          }
        }
      _block3: {}
        {
          {
            Expr _ge_auxcall1;
            RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_in, _ge_auxcall1);
            Expr _ge_auxcall2;
            RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_out, _ge_auxcall2);
            if (!RF_CALL (Satisfies_Format, (_ge_auxcall1, _ge_auxcall2, _vt_branch), /*void*/))
            {
              goto _block4__branch1;
            }
            goto _block4;
          }
        _block4__branch1: {}
        }
      _block4: {}
        Expr _ge_auxcall3;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_in, _ge_auxcall3);
        RF_CALL (Check_Vars, (_ge_auxcall3, _vt_branch), /*void*/);
        {
          {
            Expr _ge_auxcall4;
            if (!RF_CALL (Get_Cuts, _vt_branch, _ge_auxcall4))
            {
              goto _block5__branch1;
            }
            Expr _gt_auxcall5;
            if (!RF_CALL (::refal::Access::R, (_c_4, _ge_auxcall4), _gt_auxcall5))
            {
              goto _block5__branch1;
            }
            RF_CALL (Print_Error, (_c_5, _c_6, _gt_auxcall5), /*void*/);
            goto _block5;
          }
        _block5__branch1: {}
        }
      _block5: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (Satisfies_Format, (RF_ARG _ve_InFormat, _ve_OutFormat, _ve_Sentence;;), RF_VOID)
  Expr _ge_Sentence__2 (_ve_Sentence);
  Expr _ge_OutFormat__2 (_ve_OutFormat);
  for ( ; ; )
  {
    {
      if (_ge_Sentence__2.get_len () != 0)
      {
        goto _iter1;
      }
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1 = _ge_Sentence__2.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__Snt = (_v_len1 - _v_len2);
    Expr _ve_Snt;
    _ve_Snt = Expr (_ge_Sentence__2, 0, _v_len__Snt);
    Expr _vt_Statement;
    _vt_Statement = Expr (_ge_Sentence__2, (0 + _v_len__Snt), 1);
    {
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch1;
        }
        Expr _v_deref__Statement (Expr (_vt_Statement, 0));
        int _v_len3 = _v_deref__Statement.get_len ();
        int _v_len4 = 2;
        if (_v_len3 < _v_len4)
        {
          goto _block3__branch1;
        }
        int _v_len__ResultExpression = (_v_len3 - _v_len4);
        if (!_c_7.term_eq (_v_deref__Statement, 0))
        {
          goto _block3__branch1;
        }
        Expr _vt_Pragma;
        _vt_Pragma = Expr (_v_deref__Statement, (0 + 1), 1);
        Expr _ve_ResultExpression;
        _ve_ResultExpression = Expr (_v_deref__Statement, (0 + 1 + 1), _v_len__ResultExpression);
        {
          {
            if (_v_len__ResultExpression != 1)
            {
              goto _block4__branch1;
            }
            if (_ve_ResultExpression.symbol_at (0))
            {
              goto _block4__branch1;
            }
            Expr _v_deref__ResultExpression (Expr (_ve_ResultExpression, 0));
            int _v_len5 = _v_deref__ResultExpression.get_len ();
            int _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              goto _block4__branch1;
            }
            int _v_len___dollar_tmp_m_63_m_44 = (_v_len5 - _v_len6);
            if (!_v_deref__ResultExpression.symbol_at (0))
            {
              goto _block4__branch1;
            }
            Expr _vs_block;
            _vs_block = Expr (_v_deref__ResultExpression, 0, 1);
            Expr _ve__dollar_tmp_m_63_m_44;
            _ve__dollar_tmp_m_63_m_44 = Expr (_v_deref__ResultExpression, (0 + 1), _v_len___dollar_tmp_m_63_m_44);
            {
              {
                if (!_vs_block.term_eq (_c_8, 0))
                {
                  goto _block5__branch1;
                }
                goto _block5;
              }
            _block5__branch1: {}
              if (!_vs_block.term_eq (_c_9, 0))
              {
                goto _block4__branch1;
              }
            }
          _block5: {}
            if (!RF_CALL (Satisfies_Format, (empty, _ge_OutFormat__2, _ve_ResultExpression), /*void*/))
            {
              RF_RETFAIL;
            }
            _ge_Sentence__2 = _ve_Snt;
            _ge_OutFormat__2 = empty;
            goto _block4;
          }
        _block4__branch1: {}
          {
            Expr _ge_auxcall1;
            RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_ResultExpression, _ge_auxcall1);
            if (!RF_CALL (org::refal::plus::compiler::rfp_format::IsSubformat, (_ge_OutFormat__2, _ge_auxcall1), /*void*/))
            {
              goto _block4__branch2;
            }
            RF_CALL (Check_Inputs, _ve_ResultExpression, /*void*/);
            _ge_Sentence__2 = _ve_Snt;
            _ge_OutFormat__2 = empty;
            goto _block4;
          }
        _block4__branch2: {}
          RF_CALL (Print_Error, (_c_5, _c_10, _vt_Pragma), /*void*/);
          RF_RETFAIL;
        }
      _block4: {}
        goto _block3;
      }
    _block3__branch1: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch2;
        }
        Expr _v_deref__Statement2 (Expr (_vt_Statement, 0));
        int _v_len7 = _v_deref__Statement2.get_len ();
        int _v_len8 = 2;
        if (_v_len7 < _v_len8)
        {
          goto _block3__branch2;
        }
        int _v_len__HardExpression = (_v_len7 - _v_len8);
        if (!_c_11.term_eq (_v_deref__Statement2, 0))
        {
          goto _block3__branch2;
        }
        Expr _vt_Pragma;
        _vt_Pragma = Expr (_v_deref__Statement2, (0 + 1), 1);
        Expr _ve_HardExpression;
        _ve_HardExpression = Expr (_v_deref__Statement2, (0 + 1 + 1), _v_len__HardExpression);
        Expr _ge_auxcall2;
        RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_HardExpression, _ge_auxcall2);
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = _ge_auxcall2;
        goto _block3;
      }
    _block3__branch2: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch3;
        }
        Expr _v_deref__Statement3 (Expr (_vt_Statement, 0));
        int _v_len9 = _v_deref__Statement3.get_len ();
        int _v_len10 = 2;
        if (_v_len9 < _v_len10)
        {
          goto _block3__branch3;
        }
        int _v_len__Branches = (_v_len9 - _v_len10);
        if (!_v_deref__Statement3.symbol_at (0))
        {
          goto _block3__branch3;
        }
        Expr _vs_block;
        _vs_block = Expr (_v_deref__Statement3, 0, 1);
        Expr _vt__dollar_tmp_m_83_m_19;
        _vt__dollar_tmp_m_83_m_19 = Expr (_v_deref__Statement3, (0 + 1), 1);
        Expr _ve_Branches;
        _ve_Branches = Expr (_v_deref__Statement3, (0 + 1 + 1), _v_len__Branches);
        {
          {
            if (!_vs_block.term_eq (_c_8, 0))
            {
              goto _block6__branch1;
            }
            goto _block6;
          }
        _block6__branch1: {}
          if (!_vs_block.term_eq (_c_9, 0))
          {
            goto _block3__branch3;
          }
        }
      _block6: {}
        Expr _ve_pref;
        {
          {
            if (_v_len__Snt != 0)
            {
              goto _block7__branch1;
            }
            _ve_pref = empty;
            goto _block7;
          }
        _block7__branch1: {}
          _ve_pref = _c_12;
        }
      _block7: {}
        {
          if (_v_len__Branches < 1)
          {
            goto _block8__branch1;
          }
          RF_lsplit (_ve_Branches, 0, _ve__dollar_tmp_m_89_m_27, _v_lsplit__Branches);
          for ( ; ; RF_iter(_ve_Branches)++)
          {
            {
              if (!RF_iter(_ve_Branches))
              {
                goto _block8__branch1;
              }
              int _v_len11 = _v_lsplit__Branches.get_len ();
              int _v_len12 = 1;
              if (_v_len11 < _v_len12)
              {
                goto _block8__branch1;
              }
              int _v_len___dollar_tmp_m_89_m_47 = (_v_len11 - _v_len12);
              if (_v_lsplit__Branches.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__Branches (Expr (_v_lsplit__Branches, 0));
              int _v_len13 = _v_deref__lsplit__Branches.get_len ();
              int _v_len14 = 2;
              if (_v_len13 < _v_len14)
              {
                goto _continue1;
              }
              int _v_len__Snt1 = (_v_len13 - _v_len14);
              if (!_c_13.term_eq (_v_deref__lsplit__Branches, 0))
              {
                goto _continue1;
              }
              Expr _ve__dollar_tmp_m_89_m_47;
              _ve__dollar_tmp_m_89_m_47 = Expr (_v_lsplit__Branches, (0 + 1), _v_len___dollar_tmp_m_89_m_47);
              Expr _vt__dollar_tmp_m_89_m_37;
              _vt__dollar_tmp_m_89_m_37 = Expr (_v_deref__lsplit__Branches, (0 + 1), 1);
              Expr _ve_Snt1;
              _ve_Snt1 = Expr (_v_deref__lsplit__Branches, (0 + 1 + 1), _v_len__Snt1);
              if (!RF_CALL (Satisfies_Format, (_ve_InFormat, _ge_OutFormat__2, (_ve_pref + _ve_Snt1)), /*void*/))
              {
                goto _continue1;
              }
            }
        _continue1: {}
          }
        _exit1: {}
        }
      _block8__branch1: {}
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = _c_14;
        goto _block3;
      }
    _block3__branch3: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch4;
        }
        Expr _v_deref__Statement4 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement4.get_len () != 2)
        {
          goto _block3__branch4;
        }
        if (_v_deref__Statement4.symbol_at ((0 + 1)))
        {
          goto _block3__branch4;
        }
        Expr _v_deref__deref__Statement4 (Expr (_v_deref__Statement4, (0 + 1)));
        int _v_len15 = _v_deref__deref__Statement4.get_len ();
        int _v_len16 = 2;
        if (_v_len15 < _v_len16)
        {
          goto _block3__branch4;
        }
        int _v_len__Snt12 = (_v_len15 - _v_len16);
        if (!_c_15.term_eq (_v_deref__Statement4, 0))
        {
          goto _block3__branch4;
        }
        if (!_c_13.term_eq (_v_deref__deref__Statement4, 0))
        {
          goto _block3__branch4;
        }
        Expr _vt__dollar_tmp_m_94_m_23;
        _vt__dollar_tmp_m_94_m_23 = Expr (_v_deref__deref__Statement4, (0 + 1), 1);
        Expr _ve_Snt1;
        _ve_Snt1 = Expr (_v_deref__deref__Statement4, (0 + 1 + 1), _v_len__Snt12);
        {
          {
            if (!RF_CALL (org::refal::plus::compiler::rfp_format::IsSubformat, (_ge_OutFormat__2, empty), /*void*/))
            {
              goto _block9__branch1;
            }
            _ge_Sentence__2 = (_ve_Snt + _ve_Snt1);
            _ge_OutFormat__2 = empty;
            goto _block9;
          }
        _block9__branch1: {}
          RF_CALL (Print_Error, (_c_5, _c_10, _vt_Statement), /*void*/);
          RF_RETFAIL;
        }
      _block9: {}
        goto _block3;
      }
    _block3__branch4: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch5;
        }
        Expr _v_deref__Statement5 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement5.get_len () != 2)
        {
          goto _block3__branch5;
        }
        if (_v_deref__Statement5.symbol_at ((0 + 1)))
        {
          goto _block3__branch5;
        }
        Expr _v_deref__deref__Statement5 (Expr (_v_deref__Statement5, (0 + 1)));
        int _v_len17 = _v_deref__deref__Statement5.get_len ();
        int _v_len18 = 2;
        if (_v_len17 < _v_len18)
        {
          goto _block3__branch5;
        }
        int _v_len__Snt13 = (_v_len17 - _v_len18);
        if (!_c_16.term_eq (_v_deref__Statement5, 0))
        {
          goto _block3__branch5;
        }
        if (!_c_13.term_eq (_v_deref__deref__Statement5, 0))
        {
          goto _block3__branch5;
        }
        Expr _vt__dollar_tmp_m_100_m_25;
        _vt__dollar_tmp_m_100_m_25 = Expr (_v_deref__deref__Statement5, (0 + 1), 1);
        Expr _ve_Snt1;
        _ve_Snt1 = Expr (_v_deref__deref__Statement5, (0 + 1 + 1), _v_len__Snt13);
        if (!RF_CALL (Satisfies_Format, (empty, _c_14, _ve_Snt1), /*void*/))
        {
          RF_RETFAIL;
        }
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch5: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch6;
        }
        Expr _v_deref__Statement6 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement6.get_len () != 3)
        {
          goto _block3__branch6;
        }
        if (_v_deref__Statement6.symbol_at ((0 + 1)))
        {
          goto _block3__branch6;
        }
        if (_v_deref__Statement6.symbol_at ((0 + 1 + 1)))
        {
          goto _block3__branch6;
        }
        Expr _v_deref__deref__Statement6 (Expr (_v_deref__Statement6, (0 + 1)));
        Expr _v_deref__deref__Statement62 (Expr (_v_deref__Statement6, (0 + 1 + 1)));
        int _v_len19 = _v_deref__deref__Statement62.get_len ();
        int _v_len20 = 2;
        if (_v_len19 < _v_len20)
        {
          goto _block3__branch6;
        }
        int _v_len__HardExp = (_v_len19 - _v_len20);
        int _v_len21 = _v_deref__deref__Statement6.get_len ();
        int _v_len22 = 2;
        if (_v_len21 < _v_len22)
        {
          goto _block3__branch6;
        }
        int _v_len__Snt14 = (_v_len21 - _v_len22);
        if (!_c_17.term_eq (_v_deref__Statement6, 0))
        {
          goto _block3__branch6;
        }
        if (!_c_13.term_eq (_v_deref__deref__Statement6, 0))
        {
          goto _block3__branch6;
        }
        if (!_c_11.term_eq (_v_deref__deref__Statement62, 0))
        {
          goto _block3__branch6;
        }
        Expr _vt__dollar_tmp_m_103_m_24;
        _vt__dollar_tmp_m_103_m_24 = Expr (_v_deref__deref__Statement6, (0 + 1), 1);
        Expr _ve_Snt1;
        _ve_Snt1 = Expr (_v_deref__deref__Statement6, (0 + 1 + 1), _v_len__Snt14);
        Expr _vt__dollar_tmp_m_103_m_42;
        _vt__dollar_tmp_m_103_m_42 = Expr (_v_deref__deref__Statement62, (0 + 1), 1);
        Expr _ve_HardExp;
        _ve_HardExp = Expr (_v_deref__deref__Statement62, (0 + 1 + 1), _v_len__HardExp);
        Expr _ve_HardFormat;
        RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_HardExp, _ve_HardFormat);
        if (!RF_CALL (Satisfies_Format, (empty, _ve_HardFormat, _ve_Snt1), /*void*/))
        {
          RF_RETFAIL;
        }
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = _ve_HardFormat;
        goto _block3;
      }
    _block3__branch6: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch7;
        }
        Expr _v_deref__Statement7 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement7.get_len () != 3)
        {
          goto _block3__branch7;
        }
        if (_v_deref__Statement7.symbol_at ((0 + 1)))
        {
          goto _block3__branch7;
        }
        if (_v_deref__Statement7.symbol_at ((0 + 1 + 1)))
        {
          goto _block3__branch7;
        }
        Expr _v_deref__deref__Statement7 (Expr (_v_deref__Statement7, (0 + 1)));
        Expr _v_deref__deref__Statement72 (Expr (_v_deref__Statement7, (0 + 1 + 1)));
        int _v_len23 = _v_deref__deref__Statement72.get_len ();
        int _v_len24 = 2;
        if (_v_len23 < _v_len24)
        {
          goto _block3__branch7;
        }
        int _v_len__Snt2 = (_v_len23 - _v_len24);
        int _v_len25 = _v_deref__deref__Statement7.get_len ();
        int _v_len26 = 2;
        if (_v_len25 < _v_len26)
        {
          goto _block3__branch7;
        }
        int _v_len__Snt15 = (_v_len25 - _v_len26);
        if (!_c_18.term_eq (_v_deref__Statement7, 0))
        {
          goto _block3__branch7;
        }
        if (!_c_13.term_eq (_v_deref__deref__Statement7, 0))
        {
          goto _block3__branch7;
        }
        if (!_c_13.term_eq (_v_deref__deref__Statement72, 0))
        {
          goto _block3__branch7;
        }
        Expr _vt__dollar_tmp_m_107_m_23;
        _vt__dollar_tmp_m_107_m_23 = Expr (_v_deref__deref__Statement7, (0 + 1), 1);
        Expr _ve_Snt1;
        _ve_Snt1 = Expr (_v_deref__deref__Statement7, (0 + 1 + 1), _v_len__Snt15);
        Expr _vt__dollar_tmp_m_107_m_41;
        _vt__dollar_tmp_m_107_m_41 = Expr (_v_deref__deref__Statement72, (0 + 1), 1);
        Expr _ve_Snt2;
        _ve_Snt2 = Expr (_v_deref__deref__Statement72, (0 + 1 + 1), _v_len__Snt2);
        if (!RF_CALL (Satisfies_Format, (empty, _ge_OutFormat__2, _ve_Snt1), /*void*/))
        {
          RF_RETFAIL;
        }
        if (!RF_CALL (Satisfies_Format, (_c_14, _ge_OutFormat__2, _ve_Snt2), /*void*/))
        {
          RF_RETFAIL;
        }
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch7: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch8;
        }
        Expr _v_deref__Statement8 (Expr (_vt_Statement, 0));
        int _v_len27 = _v_deref__Statement8.get_len ();
        int _v_len28 = 2;
        if (_v_len27 < _v_len28)
        {
          goto _block3__branch8;
        }
        int _v_len__PatternExpression = (_v_len27 - _v_len28);
        if (!_v_deref__Statement8.symbol_at (0))
        {
          goto _block3__branch8;
        }
        Expr _vs_tag;
        _vs_tag = Expr (_v_deref__Statement8, 0, 1);
        Expr _vt_Pragma;
        _vt_Pragma = Expr (_v_deref__Statement8, (0 + 1), 1);
        Expr _ve_PatternExpression;
        _ve_PatternExpression = Expr (_v_deref__Statement8, (0 + 1 + 1), _v_len__PatternExpression);
        {
          {
            if (!_vs_tag.term_eq (_c_19, 0))
            {
              goto _block10__branch1;
            }
            goto _block10;
          }
        _block10__branch1: {}
          if (!_vs_tag.term_eq (_c_20, 0))
          {
            goto _block3__branch8;
          }
        }
      _block10: {}
        {
          {
            if (_v_len__Snt != 0)
            {
              goto _block11__branch1;
            }
            Expr _ve_PatternFormat;
            RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_PatternExpression, _ve_PatternFormat);
            {
              {
                if (!RF_CALL (org::refal::plus::compiler::rfp_format::IsSubformat, (_ve_InFormat, _ve_PatternFormat), /*void*/))
                {
                  goto _block12__branch1;
                }
                _ge_Sentence__2 = empty;
                _ge_OutFormat__2 = empty;
                goto _block12;
              }
            _block12__branch1: {}
              RF_CALL (Print_Error, (_c_5, _c_21, _vt_Pragma), /*void*/);
              RF_RETFAIL;
            }
          _block12: {}
            goto _block11;
          }
        _block11__branch1: {}
          _ge_Sentence__2 = _ve_Snt;
          _ge_OutFormat__2 = _c_14;
        }
      _block11: {}
        goto _block3;
      }
    _block3__branch8: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch9;
        }
        Expr _v_deref__Statement9 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement9.get_len () != 2)
        {
          goto _block3__branch9;
        }
        if (!_c_22.term_eq (_v_deref__Statement9, 0))
        {
          goto _block3__branch9;
        }
        Expr _vt__dollar_tmp_m_126_m_18;
        _vt__dollar_tmp_m_126_m_18 = Expr (_v_deref__Statement9, (0 + 1), 1);
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch9: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch10;
        }
        Expr _v_deref__Statement10 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement10.get_len () != 2)
        {
          goto _block3__branch10;
        }
        if (!_c_23.term_eq (_v_deref__Statement10, 0))
        {
          goto _block3__branch10;
        }
        Expr _vt__dollar_tmp_m_127_m_16;
        _vt__dollar_tmp_m_127_m_16 = Expr (_v_deref__Statement10, (0 + 1), 1);
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch10: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch11;
        }
        Expr _v_deref__Statement11 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement11.get_len () != 2)
        {
          goto _block3__branch11;
        }
        if (!_c_24.term_eq (_v_deref__Statement11, 0))
        {
          goto _block3__branch11;
        }
        Expr _vt__dollar_tmp_m_128_m_18;
        _vt__dollar_tmp_m_128_m_18 = Expr (_v_deref__Statement11, (0 + 1), 1);
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch11: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch12;
        }
        Expr _v_deref__Statement12 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement12.get_len () != 2)
        {
          goto _block3__branch12;
        }
        if (!_c_25.term_eq (_v_deref__Statement12, 0))
        {
          goto _block3__branch12;
        }
        Expr _vt__dollar_tmp_m_129_m_15;
        _vt__dollar_tmp_m_129_m_15 = Expr (_v_deref__Statement12, (0 + 1), 1);
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch12: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch13;
        }
        Expr _v_deref__Statement13 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement13.get_len () != 2)
        {
          goto _block3__branch13;
        }
        if (!_c_26.term_eq (_v_deref__Statement13, 0))
        {
          goto _block3__branch13;
        }
        Expr _vt__dollar_tmp_m_130_m_17;
        _vt__dollar_tmp_m_130_m_17 = Expr (_v_deref__Statement13, (0 + 1), 1);
        _ge_Sentence__2 = _ve_Snt;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch13: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch14;
        }
        Expr _v_deref__Statement14 (Expr (_vt_Statement, 0));
        int _v_len29 = _v_deref__Statement14.get_len ();
        int _v_len30 = 2;
        if (_v_len29 < _v_len30)
        {
          goto _block3__branch14;
        }
        int _v_len__Snt16 = (_v_len29 - _v_len30);
        if (!_c_13.term_eq (_v_deref__Statement14, 0))
        {
          goto _block3__branch14;
        }
        Expr _vt__dollar_tmp_m_131_m_18;
        _vt__dollar_tmp_m_131_m_18 = Expr (_v_deref__Statement14, (0 + 1), 1);
        Expr _ve_Snt1;
        _ve_Snt1 = Expr (_v_deref__Statement14, (0 + 1 + 1), _v_len__Snt16);
        if (!RF_CALL (Satisfies_Format, (_ve_InFormat, _ge_OutFormat__2, _ve_Snt1), /*void*/))
        {
          RF_RETFAIL;
        }
        _ge_Sentence__2 = empty;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch14: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch15;
        }
        Expr _v_deref__Statement15 (Expr (_vt_Statement, 0));
        int _v_len31 = _v_deref__Statement15.get_len ();
        int _v_len32 = 1;
        if (_v_len31 < _v_len32)
        {
          goto _block3__branch15;
        }
        int _v_len___dollar_tmp_m_133_m_18 = (_v_len31 - _v_len32);
        if (!_c_27.term_eq (_v_deref__Statement15, 0))
        {
          goto _block3__branch15;
        }
        Expr _ve__dollar_tmp_m_133_m_18;
        _ve__dollar_tmp_m_133_m_18 = Expr (_v_deref__Statement15, (0 + 1), _v_len___dollar_tmp_m_133_m_18);
        _ge_Sentence__2 = empty;
        _ge_OutFormat__2 = empty;
        goto _block3;
      }
    _block3__branch15: {}
      if (!_vt_Statement.term_eq (_c_12, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _ge_Sentence__2 = empty;
      _ge_OutFormat__2 = empty;
    }
  _block3: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Check_Inputs, (RF_ARG _ge_arg1;;), RF_VOID)
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_first;
      _vt_first = Expr (_ge_arg1, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
      {
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__first (Expr (_vt_first, 0));
          int _v_len3 = _v_deref__first.get_len ();
          int _v_len4 = 3;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len__ResultExpression = (_v_len3 - _v_len4);
          if (!_c_28.term_eq (_v_deref__first, 0))
          {
            goto _block2__branch1;
          }
          Expr _vt_Pragma;
          _vt_Pragma = Expr (_v_deref__first, (0 + 1), 1);
          Expr _vt_Fname;
          _vt_Fname = Expr (_v_deref__first, (0 + 1 + 1), 1);
          Expr _ve_ResultExpression;
          _ve_ResultExpression = Expr (_v_deref__first, (0 + 1 + 1 + 1), _v_len__ResultExpression);
          {
            {
              Expr _gs_auxcall1;
              Expr _gs_auxcall2;
              Expr _ge_auxcall3;
              Expr _ge_auxcall4;
              if (!RF_CALL (org::refal::plus::compiler::rfp_helper::Lookup_Func, _vt_Fname, (_gs_auxcall1, _gs_auxcall2, _ge_auxcall3, _ge_auxcall4)))
              {
                goto _block3__branch1;
              }
              Expr _v_L1;
              if (!RF_CALL (::refal::Access::L, (_c_29, (_gs_auxcall1 + _gs_auxcall2 + _ge_auxcall3 () + _ge_auxcall4 ())), _v_L1))
              {
                goto _block3__branch1;
              }
              if (_v_L1.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__L1 (Expr (_v_L1, 0));
              int _v_len5 = _v_deref__L1.get_len ();
              int _v_len6 = 0;
              if (_v_len5 < _v_len6)
              {
                goto _block3__branch1;
              }
              int _v_len__Fin = (_v_len5 - _v_len6);
              Expr _ve_Fin;
              _ve_Fin = Expr (_v_deref__L1, 0, _v_len__Fin);
              {
                Expr _ge_auxcall5;
                RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_ResultExpression, _ge_auxcall5);
                if (!RF_CALL (org::refal::plus::compiler::rfp_format::IsSubformat, (_ve_Fin, _ge_auxcall5), /*void*/))
                {
                  goto _negation1;
                }
                goto _block3__branch1;
              }
            _negation1: {}
              RF_CALL (Print_Error, (_c_5, _c_30, _vt_Pragma), /*void*/);
              goto _block3;
            }
          _block3__branch1: {}
          }
        _block3: {}
          RF_CALL (Check_Inputs, _ve_ResultExpression, /*void*/);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__first2 (Expr (_vt_first, 0));
          int _v_len7 = _v_deref__first2.get_len ();
          int _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          int _v_len__paren__expr = (_v_len7 - _v_len8);
          if (!_c_31.term_eq (_v_deref__first2, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_paren__expr;
          _ve_paren__expr = Expr (_v_deref__first2, (0 + 1), _v_len__paren__expr);
          RF_CALL (Check_Inputs, _ve_paren__expr, /*void*/);
          goto _block2;
        }
      _block2__branch2: {}
        Expr _vt_var__or__symbol;
        _vt_var__or__symbol = Expr (_vt_first, 0, 1);
      }
    _block2: {}
      RF_TAILCALL (Check_Inputs, _ve_rest, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (Check_Vars, (RF_ARG _ve_vars, _ve_Sentence;;), RF_VOID)
  Expr _ge_vars__0 (_ve_vars);
  Expr _ge_Sentence__0 (_ve_Sentence);
  for ( ; ; )
  {
    {
      if (_ge_Sentence__0.get_len () != 0)
      {
        goto _iter1;
      }
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1 = _ge_Sentence__0.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__Snt = (_v_len1 - _v_len2);
    Expr _vt_Statement;
    _vt_Statement = Expr (_ge_Sentence__0, 0, 1);
    Expr _ve_Snt;
    _ve_Snt = Expr (_ge_Sentence__0, (0 + 1), _v_len__Snt);
    Expr _ge_vars__0__3;
    {
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch1;
        }
        Expr _v_deref__Statement (Expr (_vt_Statement, 0));
        int _v_len3 = _v_deref__Statement.get_len ();
        int _v_len4 = 2;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch1;
        }
        int _v_len__Re = (_v_len3 - _v_len4);
        if (!_c_7.term_eq (_v_deref__Statement, 0))
        {
          goto _block2__branch1;
        }
        Expr _vt__dollar_tmp_m_168_m_18;
        _vt__dollar_tmp_m_168_m_18 = Expr (_v_deref__Statement, (0 + 1), 1);
        Expr _ve_Re;
        _ve_Re = Expr (_v_deref__Statement, (0 + 1 + 1), _v_len__Re);
        RF_CALL (Check_Vars, (_ge_vars__0, _ve_Re), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__Statement2 (Expr (_vt_Statement, 0));
        int _v_len5 = _v_deref__Statement2.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _block2__branch2;
        }
        int _v_len__Re2 = (_v_len5 - _v_len6);
        if (!_c_31.term_eq (_v_deref__Statement2, 0))
        {
          goto _block2__branch2;
        }
        Expr _ve_Re;
        _ve_Re = Expr (_v_deref__Statement2, (0 + 1), _v_len__Re2);
        RF_CALL (Check_Vars, (_ge_vars__0, _ve_Re), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch3;
        }
        Expr _v_deref__Statement3 (Expr (_vt_Statement, 0));
        int _v_len7 = _v_deref__Statement3.get_len ();
        int _v_len8 = 3;
        if (_v_len7 < _v_len8)
        {
          goto _block2__branch3;
        }
        int _v_len__Re3 = (_v_len7 - _v_len8);
        if (!_c_28.term_eq (_v_deref__Statement3, 0))
        {
          goto _block2__branch3;
        }
        Expr _vt__dollar_tmp_m_170_m_16;
        _vt__dollar_tmp_m_170_m_16 = Expr (_v_deref__Statement3, (0 + 1), 1);
        Expr _vt__dollar_tmp_m_170_m_18;
        _vt__dollar_tmp_m_170_m_18 = Expr (_v_deref__Statement3, (0 + 1 + 1), 1);
        Expr _ve_Re;
        _ve_Re = Expr (_v_deref__Statement3, (0 + 1 + 1 + 1), _v_len__Re3);
        RF_CALL (Check_Vars, (_ge_vars__0, _ve_Re), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch3: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch4;
        }
        Expr _v_deref__Statement4 (Expr (_vt_Statement, 0));
        int _v_len9 = _v_deref__Statement4.get_len ();
        int _v_len10 = 2;
        if (_v_len9 < _v_len10)
        {
          goto _block2__branch4;
        }
        int _v_len__name = (_v_len9 - _v_len10);
        if (!_v_deref__Statement4.symbol_at (0))
        {
          goto _block2__branch4;
        }
        Expr _vs_type;
        _vs_type = Expr (_v_deref__Statement4, 0, 1);
        Expr _vt_Pragma;
        _vt_Pragma = Expr (_v_deref__Statement4, (0 + 1), 1);
        Expr _ve_name;
        _ve_name = Expr (_v_deref__Statement4, (0 + 1 + 1), _v_len__name);
        {
          {
            if (!_vs_type.term_eq (_c_32, 0))
            {
              goto _block3__branch1;
            }
            goto _block3;
          }
        _block3__branch1: {}
          {
            if (!_vs_type.term_eq (_c_33, 0))
            {
              goto _block3__branch2;
            }
            goto _block3;
          }
        _block3__branch2: {}
          {
            if (!_vs_type.term_eq (_c_34, 0))
            {
              goto _block3__branch3;
            }
            goto _block3;
          }
        _block3__branch3: {}
          if (!_vs_type.term_eq (_c_35, 0))
          {
            goto _block2__branch4;
          }
        }
      _block3: {}
        {
          {
            if (_ge_vars__0.get_len () < 1)
            {
              goto _block4__branch1;
            }
            RF_lsplit (_ge_vars__0, 0, _ve__dollar_tmp_m_173_m_23, _v_lsplit__vars__0);
            for ( ; ; RF_iter(_ge_vars__0)++)
            {
              {
                if (!RF_iter(_ge_vars__0))
                {
                  goto _block4__branch1;
                }
                int _v_len11 = _v_lsplit__vars__0.get_len ();
                int _v_len12 = 1;
                if (_v_len11 < _v_len12)
                {
                  goto _block4__branch1;
                }
                int _v_len___dollar_tmp_m_173_m_42 = (_v_len11 - _v_len12);
                if (_v_lsplit__vars__0.symbol_at (0))
                {
                  goto _continue1;
                }
                Expr _v_deref__lsplit__vars__0 (Expr (_v_lsplit__vars__0, 0));
                if (_v_deref__lsplit__vars__0.get_len () != (_v_len__name + 2))
                {
                  goto _continue1;
                }
                if (!_v_deref__lsplit__vars__0.symbol_at (0))
                {
                  goto _continue1;
                }
                if (!_ve_name.eq (_v_deref__lsplit__vars__0, (0 + 1 + 1)))
                {
                  goto _continue1;
                }
                Expr _ve__dollar_tmp_m_173_m_42;
                _ve__dollar_tmp_m_173_m_42 = Expr (_v_lsplit__vars__0, (0 + 1), _v_len___dollar_tmp_m_173_m_42);
                Expr _vs_t;
                _vs_t = Expr (_v_deref__lsplit__vars__0, 0, 1);
                Expr _vt_p;
                _vt_p = Expr (_v_deref__lsplit__vars__0, (0 + 1), 1);
                {
                  {
                    if (!_vs_type.term_eq (_vs_t, 0))
                    {
                      goto _block5__branch1;
                    }
                    goto _block5;
                  }
                _block5__branch1: {}
                  RF_CALL (Print_Error, (_c_5, (_c_36 + (_vs_t + _vt_p + _ve_name) () + _vs_type), _vt_Pragma), /*void*/);
                }
              _block5: {}
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block4;
          }
        _block4__branch1: {}
          RF_CALL (Print_Error, (_c_5, (_c_37 + (_vs_type + _vt_Pragma + _ve_name) ()), _vt_Pragma), /*void*/);
        }
      _block4: {}
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch4: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch5;
        }
        Expr _v_deref__Statement5 (Expr (_vt_Statement, 0));
        int _v_len13 = _v_deref__Statement5.get_len ();
        int _v_len14 = 2;
        if (_v_len13 < _v_len14)
        {
          goto _block2__branch5;
        }
        int _v_len__He = (_v_len13 - _v_len14);
        if (!_c_11.term_eq (_v_deref__Statement5, 0))
        {
          goto _block2__branch5;
        }
        Expr _vt__dollar_tmp_m_181_m_18;
        _vt__dollar_tmp_m_181_m_18 = Expr (_v_deref__Statement5, (0 + 1), 1);
        Expr _ve_He;
        _ve_He = Expr (_v_deref__Statement5, (0 + 1 + 1), _v_len__He);
        Expr _v_Vars1;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_He, _v_Vars1);
        int _v_len15 = _v_Vars1.get_len ();
        int _v_len16 = 0;
        if (_v_len15 < _v_len16)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__He__vars = (_v_len15 - _v_len16);
        Expr _ve_He__vars;
        _ve_He__vars = Expr (_v_Vars1, 0, _v_len__He__vars);
        {
          if (_v_len__He__vars < 2)
          {
            goto _block6__branch1;
          }
          RF_lsplit (_ve_He__vars, 0, _ve__dollar_tmp_m_184_m_29, _v_lsplit__He__vars);
          for ( ; ; RF_iter(_ve_He__vars)++)
          {
            {
              if (!RF_iter(_ve_He__vars))
              {
                goto _block6__branch1;
              }
              if (_v_lsplit__He__vars.get_len () < 2)
              {
                goto _block6__branch1;
              }
              if (_v_lsplit__He__vars.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__He__vars (Expr (_v_lsplit__He__vars, 0));
              int _v_len17 = _v_deref__lsplit__He__vars.get_len ();
              int _v_len18 = 2;
              if (_v_len17 < _v_len18)
              {
                goto _continue2;
              }
              int _v_len__3 = (_v_len17 - _v_len18);
              if (!_v_deref__lsplit__He__vars.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _vs_1;
              _vs_1 = Expr (_v_deref__lsplit__He__vars, 0, 1);
              Expr _vt_p1;
              _vt_p1 = Expr (_v_deref__lsplit__He__vars, (0 + 1), 1);
              Expr _ve_3;
              _ve_3 = Expr (_v_deref__lsplit__He__vars, (0 + 1 + 1), _v_len__3);
              Expr _v_subexpr__lsplit__He__vars (Expr (_v_lsplit__He__vars, (0 + 1), (_v_lsplit__He__vars.get_len () - (0 + 1 + 0))));
              RF_lsplit (_v_subexpr__lsplit__He__vars, 0, _ve__dollar_tmp_m_184_m_44, _v_lsplit__lsplit__He__vars);
              for ( ; ; RF_iter(_v_subexpr__lsplit__He__vars)++)
              {
                {
                  if (!RF_iter(_v_subexpr__lsplit__He__vars))
                  {
                    goto _continue2;
                  }
                  int _v_len19 = _v_lsplit__lsplit__He__vars.get_len ();
                  int _v_len20 = 1;
                  if (_v_len19 < _v_len20)
                  {
                    goto _continue2;
                  }
                  int _v_len__4 = (_v_len19 - _v_len20);
                  if (_v_lsplit__lsplit__He__vars.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  Expr _v_deref__lsplit__lsplit__He__vars (Expr (_v_lsplit__lsplit__He__vars, 0));
                  if (_v_deref__lsplit__lsplit__He__vars.get_len () != (_v_len__3 + 2))
                  {
                    goto _continue3;
                  }
                  if (!_v_deref__lsplit__lsplit__He__vars.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  if (!_ve_3.eq (_v_deref__lsplit__lsplit__He__vars, (0 + 1 + 1)))
                  {
                    goto _continue3;
                  }
                  Expr _ve_4;
                  _ve_4 = Expr (_v_lsplit__lsplit__He__vars, (0 + 1), _v_len__4);
                  Expr _vs_2;
                  _vs_2 = Expr (_v_deref__lsplit__lsplit__He__vars, 0, 1);
                  Expr _vt_p2;
                  _vt_p2 = Expr (_v_deref__lsplit__lsplit__He__vars, (0 + 1), 1);
                  {
                    {
                      if (!_vs_2.term_eq (_vs_1, 0))
                      {
                        goto _block7__branch1;
                      }
                      goto _block7;
                    }
                  _block7__branch1: {}
                    RF_CALL (Print_Error, (_c_5, (_c_36 + (_vs_1 + _vt_p1 + _ve_3) () + _vs_2), _vt_p2), /*void*/);
                  }
                _block7: {}
                  RF_CALL (Print_Error, (_c_5, (_c_38 + (_vs_1 + _vt_p1 + _ve_3) ()), _vt_p2), /*void*/);
                  if (_v_len__4 != 0)
                  {
                    goto _continue3;
                  }
                  goto _block6__branch1;
                }
            _continue3: {}
              }
            _exit3: {}
            }
        _continue2: {}
          }
        _exit2: {}
        }
      _block6__branch1: {}
        Expr _ge_auxcall1;
        RF_CALL (::refal::List::Reverse, _ve_He__vars, _ge_auxcall1);
        RF_CALL (Update_Vars, (_c_39, _ge_vars__0, _ge_auxcall1), _ge_vars__0__3);
        goto _block2;
      }
    _block2__branch5: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch6;
        }
        Expr _v_deref__Statement6 (Expr (_vt_Statement, 0));
        int _v_len21 = _v_deref__Statement6.get_len ();
        int _v_len22 = 2;
        if (_v_len21 < _v_len22)
        {
          goto _block2__branch6;
        }
        int _v_len__Pe = (_v_len21 - _v_len22);
        if (!_c_19.term_eq (_v_deref__Statement6, 0))
        {
          goto _block2__branch6;
        }
        Expr _vt__dollar_tmp_m_193_m_17;
        _vt__dollar_tmp_m_193_m_17 = Expr (_v_deref__Statement6, (0 + 1), 1);
        Expr _ve_Pe;
        _ve_Pe = Expr (_v_deref__Statement6, (0 + 1 + 1), _v_len__Pe);
        Expr _ge_auxcall2;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ge_auxcall2);
        RF_CALL (Update_Vars, (_c_21, _ge_vars__0, _ge_auxcall2), _ge_vars__0__3);
        goto _block2;
      }
    _block2__branch6: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch7;
        }
        Expr _v_deref__Statement7 (Expr (_vt_Statement, 0));
        int _v_len23 = _v_deref__Statement7.get_len ();
        int _v_len24 = 2;
        if (_v_len23 < _v_len24)
        {
          goto _block2__branch7;
        }
        int _v_len__Pe2 = (_v_len23 - _v_len24);
        if (!_c_20.term_eq (_v_deref__Statement7, 0))
        {
          goto _block2__branch7;
        }
        Expr _vt__dollar_tmp_m_194_m_17;
        _vt__dollar_tmp_m_194_m_17 = Expr (_v_deref__Statement7, (0 + 1), 1);
        Expr _ve_Pe;
        _ve_Pe = Expr (_v_deref__Statement7, (0 + 1 + 1), _v_len__Pe2);
        Expr _ge_auxcall3;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ge_auxcall3);
        RF_CALL (Update_Vars, (_c_21, _ge_vars__0, _ge_auxcall3), _ge_vars__0__3);
        goto _block2;
      }
    _block2__branch7: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch8;
        }
        Expr _v_deref__Statement8 (Expr (_vt_Statement, 0));
        int _v_len25 = _v_deref__Statement8.get_len ();
        int _v_len26 = 2;
        if (_v_len25 < _v_len26)
        {
          goto _block2__branch8;
        }
        int _v_len__Branches = (_v_len25 - _v_len26);
        if (!_v_deref__Statement8.symbol_at (0))
        {
          goto _block2__branch8;
        }
        Expr _vs_block;
        _vs_block = Expr (_v_deref__Statement8, 0, 1);
        Expr _vt__dollar_tmp_m_195_m_19;
        _vt__dollar_tmp_m_195_m_19 = Expr (_v_deref__Statement8, (0 + 1), 1);
        Expr _ve_Branches;
        _ve_Branches = Expr (_v_deref__Statement8, (0 + 1 + 1), _v_len__Branches);
        {
          {
            if (!_vs_block.term_eq (_c_8, 0))
            {
              goto _block8__branch1;
            }
            goto _block8;
          }
        _block8__branch1: {}
          if (!_vs_block.term_eq (_c_9, 0))
          {
            goto _block2__branch8;
          }
        }
      _block8: {}
        {
          if (_v_len__Branches < 1)
          {
            goto _block9__branch1;
          }
          RF_lsplit (_ve_Branches, 0, _ve__dollar_tmp_m_197_m_27, _v_lsplit__Branches);
          for ( ; ; RF_iter(_ve_Branches)++)
          {
            {
              if (!RF_iter(_ve_Branches))
              {
                goto _block9__branch1;
              }
              int _v_len27 = _v_lsplit__Branches.get_len ();
              int _v_len28 = 1;
              if (_v_len27 < _v_len28)
              {
                goto _block9__branch1;
              }
              int _v_len___dollar_tmp_m_197_m_38 = (_v_len27 - _v_len28);
              Expr _vt_branch;
              _vt_branch = Expr (_v_lsplit__Branches, 0, 1);
              Expr _ve__dollar_tmp_m_197_m_38;
              _ve__dollar_tmp_m_197_m_38 = Expr (_v_lsplit__Branches, (0 + 1), _v_len___dollar_tmp_m_197_m_38);
              RF_CALL (Check_Vars, (_ge_vars__0, _vt_branch), /*void*/);
            }
        _continue4: {}
          }
        _exit4: {}
        }
      _block9__branch1: {}
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch8: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch9;
        }
        Expr _v_deref__Statement9 (Expr (_vt_Statement, 0));
        int _v_len29 = _v_deref__Statement9.get_len ();
        int _v_len30 = 2;
        if (_v_len29 < _v_len30)
        {
          goto _block2__branch9;
        }
        int _v_len__Snt1 = (_v_len29 - _v_len30);
        if (!_c_13.term_eq (_v_deref__Statement9, 0))
        {
          goto _block2__branch9;
        }
        Expr _vt__dollar_tmp_m_202_m_18;
        _vt__dollar_tmp_m_202_m_18 = Expr (_v_deref__Statement9, (0 + 1), 1);
        Expr _ve_Snt1;
        _ve_Snt1 = Expr (_v_deref__Statement9, (0 + 1 + 1), _v_len__Snt1);
        RF_CALL (Check_Vars, (_ge_vars__0, _ve_Snt1), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch9: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch10;
        }
        Expr _v_deref__Statement10 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement10.get_len () != 3)
        {
          goto _block2__branch10;
        }
        if (!_c_17.term_eq (_v_deref__Statement10, 0))
        {
          goto _block2__branch10;
        }
        Expr _vt_IterBody;
        _vt_IterBody = Expr (_v_deref__Statement10, (0 + 1), 1);
        Expr _vt_IterVars;
        _vt_IterVars = Expr (_v_deref__Statement10, (0 + 1 + 1), 1);
        RF_CALL (Check_Vars, (_ge_vars__0, (_vt_IterVars + _vt_IterBody)), /*void*/);
        if (_vt_IterVars.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__IterVars (Expr (_vt_IterVars, 0));
        int _v_len31 = _v_deref__IterVars.get_len ();
        int _v_len32 = 2;
        if (_v_len31 < _v_len32)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__He2 = (_v_len31 - _v_len32);
        if (!_c_11.term_eq (_v_deref__IterVars, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vt__dollar_tmp_m_207_m_33;
        _vt__dollar_tmp_m_207_m_33 = Expr (_v_deref__IterVars, (0 + 1), 1);
        Expr _ve_He;
        _ve_He = Expr (_v_deref__IterVars, (0 + 1 + 1), _v_len__He2);
        Expr _ge_auxcall4;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_He, _ge_auxcall4);
        RF_CALL (Update_Vars, (_c_39, _ge_vars__0, _ge_auxcall4), _ge_vars__0__3);
        goto _block2;
      }
    _block2__branch10: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch11;
        }
        Expr _v_deref__Statement11 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement11.get_len () != 3)
        {
          goto _block2__branch11;
        }
        if (!_c_18.term_eq (_v_deref__Statement11, 0))
        {
          goto _block2__branch11;
        }
        Expr _vt_TryBranch;
        _vt_TryBranch = Expr (_v_deref__Statement11, (0 + 1), 1);
        Expr _vt_CatchBranch;
        _vt_CatchBranch = Expr (_v_deref__Statement11, (0 + 1 + 1), 1);
        RF_CALL (Check_Vars, (_ge_vars__0, _vt_TryBranch), /*void*/);
        RF_CALL (Check_Vars, (_ge_vars__0, _vt_CatchBranch), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch11: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch12;
        }
        Expr _v_deref__Statement12 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement12.get_len () != 2)
        {
          goto _block2__branch12;
        }
        if (!_c_15.term_eq (_v_deref__Statement12, 0))
        {
          goto _block2__branch12;
        }
        Expr _vt_Branch;
        _vt_Branch = Expr (_v_deref__Statement12, (0 + 1), 1);
        RF_CALL (Check_Vars, (_ge_vars__0, _vt_Branch), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch12: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch13;
        }
        Expr _v_deref__Statement13 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement13.get_len () != 2)
        {
          goto _block2__branch13;
        }
        if (!_c_16.term_eq (_v_deref__Statement13, 0))
        {
          goto _block2__branch13;
        }
        Expr _vt_Branch;
        _vt_Branch = Expr (_v_deref__Statement13, (0 + 1), 1);
        RF_CALL (Check_Vars, (_ge_vars__0, _vt_Branch), /*void*/);
        _ge_vars__0__3 = _ge_vars__0;
        goto _block2;
      }
    _block2__branch13: {}
      Expr _vt_any__other;
      _vt_any__other = Expr (_vt_Statement, 0, 1);
      _ge_vars__0__3 = _ge_vars__0;
    }
  _block2: {}
    _ge_vars__0 = _ge_vars__0__3;
    _ge_Sentence__0 = _ve_Snt;
  }
_exit__iter1: {}
RF_END

RF_FUNC (Update_Vars, (RF_ARG _vs_Isformat, _ve_vars, _ve_new__vars;;), (RF_RES _v_res1;;))
  Expr _ge_vars__0 (_ve_vars);
  Expr _ge_new__vars__0 (_ve_new__vars);
  for ( ; ; )
  {
    {
      if (_ge_new__vars__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ge_vars__0;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1 = _ge_new__vars__0.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest = (_v_len1 - _v_len2);
    if (_ge_new__vars__0.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__new__vars__0 (Expr (_ge_new__vars__0, 0));
    int _v_len3 = _v_deref__new__vars__0.get_len ();
    int _v_len4 = 2;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__name = (_v_len3 - _v_len4);
    if (!_v_deref__new__vars__0.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_rest;
    _ve_rest = Expr (_ge_new__vars__0, (0 + 1), _v_len__rest);
    Expr _vs_type;
    _vs_type = Expr (_v_deref__new__vars__0, 0, 1);
    Expr _vt_p2;
    _vt_p2 = Expr (_v_deref__new__vars__0, (0 + 1), 1);
    Expr _ve_name;
    _ve_name = Expr (_v_deref__new__vars__0, (0 + 1 + 1), _v_len__name);
    {
      {
        if (_ge_vars__0.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ge_vars__0, 0, _ve__dollar_tmp_m_233_m_10, _v_lsplit__vars__0);
        for ( ; ; RF_iter(_ge_vars__0)++)
        {
          {
            if (!RF_iter(_ge_vars__0))
            {
              goto _block2__branch1;
            }
            int _v_len5 = _v_lsplit__vars__0.get_len ();
            int _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              goto _block2__branch1;
            }
            int _v_len___dollar_tmp_m_233_m_30 = (_v_len5 - _v_len6);
            if (_v_lsplit__vars__0.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__lsplit__vars__0 (Expr (_v_lsplit__vars__0, 0));
            if (_v_deref__lsplit__vars__0.get_len () != (_v_len__name + 2))
            {
              goto _continue1;
            }
            if (!_vs_type.term_eq (_v_deref__lsplit__vars__0, 0))
            {
              goto _continue1;
            }
            if (!_ve_name.eq (_v_deref__lsplit__vars__0, (0 + 1 + 1)))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_233_m_30;
            _ve__dollar_tmp_m_233_m_30 = Expr (_v_lsplit__vars__0, (0 + 1), _v_len___dollar_tmp_m_233_m_30);
            Expr _vt__dollar_tmp_m_233_m_20;
            _vt__dollar_tmp_m_233_m_20 = Expr (_v_deref__lsplit__vars__0, (0 + 1), 1);
            _ge_new__vars__0 = _ve_rest;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (_ge_vars__0.get_len () < 1)
        {
          goto _block2__branch2;
        }
        RF_lsplit (_ge_vars__0, 0, _ve_1, _v_lsplit__vars__02);
        for ( ; ; RF_iter(_ge_vars__0)++)
        {
          {
            if (!RF_iter(_ge_vars__0))
            {
              goto _block2__branch2;
            }
            int _v_len7 = _v_lsplit__vars__02.get_len ();
            int _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              goto _block2__branch2;
            }
            int _v_len__2 = (_v_len7 - _v_len8);
            if (_v_lsplit__vars__02.symbol_at (0))
            {
              goto _continue2;
            }
            Expr _v_deref__lsplit__vars__02 (Expr (_v_lsplit__vars__02, 0));
            if (_v_deref__lsplit__vars__02.get_len () != (_v_len__name + 2))
            {
              goto _continue2;
            }
            if (!_v_deref__lsplit__vars__02.symbol_at (0))
            {
              goto _continue2;
            }
            if (!_ve_name.eq (_v_deref__lsplit__vars__02, (0 + 1 + 1)))
            {
              goto _continue2;
            }
            Expr _ve_2;
            _ve_2 = Expr (_v_lsplit__vars__02, (0 + 1), _v_len__2);
            Expr _vs_t;
            _vs_t = Expr (_v_deref__lsplit__vars__02, 0, 1);
            Expr _vt_p1;
            _vt_p1 = Expr (_v_deref__lsplit__vars__02, (0 + 1), 1);
            {
              {
                if (!_vs_Isformat.term_eq (_c_39, 0))
                {
                  goto _block3__branch1;
                }
                _ge_vars__0 = (_ve_1 + _ve_2 + (_vs_type + _vt_p2 + _ve_name) ());
                _ge_new__vars__0 = _ve_rest;
                goto _block3;
              }
            _block3__branch1: {}
              RF_CALL (Print_Error, (_c_5, (_c_36 + (_vs_t + _vt_p1 + _ve_name) () + _vs_type), _vt_p2), /*void*/);
              _ge_new__vars__0 = _ve_rest;
            }
          _block3: {}
            goto _exit2;
          }
      _continue2: {}
        }
      _exit2: {}
        goto _block2;
      }
    _block2__branch2: {}
      int _v_len9 = _ge_vars__0.get_len ();
      int _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len___dollar_tmp_m_240_m_10 = (_v_len9 - _v_len10);
      Expr _ve__dollar_tmp_m_240_m_10;
      _ve__dollar_tmp_m_240_m_10 = Expr (_ge_vars__0, 0, _v_len___dollar_tmp_m_240_m_10);
      _ge_vars__0 = (_ge_vars__0 + (_vs_type + _vt_p2 + _ve_name) ());
      _ge_new__vars__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Get_Cuts, (RF_ARG _vt_arg;;), (RF_RES _v_res1;;))
  Expr _ve_cuts;
  Expr _ve_Sentence;
  {
    {
      if (_vt_arg.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg (Expr (_vt_arg, 0));
      int _v_len1 = _v_deref__arg.get_len ();
      int _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__Sentence = (_v_len1 - _v_len2);
      if (!_c_13.term_eq (_v_deref__arg, 0))
      {
        goto _block1__branch1;
      }
      Expr _vt__dollar_tmp_m_254_m_12;
      _vt__dollar_tmp_m_254_m_12 = Expr (_v_deref__arg, (0 + 1), 1);
      _ve_Sentence = Expr (_v_deref__arg, (0 + 1 + 1), _v_len__Sentence);
      _ve_cuts = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vt_Block;
    _vt_Block = Expr (_vt_arg, 0, 1);
    _ve_cuts = empty;
    _ve_Sentence = _vt_Block;
  }
_block1: {}
  for ( ; ; )
  {
    {
      if (_ve_Sentence.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_cuts;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len3 = _ve_Sentence.get_len ();
    int _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__Snt = (_v_len3 - _v_len4);
    Expr _ve_Snt;
    _ve_Snt = Expr (_ve_Sentence, 0, _v_len__Snt);
    Expr _vt_Statement;
    _vt_Statement = Expr (_ve_Sentence, (0 + _v_len__Snt), 1);
    {
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block3__branch1;
        }
        Expr _v_deref__Statement (Expr (_vt_Statement, 0));
        if (_v_deref__Statement.get_len () != 2)
        {
          goto _block3__branch1;
        }
        if (!_c_24.term_eq (_v_deref__Statement, 0))
        {
          goto _block3__branch1;
        }
        Expr _vt__dollar_tmp_m_258_m_28;
        _vt__dollar_tmp_m_258_m_28 = Expr (_v_deref__Statement, (0 + 1), 1);
        {
          Expr _gt_auxcall1;
          if (!RF_CALL (::refal::Access::R, (_c_4, _ve_cuts), _gt_auxcall1))
          {
            goto _block4__branch1;
          }
          RF_CALL (Print_Error, (_c_5, _c_6, _gt_auxcall1), /*void*/);
          RF_RETFAIL;
        }
      _block4__branch1: {}
        _ve_cuts = empty;
        _ve_Sentence = _ve_Snt;
        goto _block3;
      }
    _block3__branch1: {}
      Expr _ge_cuts__5;
      {
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block5__branch1;
          }
          Expr _v_deref__Statement2 (Expr (_vt_Statement, 0));
          if (_v_deref__Statement2.get_len () != 2)
          {
            goto _block5__branch1;
          }
          if (!_c_25.term_eq (_v_deref__Statement2, 0))
          {
            goto _block5__branch1;
          }
          Expr _vt_Pragma;
          _vt_Pragma = Expr (_v_deref__Statement2, (0 + 1), 1);
          _ge_cuts__5 = (_ve_cuts + _vt_Pragma);
          goto _block5;
        }
      _block5__branch1: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block5__branch2;
          }
          Expr _v_deref__Statement3 (Expr (_vt_Statement, 0));
          if (_v_deref__Statement3.get_len () != 2)
          {
            goto _block5__branch2;
          }
          if (!_c_26.term_eq (_v_deref__Statement3, 0))
          {
            goto _block5__branch2;
          }
          Expr _vt__dollar_tmp_m_265_m_15;
          _vt__dollar_tmp_m_265_m_15 = Expr (_v_deref__Statement3, (0 + 1), 1);
          {
            {
              if (!RF_CALL (::refal::Access::Middle, (_c_4, _c_40, _ve_cuts), _ge_cuts__5))
              {
                goto _block6__branch1;
              }
              goto _block6;
            }
          _block6__branch1: {}
            _ge_cuts__5 = empty;
          }
        _block6: {}
          goto _block5;
        }
      _block5__branch2: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block5__branch3;
          }
          Expr _v_deref__Statement4 (Expr (_vt_Statement, 0));
          if (_v_deref__Statement4.get_len () != 2)
          {
            goto _block5__branch3;
          }
          if (!_c_15.term_eq (_v_deref__Statement4, 0))
          {
            goto _block5__branch3;
          }
          Expr _vt_Branch;
          _vt_Branch = Expr (_v_deref__Statement4, (0 + 1), 1);
          {
            {
              Expr _ge_auxcall2;
              if (!RF_CALL (Get_Cuts, _vt_Branch, _ge_auxcall2))
              {
                goto _block7__branch1;
              }
              Expr _gt_auxcall3;
              if (!RF_CALL (::refal::Access::R, (_c_4, _ge_auxcall2), _gt_auxcall3))
              {
                goto _block7__branch1;
              }
              RF_CALL (Print_Error, (_c_5, _c_6, _gt_auxcall3), /*void*/);
              goto _block7;
            }
          _block7__branch1: {}
          }
        _block7: {}
          _ge_cuts__5 = _ve_cuts;
          goto _block5;
        }
      _block5__branch3: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block5__branch4;
          }
          Expr _v_deref__Statement5 (Expr (_vt_Statement, 0));
          if (_v_deref__Statement5.get_len () != 2)
          {
            goto _block5__branch4;
          }
          if (!_c_16.term_eq (_v_deref__Statement5, 0))
          {
            goto _block5__branch4;
          }
          Expr _vt_Branch;
          _vt_Branch = Expr (_v_deref__Statement5, (0 + 1), 1);
          {
            {
              Expr _ge_auxcall4;
              if (!RF_CALL (Get_Cuts, _vt_Branch, _ge_auxcall4))
              {
                goto _block8__branch1;
              }
              Expr _gt_auxcall5;
              if (!RF_CALL (::refal::Access::R, (_c_4, _ge_auxcall4), _gt_auxcall5))
              {
                goto _block8__branch1;
              }
              RF_CALL (Print_Error, (_c_5, _c_6, _gt_auxcall5), /*void*/);
              goto _block8;
            }
          _block8__branch1: {}
          }
        _block8: {}
          _ge_cuts__5 = _ve_cuts;
          goto _block5;
        }
      _block5__branch4: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block5__branch5;
          }
          Expr _v_deref__Statement6 (Expr (_vt_Statement, 0));
          int _v_len5 = _v_deref__Statement6.get_len ();
          int _v_len6 = 2;
          if (_v_len5 < _v_len6)
          {
            goto _block5__branch5;
          }
          int _v_len__Branches = (_v_len5 - _v_len6);
          if (!_v_deref__Statement6.symbol_at (0))
          {
            goto _block5__branch5;
          }
          Expr _vs_block;
          _vs_block = Expr (_v_deref__Statement6, 0, 1);
          Expr _vt__dollar_tmp_m_272_m_17;
          _vt__dollar_tmp_m_272_m_17 = Expr (_v_deref__Statement6, (0 + 1), 1);
          Expr _ve_Branches;
          _ve_Branches = Expr (_v_deref__Statement6, (0 + 1 + 1), _v_len__Branches);
          {
            {
              if (!_vs_block.term_eq (_c_8, 0))
              {
                goto _block9__branch1;
              }
              goto _block9;
            }
          _block9__branch1: {}
            if (!_vs_block.term_eq (_c_9, 0))
            {
              goto _block5__branch5;
            }
          }
        _block9: {}
          Expr _ve_longest__cuts;
          for ( ; ; )
          {
            {
              if (_ve_Branches.get_len () != 0)
              {
                goto _iter2;
              }
              {
                {
                  Expr _gs_auxcall8;
                  RF_CALL (::refal::Access::Length, _ve_cuts, _gs_auxcall8);
                  Expr _gs_auxcall9;
                  RF_CALL (::refal::Access::Length, _ve_longest__cuts, _gs_auxcall9);
                  if (!RF_CALL (::refal::Compare::Gt, (_gs_auxcall8, _gs_auxcall9), /*void*/))
                  {
                    goto _block10__branch1;
                  }
                  _ge_cuts__5 = _ve_cuts;
                  goto _block10;
                }
              _block10__branch1: {}
                _ge_cuts__5 = _ve_longest__cuts;
              }
            _block10: {}
              goto _exit__iter2;
            }
          _iter2: {}
            int _v_len7 = _ve_Branches.get_len ();
            int _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__rest = (_v_len7 - _v_len8);
            Expr _vt_Branch;
            _vt_Branch = Expr (_ve_Branches, 0, 1);
            Expr _ve_rest;
            _ve_rest = Expr (_ve_Branches, (0 + 1), _v_len__rest);
            Expr _ve_branch__cuts;
            {
              {
                if (!RF_CALL (Get_Cuts, _vt_Branch, _ve_branch__cuts))
                {
                  goto _block12__branch1;
                }
                goto _block12;
              }
            _block12__branch1: {}
              _ve_branch__cuts = empty;
            }
          _block12: {}
            {
              {
                Expr _gs_auxcall6;
                RF_CALL (::refal::Access::Length, _ve_branch__cuts, _gs_auxcall6);
                Expr _gs_auxcall7;
                RF_CALL (::refal::Access::Length, _ve_longest__cuts, _gs_auxcall7);
                if (!RF_CALL (::refal::Compare::Gt, (_gs_auxcall6, _gs_auxcall7), /*void*/))
                {
                  goto _block13__branch1;
                }
                _ve_longest__cuts = _ve_branch__cuts;
                _ve_Branches = _ve_rest;
                goto _block13;
              }
            _block13__branch1: {}
              _ve_Branches = _ve_rest;
            }
          _block13: {}
          }
        _exit__iter2: {}
          goto _block5;
        }
      _block5__branch5: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block5__branch6;
          }
          Expr _v_deref__Statement7 (Expr (_vt_Statement, 0));
          if (_v_deref__Statement7.get_len () != 3)
          {
            goto _block5__branch6;
          }
          if (!_c_17.term_eq (_v_deref__Statement7, 0))
          {
            goto _block5__branch6;
          }
          Expr _vt_IterBody;
          _vt_IterBody = Expr (_v_deref__Statement7, (0 + 1), 1);
          Expr _vt_IterVars;
          _vt_IterVars = Expr (_v_deref__Statement7, (0 + 1 + 1), 1);
          Expr _ve_body__cuts;
          if (!RF_CALL (Get_Cuts, _vt_IterBody, _ve_body__cuts))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          {
            {
              Expr _gs_auxcall10;
              RF_CALL (::refal::Access::Length, _ve_cuts, _gs_auxcall10);
              Expr _gs_auxcall11;
              RF_CALL (::refal::Access::Length, _ve_body__cuts, _gs_auxcall11);
              if (!RF_CALL (::refal::Compare::Gt, (_gs_auxcall10, _gs_auxcall11), /*void*/))
              {
                goto _block14__branch1;
              }
              _ge_cuts__5 = _ve_cuts;
              goto _block14;
            }
          _block14__branch1: {}
            _ge_cuts__5 = _ve_body__cuts;
          }
        _block14: {}
          goto _block5;
        }
      _block5__branch6: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block5__branch7;
          }
          Expr _v_deref__Statement8 (Expr (_vt_Statement, 0));
          if (_v_deref__Statement8.get_len () != 3)
          {
            goto _block5__branch7;
          }
          if (!_c_18.term_eq (_v_deref__Statement8, 0))
          {
            goto _block5__branch7;
          }
          Expr _vt_TryBranch;
          _vt_TryBranch = Expr (_v_deref__Statement8, (0 + 1), 1);
          Expr _vt_CatchBranch;
          _vt_CatchBranch = Expr (_v_deref__Statement8, (0 + 1 + 1), 1);
          {
            {
              Expr _ge_auxcall12;
              if (!RF_CALL (Get_Cuts, _vt_TryBranch, _ge_auxcall12))
              {
                goto _block15__branch1;
              }
              Expr _gt_auxcall13;
              if (!RF_CALL (::refal::Access::R, (_c_4, _ge_auxcall12), _gt_auxcall13))
              {
                goto _block15__branch1;
              }
              RF_CALL (Print_Error, (_c_5, _c_6, _gt_auxcall13), /*void*/);
              goto _block15;
            }
          _block15__branch1: {}
          }
        _block15: {}
          if (!RF_CALL (Get_Cuts, _vt_CatchBranch, _ge_cuts__5))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          goto _block5;
        }
      _block5__branch7: {}
        Expr _vt_any__other;
        _vt_any__other = Expr (_vt_Statement, 0, 1);
        _ge_cuts__5 = _ve_cuts;
      }
    _block5: {}
      _ve_cuts = _ge_cuts__5;
      _ve_Sentence = _ve_Snt;
    }
  _block3: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Print_Error, (RF_ARG _vs_WE, _ve_Descrip, _vt_Pragma;;), RF_VOID)
  Expr _vs_n;
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, org::refal::plus::compiler::rfp_err::Error_Counter, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_n__2;
      _gs_n__2 = Expr (_v_Get1, 0, 1);
      _vs_n = _gs_n__2;
      goto _block1;
    }
  _block1__branch1: {}
    _vs_n = _c_4;
  }
_block1: {}
  Expr _gs_auxcall1;
  RF_CALL (::refal::Arithm::Add, (_vs_n, _c_40), _gs_auxcall1);
  RF_CALL (::refal::Box::Store, (org::refal::plus::compiler::rfp_err::Error_Counter, _gs_auxcall1), /*void*/);
  RF_CALL (Print_Pragma, (::refal::StdIO::StdErr, _vt_Pragma), /*void*/);
  RF_CALL (::refal::StdIO::PrintCh, (::refal::StdIO::StdErr, (_c_41 + _vs_WE + _c_41)), /*void*/);
  {
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch1;
      }
      Expr _v_compose1 ((_vs_WE + _ve_Descrip));
      if (!_c_42.eq (_v_compose1, 0))
      {
        goto _block2__branch1;
      }
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, _c_43), /*void*/);
      goto _block2;
    }
  _block2__branch1: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch2;
      }
      Expr _v_compose2 ((_vs_WE + _ve_Descrip));
      if (!_c_44.eq (_v_compose2, 0))
      {
        goto _block2__branch2;
      }
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, _c_45), /*void*/);
      goto _block2;
    }
  _block2__branch2: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch3;
      }
      Expr _v_compose3 ((_vs_WE + _ve_Descrip));
      if (!_c_46.eq (_v_compose3, 0))
      {
        goto _block2__branch3;
      }
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, _c_47), /*void*/);
      goto _block2;
    }
  _block2__branch3: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 2)
      {
        goto _block2__branch4;
      }
      Expr _v_compose4 ((_vs_WE + _ve_Descrip));
      if (!_c_48.eq (_v_compose4, 0))
      {
        goto _block2__branch4;
      }
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, _c_49), /*void*/);
      goto _block2;
    }
  _block2__branch4: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 3)
      {
        goto _block2__branch5;
      }
      Expr _v_compose5 ((_vs_WE + _ve_Descrip));
      if (!_c_50.eq (_v_compose5, 0))
      {
        goto _block2__branch5;
      }
      Expr _vt_var;
      _vt_var = Expr (_v_compose5, (0 + 1 + 1), 1);
      Expr _ge_auxcall2;
      RF_CALL (AS_To_Ref, _vt_var, _ge_auxcall2);
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, (_c_52 + _ge_auxcall2 + _c_51)), /*void*/);
      goto _block2;
    }
  _block2__branch5: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 3)
      {
        goto _block2__branch6;
      }
      Expr _v_compose6 ((_vs_WE + _ve_Descrip));
      if (!_c_53.eq (_v_compose6, 0))
      {
        goto _block2__branch6;
      }
      Expr _vt_var;
      _vt_var = Expr (_v_compose6, (0 + 1 + 1), 1);
      Expr _ge_auxcall3;
      RF_CALL (AS_To_Ref, _vt_var, _ge_auxcall3);
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, (_c_55 + _ge_auxcall3 + _c_54)), /*void*/);
      goto _block2;
    }
  _block2__branch6: {}
    {
      if ((_ve_Descrip.get_len () + 1) != 4)
      {
        goto _block2__branch7;
      }
      Expr _v_compose7 ((_vs_WE + _ve_Descrip));
      if (!_c_56.eq (_v_compose7, 0))
      {
        goto _block2__branch7;
      }
      if (!_v_compose7.symbol_at ((0 + 1 + 1 + 1)))
      {
        goto _block2__branch7;
      }
      Expr _vt_var;
      _vt_var = Expr (_v_compose7, (0 + 1 + 1), 1);
      Expr _vs_type;
      _vs_type = Expr (_v_compose7, (0 + 1 + 1 + 1), 1);
      Expr _ge_auxcall4;
      RF_CALL (AS_To_Ref, _vs_type, _ge_auxcall4);
      Expr _ge_auxcall5;
      RF_CALL (AS_To_Ref, _vt_var, _ge_auxcall5);
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, (_c_59 + _ge_auxcall4 + _c_58 + _ge_auxcall5 + _c_57)), /*void*/);
      goto _block2;
    }
  _block2__branch7: {}
    if ((_ve_Descrip.get_len () + 1) != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_compose8 ((_vs_WE + _ve_Descrip));
    if (!_c_60.eq (_v_compose8, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    RF_TAILCALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, _c_61), /*void*/);
  }
_block2: {}
RF_END

RF_FUNC (Print_Pragma, (RF_ARG _gs_arg1, _gt_arg2;;), RF_VOID)
  Expr _v_compose1 ((_gs_arg1 + _gt_arg2));
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (Expr (_v_compose1, (0 + 1)));
  int _v_len1 = _v_deref__compose1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__pragmas = (_v_len1 - _v_len2);
  if (!_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_c_62.term_eq (_v_deref__compose1, 0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_channel;
  _vs_channel = Expr (_v_compose1, 0, 1);
  Expr _ve_pragmas;
  _ve_pragmas = Expr (_v_deref__compose1, (0 + 1), _v_len__pragmas);
  {
    if (_v_len__pragmas < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_pragmas, 0, _ve__dollar_tmp_m_341_m_6, _v_lsplit__pragmas);
    for ( ; ; RF_iter(_ve_pragmas)++)
    {
      {
        if (!RF_iter(_ve_pragmas))
        {
          goto _block1__branch1;
        }
        int _v_len3 = _v_lsplit__pragmas.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_341_m_27 = (_v_len3 - _v_len4);
        if (_v_lsplit__pragmas.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__pragmas (Expr (_v_lsplit__pragmas, 0));
        int _v_len5 = _v_deref__lsplit__pragmas.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _continue1;
        }
        int _v_len__file__name = (_v_len5 - _v_len6);
        if (!_c_63.term_eq (_v_deref__lsplit__pragmas, 0))
        {
          goto _continue1;
        }
        Expr _ve__dollar_tmp_m_341_m_27;
        _ve__dollar_tmp_m_341_m_27 = Expr (_v_lsplit__pragmas, (0 + 1), _v_len___dollar_tmp_m_341_m_27);
        Expr _ve_file__name;
        _ve_file__name = Expr (_v_deref__lsplit__pragmas, (0 + 1), _v_len__file__name);
        RF_CALL (::refal::StdIO::PrintCh, (_vs_channel, _ve_file__name), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
  {
    if (_v_len__pragmas < 1)
    {
      goto _block1__branch2;
    }
    RF_lsplit (_ve_pragmas, 0, _ve__dollar_tmp_m_342_m_6, _v_lsplit__pragmas2);
    for ( ; ; RF_iter(_ve_pragmas)++)
    {
      {
        if (!RF_iter(_ve_pragmas))
        {
          goto _block1__branch2;
        }
        int _v_len7 = _v_lsplit__pragmas2.get_len ();
        int _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          goto _block1__branch2;
        }
        int _v_len___dollar_tmp_m_342_m_28 = (_v_len7 - _v_len8);
        if (_v_lsplit__pragmas2.symbol_at (0))
        {
          goto _continue2;
        }
        Expr _v_deref__lsplit__pragmas2 (Expr (_v_lsplit__pragmas2, 0));
        if (_v_deref__lsplit__pragmas2.get_len () != 3)
        {
          goto _continue2;
        }
        if (!_c_64.term_eq (_v_deref__lsplit__pragmas2, 0))
        {
          goto _continue2;
        }
        if (!_v_deref__lsplit__pragmas2.symbol_at ((0 + 1)))
        {
          goto _continue2;
        }
        if (!_v_deref__lsplit__pragmas2.symbol_at ((0 + 1 + 1)))
        {
          goto _continue2;
        }
        Expr _ve__dollar_tmp_m_342_m_28;
        _ve__dollar_tmp_m_342_m_28 = Expr (_v_lsplit__pragmas2, (0 + 1), _v_len___dollar_tmp_m_342_m_28);
        Expr _vs_line;
        _vs_line = Expr (_v_deref__lsplit__pragmas2, (0 + 1), 1);
        Expr _vs_col;
        _vs_col = Expr (_v_deref__lsplit__pragmas2, (0 + 1 + 1), 1);
        RF_CALL (::refal::StdIO::PrintCh, (_vs_channel, (_vs_line + _c_65 + _vs_col) ()), /*void*/);
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block1__branch2: {}
  int _v_len9 = _v_len__pragmas;
  int _v_len10 = 0;
  if (_v_len9 < _v_len10)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len___dollar_tmp_m_343_m_6 = (_v_len9 - _v_len10);
  Expr _ve__dollar_tmp_m_343_m_6;
  _ve__dollar_tmp_m_343_m_6 = Expr (_ve_pragmas, 0, _v_len___dollar_tmp_m_343_m_6);
  RF_TAILCALL (::refal::StdIO::PrintCh, (_vs_channel, _c_66), /*void*/);
RF_END

RF_FUNC (AS_To_Ref, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_c_33.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_67;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (!_c_34.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _c_68;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch3;
      }
      if (!_c_35.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _c_69;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch4;
      }
      if (!_c_32.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch4;
      }
      _v_res1 = _c_70;
      goto _block1;
    }
  _block1__branch4: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
    if (_v_deref__arg1.get_len () != 3)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_deref__arg1.symbol_at ((0 + 1 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__deref__arg1 (Expr (_v_deref__arg1, (0 + 1 + 1)));
    int _v_len1 = _v_deref__deref__arg1.get_len ();
    int _v_len2 = 0;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__name = (_v_len1 - _v_len2);
    if (!_v_deref__arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_tag;
    _vs_tag = Expr (_v_deref__arg1, 0, 1);
    Expr _vt__dollar_tmp_m_351_m_11;
    _vt__dollar_tmp_m_351_m_11 = Expr (_v_deref__arg1, (0 + 1), 1);
    Expr _ve_name;
    _ve_name = Expr (_v_deref__deref__arg1, 0, _v_len__name);
    Expr _ge_auxcall1;
    RF_CALL (AS_To_Ref, _vs_tag, _ge_auxcall1);
    Expr _v_ToChars1;
    RF_CALL (::refal::Convert::ToChars, _ve_name, _v_ToChars1);
    _v_res1 = (_ge_auxcall1 + _c_71 + _v_ToChars1);
  }
_block1: {}
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_check {

static void init_ () {
  _c_0 = Expr::create<rftype::Word>("ITEMS");
  _c_1 = Expr::create<rftype::Word>("FUNC");
  _c_2 = Expr::create<rftype::Word>("FUNC?");
  _c_3 = Expr::create<rftype::Word>("TFUNC");
  _c_4 = Expr::create<rftype::Integer>("0");
  _c_42 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Re");
  _c_5 = Expr (_c_42, 0, 1);
  _c_60 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Cut");
  _c_6 = Expr (_c_60, 1, 1);
  _c_7 = Expr::create<rftype::Word>("RESULT");
  _c_8 = Expr::create<rftype::Word>("ALT");
  _c_9 = Expr::create<rftype::Word>("ALT?");
  _c_10 = Expr (_c_42, 1, 1);
  _c_11 = Expr::create<rftype::Word>("FORMAT");
  _c_12 = (Expr::create<rftype::Word>("Comp") + Expr::create<rftype::Word>("Branch")) ();
  _c_13 = Expr::create<rftype::Word>("BRANCH");
  _c_32 = Expr::create<rftype::Word>("EVAR");
  _c_14 = (_c_32) ();
  _c_15 = Expr::create<rftype::Word>("NOT");
  _c_16 = Expr::create<rftype::Word>("ERROR");
  _c_17 = Expr::create<rftype::Word>("ITER");
  _c_18 = Expr::create<rftype::Word>("TRY");
  _c_19 = Expr::create<rftype::Word>("LEFT");
  _c_20 = Expr::create<rftype::Word>("RIGHT");
  _c_46 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Pattern");
  _c_21 = Expr (_c_46, 1, 1);
  _c_22 = Expr::create<rftype::Word>("NOFAIL");
  _c_23 = Expr::create<rftype::Word>("FAIL");
  _c_24 = Expr::create<rftype::Word>("CUTALL");
  _c_25 = Expr::create<rftype::Word>("CUT");
  _c_26 = Expr::create<rftype::Word>("STAKE");
  _c_27 = Expr::create<rftype::Word>("NATIVE");
  _c_28 = Expr::create<rftype::Word>("CALL");
  _c_29 = Expr::create<rftype::Integer>("2");
  _c_44 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Call");
  _c_30 = Expr (_c_44, 1, 1);
  _c_31 = Expr::create<rftype::Word>("PAREN");
  _c_33 = Expr::create<rftype::Word>("SVAR");
  _c_34 = Expr::create<rftype::Word>("TVAR");
  _c_35 = Expr::create<rftype::Word>("VVAR");
  _c_56 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Var-Type");
  _c_36 = Expr (_c_56, 1, 1);
  _c_50 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Var-Re");
  _c_37 = Expr (_c_50, 1, 1);
  _c_53 = Expr::create<rftype::Word>("Error!") + Expr::create<rftype::Word>("Var-Hard");
  _c_38 = Expr (_c_53, 1, 1);
  _c_39 = Expr::create<rftype::Word>("Format");
  _c_40 = Expr::create<rftype::Integer>("1");
  _c_41 = Expr::create<rftype::Word>(" ");
  _c_43 = Expr::create<rftype::Word>("Wrong format of result expression");
  _c_45 = Expr::create<rftype::Word>("Wrong argument format in function call");
  _c_47 = Expr::create<rftype::Word>("Wrong format of pattern expression");
  _c_48 = Expr::create<rftype::Word>("Warning!") + Expr::create<rftype::Word>("Pattern");
  _c_49 = Expr::create<rftype::Word>("Clash can't be solved");
  _c_51 = Expr::create<rftype::Word>("' in result expression");
  _c_52 = Expr::create<rftype::Word>("Unknown variable '");
  _c_54 = Expr::create<rftype::Word>("' in hard expression");
  _c_55 = Expr::create<rftype::Word>("Repeated occurence of the variable '");
  _c_57 = Expr::create<rftype::Word>("'");
  _c_58 = Expr::create<rftype::Word>("' of the variable '");
  _c_59 = Expr::create<rftype::Word>("Incorrect type '");
  _c_61 = Expr::create<rftype::Word>("'\\!' without corresponding '\\?'");
  _c_62 = Expr::create<rftype::Word>("PRAGMA");
  _c_63 = Expr::create<rftype::Word>("FILE");
  _c_64 = Expr::create<rftype::Word>("LINE");
  _c_65 = Expr::create<rftype::Word>(", ");
  _c_66 = Expr::create<rftype::Word>(":");
  _c_67 = rftype::Char::create_expr (L"s");
  _c_68 = rftype::Char::create_expr (L"t");
  _c_69 = rftype::Char::create_expr (L"v");
  _c_70 = rftype::Char::create_expr (L"e");
  _c_71 = rftype::Char::create_expr (L".");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
