
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail {

RF_DECL (ASAIL_DIV);

RF_DECL (ASAIL_ADD);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_clashes {

RF_DECL (Add_Clash_To_Var);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail {

RF_DECL (ASAIL_SUB);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_clashes {

RF_DECL (Compose_Source);

RF_DECL (Compose_Clashes);

RF_DECL (Compute_Max);

RF_DECL (Compute_Bounds);

RF_DECL (Classify_Lengths);

RF_DECL (Compute_Min);

RF_DECL (Define_Vars);

RF_DECL (Compute_Min_0);

RF_DECL (Find_SFD);

RF_DECL (Get_Cycle);

RF_DECL (Get_Known_Length);

RF_DECL (Free_Index);

RF_DECL (Entries);

RF_DECL (Init_Clashes);

RF_DECL (Get_Var_Min_0);

RF_DECL (Not_Idx);

RF_DECL (L_0);

RF_DECL (Get_Var_Max_0);

RF_DECL (Compute_Max_0);

RF_DECL (Prepare_Source);

RF_DECL (R_0);

RF_DECL (Ref_Len);

RF_DECL (UHP_Clash);

RF_DECL (UHP);

RF_DECL (Reclassify_Clash);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_const {

RF_DECL (Get_Static);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Gener_Vars);

RF_DECL (Gener_Len_Var);

RF_DECL (Get_Var_Max);

RF_DECL (IsVar);

RF_DECL (Get_Var_Min);

RF_DECL (Get_Var);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_clashes {

RF_DECL (Update_Hard_Parts);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Set_Var_MaxBound);

RF_DECL (Vars);

}

}

}

}

}

namespace refal {

namespace Access {

RF_DECL (L);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Vars_Print);

RF_DECL (Vars_Decl);

RF_DECL (Set_Var_MinBound);

}

}

}

}

}

namespace refal {

namespace Access {

RF_DECL (Middle);

}

}

namespace refal {

namespace Apply {

RF_DECL (Apply);

}

}

namespace refal {

namespace Access {

RF_DECL (R);

}

}

namespace refal {

namespace Arithm {

RF_DECL (Mult);

RF_DECL (Add);

}

}

namespace refal {

namespace Access {

RF_DECL (Length);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Set_Var);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_clashes {

RF_DECL (Not_Instantiated_Var);

}

}

}

}

}

namespace refal {

namespace Box {

RF_DECL (Put);

RF_DECL (Get);

}

}

namespace refal {

namespace Compare {

RF_DECL (Lt);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace refal {

namespace List {

RF_DECL (Filter);

RF_DECL (Map);

}

}

namespace refal {

namespace Compare {

RF_DECL (Ne);

}

}

namespace refal {

namespace List {

RF_DECL (Sub);

}

}

namespace refal {

namespace Table {

RF_DECL (ClearTable);

RF_DECL (Unbind);

RF_DECL (Lookup);

RF_DECL (Bind);

}

}

namespace refal {

namespace List {

RF_DECL (Nub);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

extern Expr Const;

}

}

}

}

}

namespace refal {

namespace Arithm {

RF_DECL (Sub);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_clashes {

Expr Known_Lengths;

Expr Compute_Length;

Expr Unknown_Lengths;

Expr Checked_Lengths;

Expr Eqs;

static Expr Clashes;

static Expr Hard_Parts;

static Expr Parenth;

static Expr Unready_Source;

static Expr FreeIdx;

static Expr Const_Len;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_43;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_30;

static Expr _c_29;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

RF_FUNC (Entries, (RF_ARG _ve_expr, _ve_source;;), (RF_RES _v_res1, _v_res2;;))
  Expr _vs_num (_c_0);
  Expr _ge_source__0 (_ve_source);
  Expr _ve_res;
  for ( ; ; )
  {
    {
      if (_ge_source__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _vs_num;
      _v_res2 = _ve_res;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        if (_ge_source__0.get_len () < _ve_expr.get_len ())
        {
          goto _block1__branch1;
        }
        RF_lsplit (_ge_source__0, 0, _ve_1, _v_lsplit__source__0);
        for ( ; ; RF_iter(_ge_source__0)++)
        {
          {
            if (!RF_iter(_ge_source__0))
            {
              goto _block1__branch1;
            }
            int _v_len1 = _v_lsplit__source__0.get_len ();
            int _v_len2 = _ve_expr.get_len ();
            if (_v_len1 < _v_len2)
            {
              goto _block1__branch1;
            }
            int _v_len__2 = (_v_len1 - _v_len2);
            if (!_ve_expr.eq (_v_lsplit__source__0, 0))
            {
              goto _continue1;
            }
            Expr _ve_2;
            _ve_2 = Expr (_v_lsplit__source__0, (0 + _ve_expr.get_len ()), _v_len__2);
            Expr _gs_auxcall1;
            RF_CALL (::refal::Arithm::Add, (_vs_num, _c_1), _gs_auxcall1);
            _vs_num = _gs_auxcall1;
            _ge_source__0 = _ve_2;
            _ve_res = (_ve_res + _ve_1);
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block1;
      }
    _block1__branch1: {}
      _ve_res = (_ve_res + _ge_source__0);
      _ge_source__0 = empty;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Add_Clash_To_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_clash;
  _vt_clash = Expr (_ge_arg1, 0, 1);
  Expr _vt_var;
  _vt_var = Expr (_ge_arg1, (0 + 1), 1);
  Expr _ge_auxcall1;
  if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_2, _vt_var), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_CALL (org::refal::plus::compiler::rfp_vars::Set_Var, ((_c_2 + _ge_auxcall1 + _vt_clash) (), _vt_var), /*void*/);
  _v_res1 = empty;
RF_END

RF_FUNC (Classify_Lengths, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  if (_gt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_gt_arg1, 0));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 3;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len___dollar_tmp_m_79_m_46 = (_v_len1 - _v_len2);
  if (_v_deref__arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_deref__arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__deref__arg1 (Expr (_v_deref__arg1, (0 + 1)));
  Expr _v_deref__deref__arg12 (Expr (_v_deref__arg1, (0 + 1 + 1)));
  int _v_len3 = _v_deref__deref__arg12.get_len ();
  int _v_len4 = 1;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__Pe = (_v_len3 - _v_len4);
  int _v_len5 = _v_deref__deref__arg1.get_len ();
  int _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__Re = (_v_len5 - _v_len6);
  if (!_v_deref__arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__deref__arg12.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx;
  _vs_idx = Expr (_v_deref__arg1, 0, 1);
  Expr _ve__dollar_tmp_m_79_m_46;
  _ve__dollar_tmp_m_79_m_46 = Expr (_v_deref__arg1, (0 + 1 + 1 + 1), _v_len___dollar_tmp_m_79_m_46);
  Expr _ve_Re;
  _ve_Re = Expr (_v_deref__deref__arg1, 0, _v_len__Re);
  Expr _vs_dir;
  _vs_dir = Expr (_v_deref__deref__arg12, 0, 1);
  Expr _ve_Pe;
  _ve_Pe = Expr (_v_deref__deref__arg12, (0 + 1), _v_len__Pe);
  Expr _ve_len__Re;
  Expr _ve_vars__Re;
  RF_CALL (Get_Known_Length, _ve_Re, (_ve_len__Re, _ve_vars__Re));
  Expr _ve_len__Pe;
  Expr _ve_vars__Pe;
  RF_CALL (Get_Known_Length, _ve_Pe, (_ve_len__Pe, _ve_vars__Pe));
  {
    {
      if (_ve_vars__Pe.get_len () != 0)
      {
        goto _block1__branch1;
      }
      if (_ve_vars__Re.get_len () != 0)
      {
        goto _block1__branch1;
      }
      RF_CALL (::refal::Table::Bind, (Known_Lengths, _vs_idx, (_ve_len__Re () + _ve_len__Pe ())), /*void*/);
      _v_res1 = Known_Lengths;
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _gs_auxcall1;
      RF_CALL (::refal::Access::Length, _ve_vars__Re, _gs_auxcall1);
      Expr _gs_auxcall2;
      RF_CALL (::refal::Access::Length, _ve_vars__Pe, _gs_auxcall2);
      Expr _vs_diff;
      RF_CALL (::refal::Arithm::Sub, (_gs_auxcall1, _gs_auxcall2), _vs_diff);
      if (!RF_CALL (::refal::Compare::Ne, (_vs_diff, _c_0), /*void*/))
      {
        goto _block1__branch2;
      }
      Expr _v_Nub1;
      RF_CALL (::refal::List::Nub, (_ve_vars__Re + _ve_vars__Pe), _v_Nub1);
      if (_v_Nub1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_var;
      _vt_var = Expr (_v_Nub1, 0, 1);
      Expr _vs_mult;
      Expr _ve_minuend;
      Expr _ve_subtrahend;
      {
        {
          if (!RF_CALL (::refal::Compare::Lt, (_vs_diff, _c_0), /*void*/))
          {
            goto _block2__branch1;
          }
          Expr _gs_auxcall3;
          RF_CALL (::refal::Arithm::Mult, (_vs_diff, _c_3), _gs_auxcall3);
          _vs_mult = _gs_auxcall3;
          _ve_minuend = _ve_len__Re;
          _ve_subtrahend = _ve_len__Pe;
          goto _block2;
        }
      _block2__branch1: {}
        _vs_mult = _vs_diff;
        _ve_minuend = _ve_len__Pe;
        _ve_subtrahend = _ve_len__Re;
      }
    _block2: {}
      Expr _v_Map1;
      if (!RF_CALL (::refal::List::Map, (_c_4, _vs_idx, (_ve_vars__Re + _ve_vars__Pe)), _v_Map1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len7 = _v_Map1.get_len ();
      int _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len___dollar_tmp_m_104_m_62 = (_v_len7 - _v_len8);
      Expr _ve__dollar_tmp_m_104_m_62;
      _ve__dollar_tmp_m_104_m_62 = Expr (_v_Map1, 0, _v_len___dollar_tmp_m_104_m_62);
      RF_CALL (::refal::Table::Bind, (Compute_Length, _vs_idx, (_vt_var + _vs_mult + _ve_minuend () + _ve_subtrahend ())), /*void*/);
      _v_res1 = Compute_Length;
      goto _block1;
    }
  _block1__branch2: {}
    RF_CALL (Compute_Bounds, (_vs_idx, _ve_len__Re, _ve_vars__Re, _ve_len__Pe, _ve_vars__Pe), /*void*/);
    Expr _v_Map2;
    if (!RF_CALL (::refal::List::Map, (_c_4, _vs_idx, (_ve_vars__Re + _ve_vars__Pe)), _v_Map2))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len9 = _v_Map2.get_len ();
    int _v_len10 = 0;
    if (_v_len9 < _v_len10)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len___dollar_tmp_m_115_m_62 = (_v_len9 - _v_len10);
    Expr _ve__dollar_tmp_m_115_m_62;
    _ve__dollar_tmp_m_115_m_62 = Expr (_v_Map2, 0, _v_len___dollar_tmp_m_115_m_62);
    RF_CALL (::refal::Table::Bind, (Unknown_Lengths, _vs_idx, (_ve_len__Re () + _ve_len__Pe () + _ve_vars__Re () + _ve_vars__Pe ())), /*void*/);
    _v_res1 = Unknown_Lengths;
  }
_block1: {}
RF_END

RF_FUNC (Compute_Bounds, (RF_ARG _vs_idx, _ve_len__Re, _ve_vars__Re, _ve_len__Pe, _ve_vars__Pe;;), RF_VOID)
  Expr _ge_vars__Re__0 (_ve_vars__Re);
  Expr _ge_vars__Pe__0 (_ve_vars__Pe);
  Expr _ve_stop;
  for ( ; ; )
  {
    {
      if (_ve_stop.get_len () != 1)
      {
        goto _iter1;
      }
      if (!_c_5.term_eq (_ve_stop, 0))
      {
        goto _iter1;
      }
      Expr _v_Map1;
      if (!RF_CALL (::refal::List::Map, (_c_6, (_vs_idx + _ve_len__Pe () + _ge_vars__Pe__0 () + _ve_len__Re () + _ge_vars__Re__0 ()), _ge_vars__Pe__0), _v_Map1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len1 = _v_Map1.get_len ();
      int _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len___dollar_tmp_m_127_m_89 = (_v_len1 - _v_len2);
      Expr _ve__dollar_tmp_m_127_m_89;
      _ve__dollar_tmp_m_127_m_89 = Expr (_v_Map1, 0, _v_len___dollar_tmp_m_127_m_89);
      Expr _v_Map2;
      if (!RF_CALL (::refal::List::Map, (_c_7, (_vs_idx + _ve_len__Re () + _ge_vars__Re__0 () + _ve_len__Pe () + _ge_vars__Pe__0 ()), _ge_vars__Re__0), _v_Map2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len3 = _v_Map2.get_len ();
      int _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len___dollar_tmp_m_128_m_89 = (_v_len3 - _v_len4);
      Expr _ve__dollar_tmp_m_128_m_89;
      _ve__dollar_tmp_m_128_m_89 = Expr (_v_Map2, 0, _v_len___dollar_tmp_m_128_m_89);
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        if (_ge_vars__Re__0.get_len () < 1)
        {
          goto _block1__branch1;
        }
        RF_lsplit (_ge_vars__Re__0, 0, _ve_1, _v_lsplit__vars__Re__0);
        for ( ; ; RF_iter(_ge_vars__Re__0)++)
        {
          {
            if (!RF_iter(_ge_vars__Re__0))
            {
              goto _block1__branch1;
            }
            int _v_len5 = _v_lsplit__vars__Re__0.get_len ();
            int _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              goto _block1__branch1;
            }
            int _v_len__2 = (_v_len5 - _v_len6);
            Expr _vt_var;
            _vt_var = Expr (_v_lsplit__vars__Re__0, 0, 1);
            Expr _ve_2;
            _ve_2 = Expr (_v_lsplit__vars__Re__0, (0 + 1), _v_len__2);
            if (_ge_vars__Pe__0.get_len () < 1)
            {
              goto _continue1;
            }
            RF_lsplit (_ge_vars__Pe__0, 0, _ve_3, _v_lsplit__vars__Pe__0);
            for ( ; ; RF_iter(_ge_vars__Pe__0)++)
            {
              {
                if (!RF_iter(_ge_vars__Pe__0))
                {
                  goto _continue1;
                }
                int _v_len7 = _v_lsplit__vars__Pe__0.get_len ();
                int _v_len8 = 1;
                if (_v_len7 < _v_len8)
                {
                  goto _continue1;
                }
                int _v_len__4 = (_v_len7 - _v_len8);
                if (!_vt_var.term_eq (_v_lsplit__vars__Pe__0, 0))
                {
                  goto _continue2;
                }
                Expr _ve_4;
                _ve_4 = Expr (_v_lsplit__vars__Pe__0, (0 + 1), _v_len__4);
                _ge_vars__Re__0 = (_ve_1 + _ve_2);
                _ge_vars__Pe__0 = (_ve_3 + _ve_4);
                _ve_stop = empty;
                goto _exit2;
              }
          _continue2: {}
            }
          _exit2: {}
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block1;
      }
    _block1__branch1: {}
      _ve_stop = _c_5;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Compute_Max, (RF_ARG _vs_idx, _ve_len1, _ve_vars1, _ve_len2, _ve_vars2, _vt_var1;;), RF_VOID)
  Expr _vs_n;
  Expr _ve_vars__left;
  RF_CALL (Entries, (_vt_var1, _ve_vars1), (_vs_n, _ve_vars__left));
  Expr _ge_auxcall1;
  if (!RF_CALL (::refal::List::Map, (_c_8, empty, _ve_vars2), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ge_auxcall2;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_ADD, (_ve_len2 + _ge_auxcall1), _ge_auxcall2);
  Expr _ge_auxcall3;
  if (!RF_CALL (::refal::List::Map, (_c_9, empty, _ve_vars__left), _ge_auxcall3))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ge_auxcall4;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_ADD, (_ve_len1 + _ge_auxcall3), _ge_auxcall4);
  Expr _ge_auxcall5;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_SUB, (_ge_auxcall2 + _ge_auxcall4), _ge_auxcall5);
  Expr _ge_auxcall6;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_DIV, (_ge_auxcall5 + _vs_n), _ge_auxcall6);
  RF_TAILCALL (org::refal::plus::compiler::rfp_vars::Set_Var_MaxBound, (_vt_var1, _vs_idx, _ge_auxcall6), /*void*/);
RF_END

RF_FUNC (Compute_Min, (RF_ARG _vs_idx, _ve_len1, _ve_vars1, _ve_len2, _ve_vars2, _vt_var1;;), RF_VOID)
  Expr _vs_n;
  Expr _ve_vars__left;
  RF_CALL (Entries, (_vt_var1, _ve_vars1), (_vs_n, _ve_vars__left));
  Expr _ge_auxcall1;
  if (!RF_CALL (::refal::List::Map, (_c_9, empty, _ve_vars2), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ge_auxcall2;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_ADD, (_ve_len2 + _ge_auxcall1), _ge_auxcall2);
  Expr _ge_auxcall3;
  if (!RF_CALL (::refal::List::Map, (_c_8, empty, _ve_vars__left), _ge_auxcall3))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ge_auxcall4;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_ADD, (_ve_len1 + _ge_auxcall3), _ge_auxcall4);
  Expr _ge_auxcall5;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_SUB, (_ge_auxcall2 + _ge_auxcall4), _ge_auxcall5);
  Expr _ge_auxcall6;
  RF_CALL (org::refal::plus::compiler::rfp_asail::ASAIL_DIV, (_ge_auxcall5 + _vs_n), _ge_auxcall6);
  RF_TAILCALL (org::refal::plus::compiler::rfp_vars::Set_Var_MinBound, (_vt_var1, _vs_idx, _ge_auxcall6), /*void*/);
RF_END

RF_FUNC (Reclassify_Clash, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx;
  _vs_idx = Expr (_ge_arg1, 0, 1);
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, Clashes, _v_Get1);
      if (_v_Get1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_Get1, 0, _ve_1, _v_lsplit__Get1);
      for ( ; ; RF_iter(_v_Get1)++)
      {
        {
          if (!RF_iter(_v_Get1))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__Get1.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__2 = (_v_len1 - _v_len2);
          if (_v_lsplit__Get1.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
          int _v_len3 = _v_deref__lsplit__Get1.get_len ();
          int _v_len4 = 3;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          int _v_len__boxes = (_v_len3 - _v_len4);
          if (_v_deref__lsplit__Get1.symbol_at ((0 + 1)))
          {
            goto _continue1;
          }
          if (_v_deref__lsplit__Get1.symbol_at ((0 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _v_deref__deref__lsplit__Get1 (Expr (_v_deref__lsplit__Get1, (0 + 1)));
          Expr _v_deref__deref__lsplit__Get12 (Expr (_v_deref__lsplit__Get1, (0 + 1 + 1)));
          int _v_len5 = _v_deref__deref__lsplit__Get12.get_len ();
          int _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _continue1;
          }
          int _v_len__Pe = (_v_len5 - _v_len6);
          int _v_len7 = _v_deref__deref__lsplit__Get1.get_len ();
          int _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _continue1;
          }
          int _v_len__Re = (_v_len7 - _v_len8);
          if (!_vs_idx.term_eq (_v_deref__lsplit__Get1, 0))
          {
            goto _continue1;
          }
          if (!_v_deref__deref__lsplit__Get12.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _ve_2;
          _ve_2 = Expr (_v_lsplit__Get1, (0 + 1), _v_len__2);
          Expr _ve_boxes;
          _ve_boxes = Expr (_v_deref__lsplit__Get1, (0 + 1 + 1 + 1), _v_len__boxes);
          Expr _ve_Re;
          _ve_Re = Expr (_v_deref__deref__lsplit__Get1, 0, _v_len__Re);
          Expr _vs_dir;
          _vs_dir = Expr (_v_deref__deref__lsplit__Get12, 0, 1);
          Expr _ve_Pe;
          _ve_Pe = Expr (_v_deref__deref__lsplit__Get12, (0 + 1), _v_len__Pe);
          Expr _ve_boxes1;
          RF_CALL (::refal::List::Sub, (_ve_boxes, _c_10), _ve_boxes1);
          RF_CALL (::refal::Table::Unbind, (Compute_Length, _vs_idx), /*void*/);
          RF_CALL (::refal::Table::Unbind, (Unknown_Lengths, _vs_idx), /*void*/);
          Expr _ve_boxes2;
          RF_CALL (Classify_Lengths, (_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) ()) (), _ve_boxes2);
          RF_CALL (::refal::Box::Store, (Clashes, (_ve_1 + (_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) () + _ve_boxes1 + _ve_boxes2) () + _ve_2)), /*void*/);
          _v_res1 = empty;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Free_Index, RF_VOID, (RF_RES _v_res1;;))
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, FreeIdx, _v_Get1);
  if (_v_Get1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx;
  _vs_idx = Expr (_v_Get1, 0, 1);
  Expr _gs_auxcall1;
  RF_CALL (::refal::Arithm::Add, (_vs_idx, _c_1), _gs_auxcall1);
  RF_CALL (::refal::Box::Store, (FreeIdx, _gs_auxcall1), /*void*/);
  _v_res1 = _vs_idx;
RF_END

RF_FUNC (Init_Clashes, (RF_ARG _ve_clashes;;), RF_VOID)
  RF_CALL (::refal::Table::ClearTable, Known_Lengths, /*void*/);
  RF_CALL (::refal::Table::ClearTable, Compute_Length, /*void*/);
  RF_CALL (::refal::Table::ClearTable, Unknown_Lengths, /*void*/);
  RF_CALL (::refal::Box::Store, (Checked_Lengths, empty), /*void*/);
  RF_CALL (::refal::Box::Store, (Eqs, empty), /*void*/);
  RF_CALL (::refal::Box::Store, (Parenth, empty), /*void*/);
  RF_CALL (::refal::Box::Store, (Unready_Source, empty), /*void*/);
  RF_CALL (::refal::Table::ClearTable, Hard_Parts, /*void*/);
  RF_CALL (::refal::Box::Store, (FreeIdx, _c_0), /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (Compose_Clashes, _ve_clashes, _ge_auxcall1);
  RF_TAILCALL (::refal::Box::Store, (Clashes, _ge_auxcall1), /*void*/);
RF_END

RF_FUNC (Compose_Clashes, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_ge_arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
      Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1)));
      int _v_len3 = _v_deref__arg12.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__Pe = (_v_len3 - _v_len4);
      int _v_len5 = _v_deref__arg1.get_len ();
      int _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      int _v_len__Re = (_v_len5 - _v_len6);
      if (!_v_deref__arg12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest;
      _ve_rest = Expr (_ge_arg1, (0 + 1 + 1), _v_len__rest);
      Expr _ve_Re;
      _ve_Re = Expr (_v_deref__arg1, 0, _v_len__Re);
      Expr _vs_dir;
      _vs_dir = Expr (_v_deref__arg12, 0, 1);
      Expr _ve_Pe;
      _ve_Pe = Expr (_v_deref__arg12, (0 + 1), _v_len__Pe);
      Expr _vs_idx;
      RF_CALL (Free_Index, /*void*/, _vs_idx);
      Expr _ve_boxes;
      RF_CALL (Classify_Lengths, (_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) ()) (), _ve_boxes);
      {
        {
          {
            {
              Expr _v_Get__Var1;
              if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_11, _ve_Re), _v_Get__Var1))
              {
                goto _block3__branch1;
              }
              if (_v_Get__Var1.get_len () != 1)
              {
                goto _block3__branch1;
              }
              if (!_c_12.term_eq (_v_Get__Var1, 0))
              {
                goto _block3__branch1;
              }
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (_v_len__Re != 1)
              {
                goto _block3__branch2;
              }
              if (_ve_Re.symbol_at (0))
              {
                goto _block3__branch2;
              }
              Expr _v_deref__Re (Expr (_ve_Re, 0));
              int _v_len7 = _v_deref__Re.get_len ();
              int _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _block3__branch2;
              }
              int _v_len___dollar_tmp_m_199_m_22 = (_v_len7 - _v_len8);
              if (!_c_13.term_eq (_v_deref__Re, 0))
              {
                goto _block3__branch2;
              }
              Expr _ve__dollar_tmp_m_199_m_22;
              _ve__dollar_tmp_m_199_m_22 = Expr (_v_deref__Re, (0 + 1), _v_len___dollar_tmp_m_199_m_22);
              goto _block3;
            }
          _block3__branch2: {}
            if (_v_len__Re != 1)
            {
              goto _block2__branch1;
            }
            if (_ve_Re.symbol_at (0))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__Re2 (Expr (_ve_Re, 0));
            int _v_len9 = _v_deref__Re2.get_len ();
            int _v_len10 = 1;
            if (_v_len9 < _v_len10)
            {
              goto _block2__branch1;
            }
            int _v_len___dollar_tmp_m_200_m_25 = (_v_len9 - _v_len10);
            if (!_c_14.term_eq (_v_deref__Re2, 0))
            {
              goto _block2__branch1;
            }
            Expr _ve__dollar_tmp_m_200_m_25;
            _ve__dollar_tmp_m_200_m_25 = Expr (_v_deref__Re2, (0 + 1), _v_len___dollar_tmp_m_200_m_25);
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_v_len__Pe < 1)
          {
            goto _block2__branch2;
          }
          RF_lsplit (_ve_Pe, 0, _ve_1, _v_lsplit__Pe);
          for ( ; ; RF_iter(_ve_Pe)++)
          {
            {
              if (!RF_iter(_ve_Pe))
              {
                goto _block2__branch2;
              }
              int _v_len11 = _v_lsplit__Pe.get_len ();
              int _v_len12 = 1;
              if (_v_len11 < _v_len12)
              {
                goto _block2__branch2;
              }
              int _v_len__2 = (_v_len11 - _v_len12);
              if (_v_lsplit__Pe.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__Pe (Expr (_v_lsplit__Pe, 0));
              int _v_len13 = _v_deref__lsplit__Pe.get_len ();
              int _v_len14 = 1;
              if (_v_len13 < _v_len14)
              {
                goto _continue1;
              }
              int _v_len___dollar_tmp_m_202_m_25 = (_v_len13 - _v_len14);
              if (!_c_15.term_eq (_v_deref__lsplit__Pe, 0))
              {
                goto _continue1;
              }
              Expr _ve_2;
              _ve_2 = Expr (_v_lsplit__Pe, (0 + 1), _v_len__2);
              Expr _ve__dollar_tmp_m_202_m_25;
              _ve__dollar_tmp_m_202_m_25 = Expr (_v_deref__lsplit__Pe, (0 + 1), _v_len___dollar_tmp_m_202_m_25);
              Expr _ve_Re__vars;
              RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Re, _ve_Re__vars);
              Expr _ge_auxcall1;
              RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_1, _ge_auxcall1);
              RF_CALL (::refal::Box::Put, (Parenth, (_vs_idx + _ve_Re__vars () + _ge_auxcall1) ()), /*void*/);
              {
                {
                  if (_v_len__2 < 1)
                  {
                    goto _block4__branch1;
                  }
                  RF_rsplit (_ve_2, 0, _v_rsplit__2, _ve_3);
                  for ( ; ; RF_iter(_ve_2)--)
                  {
                    {
                      if (!RF_iter(_ve_2))
                      {
                        goto _block4__branch1;
                      }
                      int _v_len15 = _v_rsplit__2.get_len ();
                      int _v_len16 = 1;
                      if (_v_len15 < _v_len16)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len___dollar_tmp_m_206_m_20 = (_v_len15 - _v_len16);
                      if (_v_rsplit__2.symbol_at ((0 + _v_len___dollar_tmp_m_206_m_20)))
                      {
                        goto _continue2;
                      }
                      Expr _v_deref__rsplit__2 (Expr (_v_rsplit__2, (0 + _v_len___dollar_tmp_m_206_m_20)));
                      int _v_len17 = _v_deref__rsplit__2.get_len ();
                      int _v_len18 = 1;
                      if (_v_len17 < _v_len18)
                      {
                        goto _continue2;
                      }
                      int _v_len___dollar_tmp_m_206_m_29 = (_v_len17 - _v_len18);
                      if (!_c_15.term_eq (_v_deref__rsplit__2, 0))
                      {
                        goto _continue2;
                      }
                      Expr _ve__dollar_tmp_m_206_m_20;
                      _ve__dollar_tmp_m_206_m_20 = Expr (_v_rsplit__2, 0, _v_len___dollar_tmp_m_206_m_20);
                      Expr _ve__dollar_tmp_m_206_m_29;
                      _ve__dollar_tmp_m_206_m_29 = Expr (_v_deref__rsplit__2, (0 + 1), _v_len___dollar_tmp_m_206_m_29);
                      Expr _ge_auxcall2;
                      RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_3, _ge_auxcall2);
                      RF_CALL (::refal::Box::Put, (Parenth, (_vs_idx + _ve_Re__vars () + _ge_auxcall2) ()), /*void*/);
                      goto _exit2;
                    }
                _continue2: {}
                  }
                _exit2: {}
                  goto _block4;
                }
              _block4__branch1: {}
              }
            _block4: {}
              RF_CALL (::refal::Box::Put, (Unready_Source, (_vs_idx + _ve_Re__vars) ()), /*void*/);
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch2: {}
        Expr _ge_auxcall3;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Re, _ge_auxcall3);
        RF_CALL (::refal::Box::Put, (Unready_Source, (_vs_idx + _ge_auxcall3) ()), /*void*/);
      }
    _block2: {}
      Expr _v_Compose__Clashes1;
      RF_CALL (Compose_Clashes, _ve_rest, _v_Compose__Clashes1);
      _v_res1 = ((_vs_idx + _ve_Re () + (_vs_dir + _ve_Pe) () + _ve_boxes) () + _v_Compose__Clashes1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Update_Hard_Parts, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, Clashes, _ge_auxcall1);
  Expr _ve_clashes;
  Expr _ve_actions;
  RF_CALL (UHP, (empty, empty, _ge_auxcall1), (_ve_clashes, _ve_actions));
  RF_CALL (::refal::Box::Store, (Clashes, _ve_clashes), /*void*/);
  _v_res1 = _ve_actions;
RF_END

RF_FUNC (UHP, (RF_ARG _ve_conds, _ve_assigns, _ve_clashes;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = _ve_clashes.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_clash;
      _vt_clash = Expr (_ve_clashes, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_clashes, (0 + 1), _v_len__rest);
      if (_vt_clash.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__clash (Expr (_vt_clash, 0));
      int _v_len3 = _v_deref__clash.get_len ();
      int _v_len4 = 3;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len___dollar_tmp_m_242_m_43 = (_v_len3 - _v_len4);
      if (_v_deref__clash.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_deref__clash.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__clash (Expr (_v_deref__clash, (0 + 1)));
      Expr _v_deref__deref__clash2 (Expr (_v_deref__clash, (0 + 1 + 1)));
      if (_v_deref__deref__clash.get_len () != 1)
      {
        goto _block1__branch1;
      }
      int _v_len5 = _v_deref__deref__clash2.get_len ();
      int _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      int _v_len__Pe = (_v_len5 - _v_len6);
      if (!_v_deref__clash.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__deref__clash2.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_idx;
      _vs_idx = Expr (_v_deref__clash, 0, 1);
      Expr _ve__dollar_tmp_m_242_m_43;
      _ve__dollar_tmp_m_242_m_43 = Expr (_v_deref__clash, (0 + 1 + 1 + 1), _v_len___dollar_tmp_m_242_m_43);
      Expr _vt_Re;
      _vt_Re = Expr (_v_deref__deref__clash, 0, 1);
      Expr _vs_dir;
      _vs_dir = Expr (_v_deref__deref__clash2, 0, 1);
      Expr _ve_Pe;
      _ve_Pe = Expr (_v_deref__deref__clash2, (0 + 1), _v_len__Pe);
      {
        {
          Expr _v_Get__Var1;
          if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_11, _vt_Re), _v_Get__Var1))
          {
            goto _block2__branch1;
          }
          if (_v_Get__Var1.get_len () != 1)
          {
            goto _block2__branch1;
          }
          if (!_c_12.term_eq (_v_Get__Var1, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_Re.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Re (Expr (_vt_Re, 0));
          int _v_len7 = _v_deref__Re.get_len ();
          int _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          int _v_len___dollar_tmp_m_245_m_20 = (_v_len7 - _v_len8);
          if (!_c_13.term_eq (_v_deref__Re, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve__dollar_tmp_m_245_m_20;
          _ve__dollar_tmp_m_245_m_20 = Expr (_v_deref__Re, (0 + 1), _v_len___dollar_tmp_m_245_m_20);
          goto _block2;
        }
      _block2__branch2: {}
        if (_vt_Re.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__Re2 (Expr (_vt_Re, 0));
        int _v_len9 = _v_deref__Re2.get_len ();
        int _v_len10 = 1;
        if (_v_len9 < _v_len10)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_246_m_23 = (_v_len9 - _v_len10);
        if (!_c_14.term_eq (_v_deref__Re2, 0))
        {
          goto _block1__branch1;
        }
        Expr _ve__dollar_tmp_m_246_m_23;
        _ve__dollar_tmp_m_246_m_23 = Expr (_v_deref__Re2, (0 + 1), _v_len___dollar_tmp_m_246_m_23);
      }
    _block2: {}
      Expr _ge_auxalt1;
      {
        {
          if (!RF_CALL (::refal::Table::Lookup, (Hard_Parts, _vs_idx), _ge_auxalt1))
          {
            goto _block3__branch1;
          }
          goto _block3;
        }
      _block3__branch1: {}
        _ge_auxalt1 = (_c_16 + _ve_Pe);
      }
    _block3: {}
      int _v_len11 = _ge_auxalt1.get_len ();
      int _v_len12 = 2;
      if (_v_len11 < _v_len12)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__xpr = (_v_len11 - _v_len12);
      if (_ge_auxalt1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_ge_auxalt1.symbol_at ((0 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__auxalt1 (Expr (_ge_auxalt1, 0));
      Expr _v_deref__auxalt12 (Expr (_ge_auxalt1, (0 + 1)));
      int _v_len13 = _v_deref__auxalt12.get_len ();
      int _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__right = (_v_len13 - _v_len14);
      int _v_len15 = _v_deref__auxalt1.get_len ();
      int _v_len16 = 0;
      if (_v_len15 < _v_len16)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__left = (_v_len15 - _v_len16);
      Expr _ve_xpr;
      _ve_xpr = Expr (_ge_auxalt1, (0 + 1 + 1), _v_len__xpr);
      Expr _ve_left;
      _ve_left = Expr (_v_deref__auxalt1, 0, _v_len__left);
      Expr _ve_right;
      _ve_right = Expr (_v_deref__auxalt12, 0, _v_len__right);
      Expr _ve_l__clashes;
      Expr _ve_l__conds;
      Expr _ve_l__assigns;
      RF_CALL (UHP_Clash, (_vs_dir, _c_17, _c_1, _c_0, empty, empty, _ve_left, _vt_Re, _ve_xpr), (_ve_l__clashes, _ve_l__conds, _ve_l__assigns, _ve_left, _ve_xpr));
      Expr _ve_r__clashes;
      Expr _ve_r__conds;
      Expr _ve_r__assigns;
      RF_CALL (UHP_Clash, (_vs_dir, _c_18, _c_0, _c_1, empty, empty, _ve_right, _vt_Re, _ve_xpr), (_ve_r__clashes, _ve_r__conds, _ve_r__assigns, _ve_right, _ve_xpr));
      RF_CALL (::refal::Table::Bind, (Hard_Parts, _vs_idx, (_ve_left () + _ve_right () + _ve_xpr)), /*void*/);
      Expr _ge_auxcall2;
      RF_CALL (Compose_Clashes, _ve_l__clashes, _ge_auxcall2);
      Expr _ge_auxcall3;
      RF_CALL (Compose_Clashes, _ve_r__clashes, _ge_auxcall3);
      Expr _v_UHP1;
      RF_CALL (UHP, ((_ve_conds + _ve_l__conds + _ve_r__conds), (_ve_assigns + _ve_l__assigns + _ve_r__assigns), _ve_rest), (_v_UHP1, _v_res2));
      _v_res1 = (_ge_auxcall2 + _vt_clash + _ge_auxcall3 + _v_UHP1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len17 = _ve_clashes.get_len ();
      int _v_len18 = 1;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch2;
      }
      int _v_len__rest2 = (_v_len17 - _v_len18);
      Expr _vt_unready__clash;
      _vt_unready__clash = Expr (_ve_clashes, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_clashes, (0 + 1), _v_len__rest2);
      Expr _v_UHP2;
      RF_CALL (UHP, (_ve_conds, _ve_assigns, _ve_rest), (_v_UHP2, _v_res2));
      _v_res1 = (_vt_unready__clash + _v_UHP2);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ve_clashes.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
    _v_res2 = (_ve_conds + _ve_assigns);
  }
_block1: {}
RF_END

RF_FUNC (UHP_Clash, (RF_ARG _vs_dir, _vs_fun, _vs_l, _vs_r, _ve_conds, _ve_assigns, _ve_pos, _ve_Re, _ve_Pe;;), (RF_RES _v_res1, _v_res2, _v_res3, _v_res4, _v_res5;;))
  {
    {
      int _v_len1 = _ve_Pe.get_len ();
      int _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      int _v_len___dollar_tmp_m_274_m_11 = (_v_len1 - _v_len2);
      Expr _vv__dollar_tmp_m_274_m_11;
      _vv__dollar_tmp_m_274_m_11 = Expr (_ve_Pe, 0, _v_len___dollar_tmp_m_274_m_11);
      Expr _v_Apply1;
      if (!RF_CALL (::refal::Apply::Apply, (_vs_fun, (_c_0 + _ve_Pe)), _v_Apply1))
      {
        goto _block1__branch1;
      }
      if (_v_Apply1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _vt_Pt;
      _vt_Pt = Expr (_v_Apply1, 0, 1);
      {
        {
          Expr _v_Get__Known__Length1;
          Expr _v_Get__Known__Length2;
          RF_CALL (Get_Known_Length, _vt_Pt, (_v_Get__Known__Length1, _v_Get__Known__Length2));
          int _v_len3 = (_v_Get__Known__Length1.get_len () + 1);
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len__len = (_v_len3 - _v_len4);
          Expr _v_compose1 ((_v_Get__Known__Length1 + _v_Get__Known__Length2 ()));
          if (!_c_19.term_eq (_v_compose1, (0 + _v_len__len)))
          {
            goto _block2__branch1;
          }
          Expr _ve_len;
          _ve_len = Expr (_v_compose1, 0, _v_len__len);
          Expr _ve_cond;
          Expr _ve_assign;
          Expr _ve_clash;
          {
            {
              if (_vt_Pt.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__Pt (Expr (_vt_Pt, 0));
              int _v_len5 = _v_deref__Pt.get_len ();
              int _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block3__branch1;
              }
              int _v_len__xpr = (_v_len5 - _v_len6);
              if (!_c_15.term_eq (_v_deref__Pt, 0))
              {
                goto _block3__branch1;
              }
              Expr _ve_xpr;
              _ve_xpr = Expr (_v_deref__Pt, (0 + 1), _v_len__xpr);
              Expr _v_Gener__Vars1;
              RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Vars, (_c_20, (_c_21 + _ve_Re)), _v_Gener__Vars1);
              if (_v_Gener__Vars1.get_len () != 1)
              {
                goto _block2__branch1;
              }
              Expr _vt_var;
              _vt_var = Expr (_v_Gener__Vars1, 0, 1);
              RF_CALL (org::refal::plus::compiler::rfp_vars::Set_Var, (_c_22, _vt_var), /*void*/);
              Expr _ge_pos__7;
              {
                {
                  if (!_vs_fun.term_eq (_c_18, 0))
                  {
                    goto _block4__branch1;
                  }
                  _ge_pos__7 = (_c_23 + _ve_pos + _c_1);
                  goto _block4;
                }
              _block4__branch1: {}
                _ge_pos__7 = (_c_24 + _ve_pos);
              }
            _block4: {}
              _ve_cond = (_c_25 + _ve_Re + _ge_pos__7 ()) ();
              _ve_assign = (_c_26 + _vt_var + _ve_Re + _ge_pos__7 ()) ();
              _ve_clash = (_vt_var () + (_vs_dir + _ve_xpr) ());
              goto _block3;
            }
          _block3__branch1: {}
            {
              {
                if (!_vs_fun.term_eq (_c_18, 0))
                {
                  goto _block5__branch1;
                }
                RF_CALL (::refal::Box::Put, (Eqs, (_ve_Re () + (_c_23 + _ve_pos + _ve_len) () + _vt_Pt + _ve_len ()) ()), /*void*/);
                goto _block5;
              }
            _block5__branch1: {}
              RF_CALL (::refal::Box::Put, (Eqs, (_ve_Re () + (_c_24 + _ve_pos) () + _vt_Pt + _ve_len ()) ()), /*void*/);
            }
          _block5: {}
            _ve_cond = empty;
            _ve_assign = empty;
            _ve_clash = empty;
          }
        _block3: {}
          Expr _ge_auxcall1;
          if (!RF_CALL (::refal::Access::Middle, (_vs_l, _vs_r, _ve_Pe), _ge_auxcall1))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _v_UHP__Clash1;
          RF_CALL (UHP_Clash, (_vs_dir, _vs_fun, _vs_l, _vs_r, (_ve_conds + _ve_cond), (_ve_assigns + _ve_assign), (_ve_pos + _ve_len), _ve_Re, _ge_auxcall1), (_v_UHP__Clash1, _v_res2, _v_res3, _v_res4, _v_res5));
          _v_res1 = (_ve_clash + _v_UHP__Clash1);
          goto _block2;
        }
      _block2__branch1: {}
        _v_res1 = empty;
        _v_res2 = _ve_conds;
        _v_res3 = _ve_assigns;
        _v_res4 = _ve_pos;
        _v_res5 = _ve_Pe;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = _ve_conds;
    _v_res3 = _ve_assigns;
    _v_res4 = _ve_pos;
    _v_res5 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Prepare_Source, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _vt_Re;
      _vt_Re = Expr (_ge_arg1, 0, 1);
      {
        {
          Expr _v_Get__Var1;
          if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_11, _vt_Re), _v_Get__Var1))
          {
            goto _block2__branch1;
          }
          if (_v_Get__Var1.get_len () != 1)
          {
            goto _block2__branch1;
          }
          if (!_c_12.term_eq (_v_Get__Var1, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_Re.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Re (Expr (_vt_Re, 0));
          int _v_len1 = _v_deref__Re.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch2;
          }
          int _v_len___dollar_tmp_m_310_m_18 = (_v_len1 - _v_len2);
          if (!_c_13.term_eq (_v_deref__Re, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve__dollar_tmp_m_310_m_18;
          _ve__dollar_tmp_m_310_m_18 = Expr (_v_deref__Re, (0 + 1), _v_len___dollar_tmp_m_310_m_18);
          goto _block2;
        }
      _block2__branch2: {}
        if (_vt_Re.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__Re2 (Expr (_vt_Re, 0));
        int _v_len3 = _v_deref__Re2.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_311_m_21 = (_v_len3 - _v_len4);
        if (!_c_14.term_eq (_v_deref__Re2, 0))
        {
          goto _block1__branch1;
        }
        Expr _ve__dollar_tmp_m_311_m_21;
        _ve__dollar_tmp_m_311_m_21 = Expr (_v_deref__Re2, (0 + 1), _v_len___dollar_tmp_m_311_m_21);
      }
    _block2: {}
      _v_res1 = _vt_Re;
      _v_res2 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_Re;
      _vt_Re = Expr (_ge_arg1, 0, 1);
      if (!RF_CALL (org::refal::plus::compiler::rfp_vars::IsVar, _vt_Re, /*void*/))
      {
        goto _block1__branch2;
      }
      RF_CALL (Define_Vars, _vt_Re, _v_res2);
      _v_res1 = _vt_Re;
      goto _block1;
    }
  _block1__branch2: {}
    Expr _v_Gener__Vars1;
    RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Vars, (_c_27, _c_28), _v_Gener__Vars1);
    if (_v_Gener__Vars1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vt_var;
    _vt_var = Expr (_v_Gener__Vars1, 0, 1);
    RF_CALL (org::refal::plus::compiler::rfp_vars::Set_Var, (_c_22, _vt_var), /*void*/);
    Expr _v_Vars__Decl1;
    RF_CALL (org::refal::plus::compiler::rfp_vars::Vars_Decl, (_c_29, _vt_var), _v_Vars__Decl1);
    int _v_len5 = _v_Vars__Decl1.get_len ();
    int _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len___dollar_tmp_m_319_m_31 = (_v_len5 - _v_len6);
    Expr _ve__dollar_tmp_m_319_m_31;
    _ve__dollar_tmp_m_319_m_31 = Expr (_v_Vars__Decl1, 0, _v_len___dollar_tmp_m_319_m_31);
    Expr _ge_auxcall1;
    RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ge_arg1, _ge_auxcall1);
    Expr _ge_auxcall2;
    RF_CALL (Define_Vars, _ge_auxcall1, _ge_auxcall2);
    Expr _ge_auxcall3;
    RF_CALL (org::refal::plus::compiler::rfp_vars::Vars_Print, _vt_var, _ge_auxcall3);
    _v_res1 = _vt_var;
    _v_res2 = (_ge_auxcall2 + (_c_30 + _ge_auxcall3 + _ge_arg1) ());
  }
_block1: {}
RF_END

RF_FUNC (Define_Vars, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_var;
      _vt_var = Expr (_ge_arg1, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
      {
        {
          Expr _v_Get__Var1;
          if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_11, _vt_var), _v_Get__Var1))
          {
            goto _block2__branch1;
          }
          if (_v_Get__Var1.get_len () != 1)
          {
            goto _block2__branch1;
          }
          if (!_c_12.term_eq (_v_Get__Var1, 0))
          {
            goto _block2__branch1;
          }
          RF_TAILCALL (Define_Vars, _ve_rest, _v_res1);
          goto _block2;
        }
      _block2__branch1: {}
        Expr _v_Get1;
        RF_CALL (::refal::Box::Get, Eqs, _v_Get1);
        if (_v_Get1.get_len () < 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        RF_lsplit (_v_Get1, 0, _ve_1, _v_lsplit__Get1);
        for ( ; ; RF_iter(_v_Get1)++)
        {
          {
            if (!RF_iter(_v_Get1))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len3 = _v_lsplit__Get1.get_len ();
            int _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__2 = (_v_len3 - _v_len4);
            if (_v_lsplit__Get1.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
            if (_v_deref__lsplit__Get1.get_len () != 4)
            {
              goto _continue1;
            }
            if (!_vt_var.term_eq (_v_deref__lsplit__Get1, (0 + 1 + 1)))
            {
              goto _continue1;
            }
            Expr _ve_2;
            _ve_2 = Expr (_v_lsplit__Get1, (0 + 1), _v_len__2);
            Expr _vt_Re;
            _vt_Re = Expr (_v_deref__lsplit__Get1, 0, 1);
            Expr _vt_pos;
            _vt_pos = Expr (_v_deref__lsplit__Get1, (0 + 1), 1);
            Expr _vt_len;
            _vt_len = Expr (_v_deref__lsplit__Get1, (0 + 1 + 1 + 1), 1);
            RF_CALL (::refal::Box::Store, (Eqs, (_ve_1 + _ve_2)), /*void*/);
            Expr _v_Define__Vars1;
            RF_CALL (Define_Vars, _ve_rest, _v_Define__Vars1);
            _v_res1 = ((_vt_Re + _vt_pos + _vt_var + _vt_len) () + _v_Define__Vars1);
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Not_Idx, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    if (_ge_arg1.get_len () != 2)
    {
      goto _block1__branch1;
    }
    if (_ge_arg1.symbol_at ((0 + 1)))
    {
      goto _block1__branch1;
    }
    Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + 1)));
    int _v_len1 = _v_deref__arg1.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      goto _block1__branch1;
    }
    int _v_len___dollar_tmp_m_343_m_17 = (_v_len1 - _v_len2);
    if (!_ge_arg1.symbol_at (0))
    {
      goto _block1__branch1;
    }
    Expr _vs_idx;
    _vs_idx = Expr (_ge_arg1, 0, 1);
    if (!_vs_idx.term_eq (_v_deref__arg1, 0))
    {
      goto _block1__branch1;
    }
    Expr _ve__dollar_tmp_m_343_m_17;
    _ve__dollar_tmp_m_343_m_17 = Expr (_v_deref__arg1, (0 + 1), _v_len___dollar_tmp_m_343_m_17);
    RF_RETFAIL;
  }
_block1__branch1: {}
  _v_res1 = empty;
RF_END

RF_FUNC (Compose_Source, RF_VOID, (RF_RES _v_res1;;))
  Expr _vs_idx;
  {
    {
      Expr _ge_auxcall1;
      RF_CALL (::refal::Box::Get, Parenth, _ge_auxcall1);
      Expr _v_Find__SFD1;
      Expr _v_Find__SFD2;
      RF_CALL (Find_SFD, _ge_auxcall1, (_v_Find__SFD1, _v_Find__SFD2));
      int _v_len1 = (_v_Find__SFD1.get_len () + 1);
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__parenth = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_v_Find__SFD1 + _v_Find__SFD2 ()));
      if (_v_compose1.symbol_at ((0 + _v_len__parenth)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (Expr (_v_compose1, (0 + _v_len__parenth)));
      if (_v_deref__compose1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_deref__compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_parenth;
      _ve_parenth = Expr (_v_compose1, 0, _v_len__parenth);
      Expr _gs_idx__2;
      _gs_idx__2 = Expr (_v_deref__compose1, 0, 1);
      Expr _ge_auxcall2;
      RF_CALL (::refal::List::Filter, (_c_31, _gs_idx__2, _ve_parenth), _ge_auxcall2);
      RF_CALL (::refal::Box::Store, (Parenth, _ge_auxcall2), /*void*/);
      Expr _ge_auxcall3;
      RF_CALL (::refal::Box::Get, Unready_Source, _ge_auxcall3);
      Expr _ge_auxcall4;
      RF_CALL (::refal::List::Filter, (_c_31, _gs_idx__2, _ge_auxcall3), _ge_auxcall4);
      RF_CALL (::refal::Box::Store, (Unready_Source, _ge_auxcall4), /*void*/);
      _vs_idx = _gs_idx__2;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v_Get1;
    RF_CALL (::refal::Box::Get, Unready_Source, _v_Get1);
    if (_v_Get1.get_len () < 1)
    {
      RF_RETFAIL;
    }
    RF_lsplit (_v_Get1, 0, _ve_l, _v_lsplit__Get1);
    for ( ; ; RF_iter(_v_Get1)++)
    {
      {
        if (!RF_iter(_v_Get1))
        {
          RF_RETFAIL;
        }
        int _v_len3 = _v_lsplit__Get1.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          RF_RETFAIL;
        }
        int _v_len__r = (_v_len3 - _v_len4);
        if (_v_lsplit__Get1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
        int _v_len5 = _v_deref__lsplit__Get1.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _continue1;
        }
        int _v_len__vars = (_v_len5 - _v_len6);
        if (!_v_deref__lsplit__Get1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _ve_r;
        _ve_r = Expr (_v_lsplit__Get1, (0 + 1), _v_len__r);
        Expr _gs_idx__2;
        _gs_idx__2 = Expr (_v_deref__lsplit__Get1, 0, 1);
        Expr _ve_vars;
        _ve_vars = Expr (_v_deref__lsplit__Get1, (0 + 1), _v_len__vars);
        Expr _v_Filter1;
        RF_CALL (::refal::List::Filter, (_c_32, empty, _ve_vars), _v_Filter1);
        if (_v_Filter1.get_len () != 0)
        {
          goto _continue1;
        }
        RF_CALL (::refal::Box::Store, (Unready_Source, (_ve_l + _ve_r)), /*void*/);
        Expr _ge_auxcall5;
        RF_CALL (::refal::Box::Get, Parenth, _ge_auxcall5);
        Expr _ge_auxcall6;
        RF_CALL (::refal::List::Filter, (_c_31, _gs_idx__2, _ge_auxcall5), _ge_auxcall6);
        RF_CALL (::refal::Box::Store, (Parenth, _ge_auxcall6), /*void*/);
        _vs_idx = _gs_idx__2;
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
  Expr _v_Get2;
  RF_CALL (::refal::Box::Get, Clashes, _v_Get2);
  if (_v_Get2.get_len () < 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_lsplit (_v_Get2, 0, _ve_1, _v_lsplit__Get2);
  for ( ; ; RF_iter(_v_Get2)++)
  {
    {
      if (!RF_iter(_v_Get2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len7 = _v_lsplit__Get2.get_len ();
      int _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__2 = (_v_len7 - _v_len8);
      if (_v_lsplit__Get2.symbol_at (0))
      {
        goto _continue2;
      }
      Expr _v_deref__lsplit__Get2 (Expr (_v_lsplit__Get2, 0));
      int _v_len9 = _v_deref__lsplit__Get2.get_len ();
      int _v_len10 = 3;
      if (_v_len9 < _v_len10)
      {
        goto _continue2;
      }
      int _v_len__boxes = (_v_len9 - _v_len10);
      if (_v_deref__lsplit__Get2.symbol_at ((0 + 1)))
      {
        goto _continue2;
      }
      if (_v_deref__lsplit__Get2.symbol_at ((0 + 1 + 1)))
      {
        goto _continue2;
      }
      Expr _v_deref__deref__lsplit__Get2 (Expr (_v_deref__lsplit__Get2, (0 + 1)));
      Expr _v_deref__deref__lsplit__Get22 (Expr (_v_deref__lsplit__Get2, (0 + 1 + 1)));
      int _v_len11 = _v_deref__deref__lsplit__Get22.get_len ();
      int _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _continue2;
      }
      int _v_len__Pe = (_v_len11 - _v_len12);
      int _v_len13 = _v_deref__deref__lsplit__Get2.get_len ();
      int _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        goto _continue2;
      }
      int _v_len__Re = (_v_len13 - _v_len14);
      if (!_vs_idx.term_eq (_v_deref__lsplit__Get2, 0))
      {
        goto _continue2;
      }
      if (!_v_deref__deref__lsplit__Get22.symbol_at (0))
      {
        goto _continue2;
      }
      Expr _ve_2;
      _ve_2 = Expr (_v_lsplit__Get2, (0 + 1), _v_len__2);
      Expr _ve_boxes;
      _ve_boxes = Expr (_v_deref__lsplit__Get2, (0 + 1 + 1 + 1), _v_len__boxes);
      Expr _ve_Re;
      _ve_Re = Expr (_v_deref__deref__lsplit__Get2, 0, _v_len__Re);
      Expr _vs_dir;
      _vs_dir = Expr (_v_deref__deref__lsplit__Get22, 0, 1);
      Expr _ve_Pe;
      _ve_Pe = Expr (_v_deref__deref__lsplit__Get22, (0 + 1), _v_len__Pe);
      Expr _vt_var;
      Expr _ve_assign;
      RF_CALL (Prepare_Source, _ve_Re, (_vt_var, _ve_assign));
      RF_CALL (::refal::Box::Store, (Clashes, (_ve_1 + (_vs_idx + _vt_var () + (_vs_dir + _ve_Pe) () + _ve_boxes) () + _ve_2)), /*void*/);
      _v_res1 = _ve_assign;
      goto _exit2;
    }
_continue2: {}
  }
_exit2: {}
RF_END

RF_FUNC (Find_SFD, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
      int _v_len3 = _v_deref__arg1.get_len ();
      int _v_len4 = 2;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__Pe__vars = (_v_len3 - _v_len4);
      if (_v_deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__arg1 (Expr (_v_deref__arg1, (0 + 1)));
      int _v_len5 = _v_deref__deref__arg1.get_len ();
      int _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      int _v_len__Re__vars = (_v_len5 - _v_len6);
      if (!_v_deref__arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_rest;
      _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _vs_idx;
      _vs_idx = Expr (_v_deref__arg1, 0, 1);
      Expr _ve_Pe__vars;
      _ve_Pe__vars = Expr (_v_deref__arg1, (0 + 1 + 1), _v_len__Pe__vars);
      Expr _ve_Re__vars;
      _ve_Re__vars = Expr (_v_deref__deref__arg1, 0, _v_len__Re__vars);
      Expr _v_Filter1;
      RF_CALL (::refal::List::Filter, (_c_32, empty, _ve_Re__vars), _v_Filter1);
      {
        {
          int _v_len7 = _v_Filter1.get_len ();
          int _v_len8 = 0;
          if (_v_len7 < (_v_len8 + 1))
          {
            goto _block2__branch1;
          }
          int _v_len__r__vars = (_v_len7 - _v_len8);
          Expr _vv_r__vars;
          _vv_r__vars = Expr (_v_Filter1, 0, _v_len__r__vars);
          Expr _v_Find__SFD1;
          RF_CALL (Find_SFD, _ve_rest, (_v_Find__SFD1, _v_res2));
          _v_res1 = ((_vs_idx + _vv_r__vars () + _ve_Pe__vars) () + _v_Find__SFD1);
          goto _block2;
        }
      _block2__branch1: {}
        if (_v_Filter1.get_len () != 0)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_Get__Known__Length1;
        Expr _v_Get__Known__Length2;
        RF_CALL (Get_Known_Length, _ve_Pe__vars, (_v_Get__Known__Length1, _v_Get__Known__Length2));
        {
          {
            int _v_len9 = (_v_Get__Known__Length1.get_len () + 1);
            int _v_len10 = 1;
            if (_v_len9 < _v_len10)
            {
              goto _block3__branch1;
            }
            int _v_len___dollar_tmp_m_370_m_10 = (_v_len9 - _v_len10);
            Expr _v_compose1 ((_v_Get__Known__Length1 + _v_Get__Known__Length2 ()));
            if (_v_compose1.symbol_at ((0 + _v_len___dollar_tmp_m_370_m_10)))
            {
              goto _block3__branch1;
            }
            Expr _v_deref__compose1 (Expr (_v_compose1, (0 + _v_len___dollar_tmp_m_370_m_10)));
            int _v_len11 = _v_deref__compose1.get_len ();
            int _v_len12 = 0;
            if (_v_len11 < (_v_len12 + 1))
            {
              goto _block3__branch1;
            }
            int _v_len__p__vars = (_v_len11 - _v_len12);
            Expr _ve__dollar_tmp_m_370_m_10;
            _ve__dollar_tmp_m_370_m_10 = Expr (_v_compose1, 0, _v_len___dollar_tmp_m_370_m_10);
            Expr _vv_p__vars;
            _vv_p__vars = Expr (_v_deref__compose1, 0, _v_len__p__vars);
            Expr _v_Find__SFD2;
            RF_CALL (Find_SFD, _ve_rest, (_v_Find__SFD2, _v_res2));
            _v_res1 = ((_vs_idx + _c_19 + _vv_p__vars) () + _v_Find__SFD2);
            goto _block3;
          }
        _block3__branch1: {}
          int _v_len13 = (_v_Get__Known__Length1.get_len () + 1);
          int _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          int _v_len___dollar_tmp_m_371_m_10 = (_v_len13 - _v_len14);
          Expr _v_compose2 ((_v_Get__Known__Length1 + _v_Get__Known__Length2 ()));
          if (!_c_19.term_eq (_v_compose2, (0 + _v_len___dollar_tmp_m_371_m_10)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _ve__dollar_tmp_m_371_m_10;
          _ve__dollar_tmp_m_371_m_10 = Expr (_v_compose2, 0, _v_len___dollar_tmp_m_371_m_10);
          Expr _ge_auxcall1;
          RF_CALL (::refal::List::Filter, (_c_31, _vs_idx, _ve_rest), _ge_auxcall1);
          _v_res1 = _ge_auxcall1;
          _v_res2 = _vs_idx;
        }
      _block3: {}
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Not_Instantiated_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  Expr _vt_var;
  _vt_var = Expr (_ge_arg1, 0, 1);
  {
    {
      {
        Expr _v_Get__Var1;
        if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_11, _vt_var), _v_Get__Var1))
        {
          goto _block1__branch1;
        }
        if (_v_Get__Var1.get_len () != 1)
        {
          goto _block1__branch1;
        }
        if (!_c_12.term_eq (_v_Get__Var1, 0))
        {
          goto _block1__branch1;
        }
        goto _block1;
      }
    _block1__branch1: {}
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, Eqs, _v_Get1);
      if (_v_Get1.get_len () < 1)
      {
        goto _negation1;
      }
      RF_lsplit (_v_Get1, 0, _ve__dollar_tmp_m_379_m_17, _v_lsplit__Get1);
      for ( ; ; RF_iter(_v_Get1)++)
      {
        {
          if (!RF_iter(_v_Get1))
          {
            goto _negation1;
          }
          int _v_len1 = _v_lsplit__Get1.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _negation1;
          }
          int _v_len___dollar_tmp_m_379_m_33 = (_v_len1 - _v_len2);
          if (_v_lsplit__Get1.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
          if (_v_deref__lsplit__Get1.get_len () != 4)
          {
            goto _continue1;
          }
          if (!_vt_var.term_eq (_v_deref__lsplit__Get1, (0 + 1 + 1)))
          {
            goto _continue1;
          }
          Expr _ve__dollar_tmp_m_379_m_33;
          _ve__dollar_tmp_m_379_m_33 = Expr (_v_lsplit__Get1, (0 + 1), _v_len___dollar_tmp_m_379_m_33);
          Expr _vt__dollar_tmp_m_379_m_20;
          _vt__dollar_tmp_m_379_m_20 = Expr (_v_deref__lsplit__Get1, 0, 1);
          Expr _vt__dollar_tmp_m_379_m_22;
          _vt__dollar_tmp_m_379_m_22 = Expr (_v_deref__lsplit__Get1, (0 + 1), 1);
          Expr _vt__dollar_tmp_m_379_m_30;
          _vt__dollar_tmp_m_379_m_30 = Expr (_v_deref__lsplit__Get1, (0 + 1 + 1 + 1), 1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
    }
  _block1: {}
    RF_RETFAIL;
  }
_negation1: {}
  _v_res1 = empty;
RF_END

RF_FUNC (Get_Cycle, RF_VOID, (RF_RES _v_res1, _v_res2, _v_res3, _v_res4, _v_res5, _v_res6, _v_res7;;))
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, Clashes, _v_Get1);
  if (_v_Get1.get_len () < 1)
  {
    RF_RETFAIL;
  }
  RF_lsplit (_v_Get1, 0, _ve__dollar_tmp_m_385_m_21, _v_lsplit__Get1);
  for ( ; ; RF_iter(_v_Get1)++)
  {
    {
      if (!RF_iter(_v_Get1))
      {
        RF_RETFAIL;
      }
      int _v_len1 = _v_lsplit__Get1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_RETFAIL;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      if (_v_lsplit__Get1.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
      if (_v_deref__lsplit__Get1.get_len () < 4)
      {
        goto _continue1;
      }
      if (_v_deref__lsplit__Get1.symbol_at ((0 + 1)))
      {
        goto _continue1;
      }
      if (_v_deref__lsplit__Get1.symbol_at ((0 + 1 + 1)))
      {
        goto _continue1;
      }
      Expr _v_deref__deref__lsplit__Get1 (Expr (_v_deref__lsplit__Get1, (0 + 1)));
      Expr _v_deref__deref__lsplit__Get12 (Expr (_v_deref__lsplit__Get1, (0 + 1 + 1)));
      if (_v_deref__deref__lsplit__Get1.get_len () != 1)
      {
        goto _continue1;
      }
      int _v_len3 = _v_deref__deref__lsplit__Get12.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _continue1;
      }
      int _v_len__Pe = (_v_len3 - _v_len4);
      if (!_v_deref__lsplit__Get1.symbol_at (0))
      {
        goto _continue1;
      }
      if (!_v_deref__deref__lsplit__Get12.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _ve_rest;
      _ve_rest = Expr (_v_lsplit__Get1, (0 + 1), _v_len__rest);
      Expr _vs_idx;
      _vs_idx = Expr (_v_deref__lsplit__Get1, 0, 1);
      Expr _vt_var;
      _vt_var = Expr (_v_deref__deref__lsplit__Get1, 0, 1);
      Expr _vs_dir;
      _vs_dir = Expr (_v_deref__deref__lsplit__Get12, 0, 1);
      Expr _ve_Pe;
      _ve_Pe = Expr (_v_deref__deref__lsplit__Get12, (0 + 1), _v_len__Pe);
      Expr _v_subexpr__deref__lsplit__Get1 (Expr (_v_deref__lsplit__Get1, (0 + 1 + 1 + 1), (_v_deref__lsplit__Get1.get_len () - (0 + 1 + 1 + 1 + 0))));
      RF_lsplit (_v_subexpr__deref__lsplit__Get1, 0, _ve_b1, _v_lsplit__deref__lsplit__Get1);
      for ( ; ; RF_iter(_v_subexpr__deref__lsplit__Get1)++)
      {
        {
          if (!RF_iter(_v_subexpr__deref__lsplit__Get1))
          {
            goto _continue1;
          }
          int _v_len5 = _v_lsplit__deref__lsplit__Get1.get_len ();
          int _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _continue1;
          }
          int _v_len__b2 = (_v_len5 - _v_len6);
          if (!Unknown_Lengths.term_eq (_v_lsplit__deref__lsplit__Get1, 0))
          {
            goto _continue2;
          }
          Expr _ve_b2;
          _ve_b2 = Expr (_v_lsplit__deref__lsplit__Get1, (0 + 1), _v_len__b2);
          Expr _v_Get__Known__Length1;
          Expr _v_Get__Known__Length2;
          RF_CALL (Get_Known_Length, _vt_var, (_v_Get__Known__Length1, _v_Get__Known__Length2));
          int _v_len7 = (_v_Get__Known__Length1.get_len () + 1);
          int _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            RF_RETFAIL;
          }
          int _v_len__len = (_v_len7 - _v_len8);
          Expr _v_compose1 ((_v_Get__Known__Length1 + _v_Get__Known__Length2 ()));
          if (!_c_19.term_eq (_v_compose1, (0 + _v_len__len)))
          {
            RF_RETFAIL;
          }
          Expr _ve_len;
          _ve_len = Expr (_v_compose1, 0, _v_len__len);
          Expr _v_Lookup1;
          if (!RF_CALL (::refal::Table::Lookup, (Hard_Parts, _vs_idx), _v_Lookup1))
          {
            RF_RETFAIL;
          }
          int _v_len9 = _v_Lookup1.get_len ();
          int _v_len10 = 2;
          if (_v_len9 < _v_len10)
          {
            RF_RETFAIL;
          }
          int _v_len__expr = (_v_len9 - _v_len10);
          if (_v_Lookup1.symbol_at (0))
          {
            RF_RETFAIL;
          }
          if (_v_Lookup1.symbol_at ((0 + 1)))
          {
            RF_RETFAIL;
          }
          Expr _v_deref__Lookup1 (Expr (_v_Lookup1, 0));
          Expr _v_deref__Lookup12 (Expr (_v_Lookup1, (0 + 1)));
          int _v_len11 = _v_deref__Lookup12.get_len ();
          int _v_len12 = 0;
          if (_v_len11 < _v_len12)
          {
            RF_RETFAIL;
          }
          int _v_len__right = (_v_len11 - _v_len12);
          int _v_len13 = _v_deref__Lookup1.get_len ();
          int _v_len14 = 0;
          if (_v_len13 < _v_len14)
          {
            RF_RETFAIL;
          }
          int _v_len__left = (_v_len13 - _v_len14);
          Expr _ve_expr;
          _ve_expr = Expr (_v_Lookup1, (0 + 1 + 1), _v_len__expr);
          Expr _ve_left;
          _ve_left = Expr (_v_deref__Lookup1, 0, _v_len__left);
          Expr _ve_right;
          _ve_right = Expr (_v_deref__Lookup12, 0, _v_len__right);
          Expr _vs_split;
          Expr _vt_var__e1;
          Expr _vs_pref__e2;
          Expr _ve_Pe__rest;
          {
            {
              if (!_vs_dir.term_eq (_c_24, 0))
              {
                goto _block1__branch1;
              }
              int _v_len15 = _v_len__expr;
              int _v_len16 = 1;
              if (_v_len15 < _v_len16)
              {
                RF_RETFAIL;
              }
              int _v_len__Pe__rest__2 = (_v_len15 - _v_len16);
              Expr _gt_var__e1__2;
              _gt_var__e1__2 = Expr (_ve_expr, 0, 1);
              Expr _ge_Pe__rest__2;
              _ge_Pe__rest__2 = Expr (_ve_expr, (0 + 1), _v_len__Pe__rest__2);
              _vs_split = _c_33;
              _vt_var__e1 = _gt_var__e1__2;
              _vs_pref__e2 = _c_34;
              _ve_Pe__rest = _ge_Pe__rest__2;
              goto _block1;
            }
          _block1__branch1: {}
            if (!_vs_dir.term_eq (_c_23, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len17 = _v_len__expr;
            int _v_len18 = 1;
            if (_v_len17 < _v_len18)
            {
              RF_RETFAIL;
            }
            int _v_len__Pe__rest__22 = (_v_len17 - _v_len18);
            Expr _ge_Pe__rest__2;
            _ge_Pe__rest__2 = Expr (_ve_expr, 0, _v_len__Pe__rest__22);
            Expr _gt_var__e1__2;
            _gt_var__e1__2 = Expr (_ve_expr, (0 + _v_len__Pe__rest__22), 1);
            _vs_split = _c_35;
            _vt_var__e1 = _gt_var__e1__2;
            _vs_pref__e2 = _c_36;
            _ve_Pe__rest = _ge_Pe__rest__2;
          }
        _block1: {}
          Expr _ge_auxalt2;
          Expr _ge_auxalt3;
          Expr _gs_auxalt4;
          Expr _ge_auxalt5;
          {
            {
              if (!RF_CALL (org::refal::plus::compiler::rfp_vars::IsVar, _ve_Pe__rest, /*void*/))
              {
                goto _block2__branch1;
              }
              Expr _gt_auxcall1;
              RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Len_Var, _ve_Pe__rest, _gt_auxcall1);
              _ge_auxalt2 = _ve_Pe__rest;
              _ge_auxalt3 = _ve_Pe__rest;
              _gs_auxalt4 = _vs_dir;
              _ge_auxalt5 = _gt_auxcall1;
              goto _block2;
            }
          _block2__branch1: {}
            Expr _v_Gener__Vars1;
            RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Vars, (_c_20, (_vs_pref__e2 + _vt_var)), _v_Gener__Vars1);
            if (_v_Gener__Vars1.get_len () != 1)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vt_var__e2;
            _vt_var__e2 = Expr (_v_Gener__Vars1, 0, 1);
            _ge_auxalt2 = _vt_var__e2;
            _ge_auxalt3 = _vt_var__e2;
            _gs_auxalt4 = _vs_dir;
            _ge_auxalt5 = _ve_Pe__rest;
          }
        _block2: {}
          if ((_ge_auxalt2.get_len () + 1) != 2)
          {
            RF_RETFAIL;
          }
          Expr _v_compose2 ((_ge_auxalt2 + (_ge_auxalt3 () + (_gs_auxalt4 + _ge_auxalt5) ()) ()));
          if (_v_compose2.symbol_at ((0 + 1)))
          {
            RF_RETFAIL;
          }
          Expr _v_deref__compose2 (Expr (_v_compose2, (0 + 1)));
          int _v_len19 = _v_deref__compose2.get_len ();
          int _v_len20 = 0;
          if (_v_len19 < _v_len20)
          {
            RF_RETFAIL;
          }
          int _v_len__clash = (_v_len19 - _v_len20);
          Expr _vt_var__e2;
          _vt_var__e2 = Expr (_v_compose2, 0, 1);
          Expr _ve_clash;
          _ve_clash = Expr (_v_deref__compose2, 0, _v_len__clash);
          RF_CALL (org::refal::plus::compiler::rfp_vars::Set_Var, (_c_22, _vt_var__e1), /*void*/);
          RF_CALL (org::refal::plus::compiler::rfp_vars::Set_Var, (_c_22, _vt_var__e2), /*void*/);
          Expr _ge_auxcall6;
          RF_CALL (Compose_Clashes, _ve_clash, _ge_auxcall6);
          RF_CALL (::refal::Box::Store, (Clashes, (_ge_auxcall6 + _ve_rest)), /*void*/);
          Expr _ge_auxcall7;
          if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_2, _vt_var__e1), _ge_auxcall7))
          {
            RF_RETFAIL;
          }
          Expr _v_Get__Var1;
          if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_2, _vt_var__e2), _v_Get__Var1))
          {
            RF_RETFAIL;
          }
          Expr _ve_clashes ((_ge_auxcall7 + _v_Get__Var1));
          Expr _ge_auxcall8;
          RF_CALL (::refal::Box::Get, Checked_Lengths, _ge_auxcall8);
          Expr _ge_auxcall9;
          RF_CALL (::refal::List::Sub, (_ve_clashes, _ge_auxcall8), _ge_auxcall9);
          Expr _v_Map1;
          if (!RF_CALL (::refal::List::Map, (_c_37, empty, _ge_auxcall9), _v_Map1))
          {
            RF_RETFAIL;
          }
          int _v_len21 = _v_Map1.get_len ();
          int _v_len22 = 0;
          if (_v_len21 < _v_len22)
          {
            RF_RETFAIL;
          }
          int _v_len___dollar_tmp_m_407_m_78 = (_v_len21 - _v_len22);
          Expr _ve__dollar_tmp_m_407_m_78;
          _ve__dollar_tmp_m_407_m_78 = Expr (_v_Map1, 0, _v_len___dollar_tmp_m_407_m_78);
          _v_res1 = _vs_split;
          _v_res2 = _ve_left;
          _v_res3 = _ve_right;
          _v_res4 = _ve_len;
          _v_res5 = _vt_var;
          _v_res6 = _vt_var__e1;
          _v_res7 = _vt_var__e2;
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Get_Known_Length, (RF_ARG _ve_Re;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ge_Re__0 (_ve_Re);
  Expr _ve_length;
  Expr _ve_unknown__vars;
  for ( ; ; )
  {
    {
      if (_ge_Re__0.get_len () != 0)
      {
        goto _iter1;
      }
      {
        {
          if (_ve_length.get_len () != 0)
          {
            goto _block1__branch1;
          }
          _v_res1 = _c_0;
          _v_res2 = _ve_unknown__vars;
          goto _block1;
        }
      _block1__branch1: {}
        _v_res1 = _ve_length;
        _v_res2 = _ve_unknown__vars;
      }
    _block1: {}
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1 = _ge_Re__0.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_Rt;
    _vt_Rt = Expr (_ge_Re__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_Re__0, (0 + 1), _v_len__rest);
    Expr _ve_len;
    Expr _ve_var;
    {
      {
        if (!_vt_Rt.symbol_at (0))
        {
          goto _block3__branch1;
        }
        Expr _vs_ObjectSymbol;
        _vs_ObjectSymbol = Expr (_vt_Rt, 0, 1);
        _ve_len = _c_1;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch1: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch2;
        }
        Expr _v_deref__Rt (Expr (_vt_Rt, 0));
        int _v_len3 = _v_deref__Rt.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block3__branch2;
        }
        int _v_len___dollar_tmp_m_426_m_15 = (_v_len3 - _v_len4);
        if (!_c_15.term_eq (_v_deref__Rt, 0))
        {
          goto _block3__branch2;
        }
        Expr _ve__dollar_tmp_m_426_m_15;
        _ve__dollar_tmp_m_426_m_15 = Expr (_v_deref__Rt, (0 + 1), _v_len___dollar_tmp_m_426_m_15);
        _ve_len = _c_1;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch2: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch3;
        }
        Expr _v_deref__Rt2 (Expr (_vt_Rt, 0));
        int _v_len5 = _v_deref__Rt2.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _block3__branch3;
        }
        int _v_len___dollar_tmp_m_427_m_14 = (_v_len5 - _v_len6);
        if (!_c_38.term_eq (_v_deref__Rt2, 0))
        {
          goto _block3__branch3;
        }
        Expr _ve__dollar_tmp_m_427_m_14;
        _ve__dollar_tmp_m_427_m_14 = Expr (_v_deref__Rt2, (0 + 1), _v_len___dollar_tmp_m_427_m_14);
        _ve_len = _c_1;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch3: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch4;
        }
        Expr _v_deref__Rt3 (Expr (_vt_Rt, 0));
        int _v_len7 = _v_deref__Rt3.get_len ();
        int _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          goto _block3__branch4;
        }
        int _v_len___dollar_tmp_m_428_m_17 = (_v_len7 - _v_len8);
        if (!_c_39.term_eq (_v_deref__Rt3, 0))
        {
          goto _block3__branch4;
        }
        Expr _ve__dollar_tmp_m_428_m_17;
        _ve__dollar_tmp_m_428_m_17 = Expr (_v_deref__Rt3, (0 + 1), _v_len___dollar_tmp_m_428_m_17);
        _ve_len = _c_1;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch4: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch5;
        }
        Expr _v_deref__Rt4 (Expr (_vt_Rt, 0));
        if (_v_deref__Rt4.get_len () != 2)
        {
          goto _block3__branch5;
        }
        if (!_c_13.term_eq (_v_deref__Rt4, 0))
        {
          goto _block3__branch5;
        }
        Expr _vt_name;
        _vt_name = Expr (_v_deref__Rt4, (0 + 1), 1);
        Expr _ge_auxcall1;
        RF_CALL (Ref_Len, _vt_name, _ge_auxcall1);
        _ve_len = _ge_auxcall1;
        _ve_var = empty;
        goto _block3;
      }
    _block3__branch5: {}
      {
        if (_vt_Rt.symbol_at (0))
        {
          goto _block3__branch6;
        }
        Expr _v_deref__Rt5 (Expr (_vt_Rt, 0));
        if (_v_deref__Rt5.get_len () != 2)
        {
          goto _block3__branch6;
        }
        if (!_c_14.term_eq (_v_deref__Rt5, 0))
        {
          goto _block3__branch6;
        }
        Expr _vt_name;
        _vt_name = Expr (_v_deref__Rt5, (0 + 1), 1);
        Expr _ge_auxcall2;
        RF_CALL (org::refal::plus::compiler::rfp_const::Get_Static, _vt_Rt, _ge_auxcall2);
        RF_CALL (Get_Known_Length, _ge_auxcall2, (_ve_len, _ve_var));
        goto _block3;
      }
    _block3__branch6: {}
      Expr _vt__dollar_tmp_m_431_m_8;
      _vt__dollar_tmp_m_431_m_8 = Expr (_vt_Rt, 0, 1);
      if (!RF_CALL (org::refal::plus::compiler::rfp_vars::IsVar, _vt_Rt, /*void*/))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      {
        {
          Expr _v_Get__Var1;
          if (!RF_CALL (org::refal::plus::compiler::rfp_vars::Get_Var, (_c_40, _vt_Rt), _v_Get__Var1))
          {
            goto _block4__branch1;
          }
          int _v_len9 = _v_Get__Var1.get_len ();
          int _v_len10 = 0;
          if (_v_len9 < (_v_len10 + 1))
          {
            goto _block4__branch1;
          }
          int _v_len__len__6 = (_v_len9 - _v_len10);
          Expr _gv_len__6;
          _gv_len__6 = Expr (_v_Get__Var1, 0, _v_len__len__6);
          _ve_len = _gv_len__6;
          _ve_var = empty;
          goto _block4;
        }
      _block4__branch1: {}
        _ve_len = empty;
        _ve_var = _vt_Rt;
      }
    _block4: {}
    }
  _block3: {}
    _ge_Re__0 = _ve_rest;
    _ve_length = (_ve_length + _ve_len);
    _ve_unknown__vars = (_ve_unknown__vars + _ve_var);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Ref_Len, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (::refal::Table::Lookup, (Const_Len, _vt_name), _v_res1))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (::refal::Table::Lookup, (org::refal::plus::compiler::rfp_helper::Const, _vt_name), _ge_auxcall1))
      {
        goto _block1__branch2;
      }
      Expr _ge_auxcall2;
      if (!RF_CALL (::refal::Access::Middle, (_c_41, _c_0, _ge_auxcall1), _ge_auxcall2))
      {
        goto _block1__branch2;
      }
      Expr _ve_len;
      Expr _v_Get__Known__Length1;
      RF_CALL (Get_Known_Length, _ge_auxcall2, (_ve_len, _v_Get__Known__Length1));
      Expr _vt__dollar_tmp_m_448_m_68 (_v_Get__Known__Length1 ());
      RF_CALL (::refal::Table::Bind, (Const_Len, _vt_name, _ve_len), /*void*/);
      _v_res1 = _ve_len;
      goto _block1;
    }
  _block1__branch2: {}
    _v_res1 = _c_1;
  }
_block1: {}
RF_END

RF_FUNC (Compute_Max_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 6)
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1 + 1)))
  {
    RF_ERROR (_c_42);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + 1)));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1 + 1)));
  Expr _v_deref__arg13 (Expr (_ge_arg1, (0 + 1 + 1 + 1)));
  Expr _v_deref__arg14 (Expr (_ge_arg1, (0 + 1 + 1 + 1 + 1)));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__arg12.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub2 = (_v_len3 - _v_len4);
  int _v_len5 = _v_deref__arg14.get_len ();
  int _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub3 = (_v_len5 - _v_len6);
  int _v_len7 = _v_deref__arg13.get_len ();
  int _v_len8 = 0;
  if (_v_len7 < _v_len8)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub4 = (_v_len7 - _v_len8);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_42);
  }
  Expr _v_stub5;
  _v_stub5 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub6;
  _v_stub6 = Expr (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1), 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_v_deref__arg1, 0, _v_len__stub1);
  Expr _v_stub2;
  _v_stub2 = Expr (_v_deref__arg12, 0, _v_len__stub2);
  Expr _v_stub4;
  _v_stub4 = Expr (_v_deref__arg13, 0, _v_len__stub4);
  Expr _v_stub3;
  _v_stub3 = Expr (_v_deref__arg14, 0, _v_len__stub3);
  RF_CALL (Compute_Max, (_v_stub5, _v_stub1, _v_stub2, _v_stub4, _v_stub3, _v_stub6), /*void*/);
  _v_res1 = empty;
RF_END

RF_FUNC (Get_Var_Max_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_42);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  RF_TAILCALL (org::refal::plus::compiler::rfp_vars::Get_Var_Max, _v_stub1, _v_res1);
RF_END

RF_FUNC (R_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_42);
  }
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, (0 + 1), _v_len__stub1);
  if (!RF_CALL (::refal::Access::R, (_v_stub2, _v_stub1), _v_res1))
  {
    RF_RETFAIL;
  }
RF_END

RF_FUNC (L_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_42);
  }
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, (0 + 1), _v_len__stub1);
  if (!RF_CALL (::refal::Access::L, (_v_stub2, _v_stub1), _v_res1))
  {
    RF_RETFAIL;
  }
RF_END

RF_FUNC (Get_Var_Min_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_42);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  RF_TAILCALL (org::refal::plus::compiler::rfp_vars::Get_Var_Min, _v_stub1, _v_res1);
RF_END

RF_FUNC (Compute_Min_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 6)
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_ERROR (_c_42);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1 + 1)))
  {
    RF_ERROR (_c_42);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + 1)));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1 + 1)));
  Expr _v_deref__arg13 (Expr (_ge_arg1, (0 + 1 + 1 + 1)));
  Expr _v_deref__arg14 (Expr (_ge_arg1, (0 + 1 + 1 + 1 + 1)));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__arg12.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub2 = (_v_len3 - _v_len4);
  int _v_len5 = _v_deref__arg14.get_len ();
  int _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub3 = (_v_len5 - _v_len6);
  int _v_len7 = _v_deref__arg13.get_len ();
  int _v_len8 = 0;
  if (_v_len7 < _v_len8)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub4 = (_v_len7 - _v_len8);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_42);
  }
  Expr _v_stub5;
  _v_stub5 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub6;
  _v_stub6 = Expr (_ge_arg1, (0 + 1 + 1 + 1 + 1 + 1), 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_v_deref__arg1, 0, _v_len__stub1);
  Expr _v_stub2;
  _v_stub2 = Expr (_v_deref__arg12, 0, _v_len__stub2);
  Expr _v_stub4;
  _v_stub4 = Expr (_v_deref__arg13, 0, _v_len__stub4);
  Expr _v_stub3;
  _v_stub3 = Expr (_v_deref__arg14, 0, _v_len__stub3);
  RF_CALL (Compute_Min, (_v_stub5, _v_stub1, _v_stub2, _v_stub4, _v_stub3, _v_stub6), /*void*/);
  _v_res1 = empty;
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_clashes {

static void init_ () {
  Known_Lengths = new rftype::StaticObject<rftype::Table>(L"Known_Lengths");
  Compute_Length = new rftype::StaticObject<rftype::Table>(L"Compute_Length");
  Unknown_Lengths = new rftype::StaticObject<rftype::Table>(L"Unknown_Lengths");
  Checked_Lengths = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Checked_Lengths");
  Eqs = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Eqs");
  Clashes = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Clashes");
  Hard_Parts = new rftype::StaticObject<rftype::Table>(L"Hard_Parts");
  Parenth = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Parenth");
  Unready_Source = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Unready_Source");
  FreeIdx = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"FreeIdx");
  Const_Len = new rftype::StaticObject<rftype::Table>(L"Const_Len");
  _c_0 = Expr::create<rftype::Integer>("0");
  _c_1 = Expr::create<rftype::Integer>("1");
  _c_2 = Expr::create<rftype::Word>("Clashes");
  _c_3 = Expr::create<rftype::Integer>("-1");
  _c_4 = Expr::create_sym<rftype::Func> (Add_Clash_To_Var);
  _c_5 = Expr::create<rftype::Word>("Stop");
  _c_6 = Expr::create_sym<rftype::Func> (Compute_Max_0);
  _c_7 = Expr::create_sym<rftype::Func> (Compute_Min_0);
  _c_8 = Expr::create_sym<rftype::Func> (Get_Var_Max_0);
  _c_9 = Expr::create_sym<rftype::Func> (Get_Var_Min_0);
  _c_10 = Compute_Length + Unknown_Lengths;
  _c_43 = Expr::create<rftype::Word>("Instantiated?") + Expr::create<rftype::Word>("True");
  _c_11 = Expr (_c_43, 0, 1);
  _c_12 = Expr (_c_43, 1, 1);
  _c_13 = Expr::create<rftype::Word>("REF");
  _c_14 = Expr::create<rftype::Word>("STATIC");
  _c_15 = Expr::create<rftype::Word>("PAREN");
  _c_16 = (_c_0) () + (_c_0) ();
  _c_17 = Expr::create_sym<rftype::Func> (L_0);
  _c_18 = Expr::create_sym<rftype::Func> (R_0);
  _c_19 = (empty) ();
  _c_20 = (Expr::create<rftype::Word>("VAR")) ();
  _c_21 = Expr::create<rftype::Word>("deref_");
  _c_22 = (_c_43) ();
  _c_23 = Expr::create<rftype::Word>("RIGHT");
  _c_24 = Expr::create<rftype::Word>("LEFT");
  _c_25 = Expr::create<rftype::Word>("SYMBOL?");
  _c_26 = Expr::create<rftype::Word>("DEREF");
  _c_27 = (Expr::create<rftype::Word>("EVAR")) ();
  _c_28 = Expr::create<rftype::Word>("compose");
  _c_30 = Expr::create<rftype::Word>("DECL") + Expr::create<rftype::Word>("Expr");
  _c_29 = Expr (_c_30, 1, 1);
  _c_31 = Expr::create_sym<rftype::Func> (Not_Idx);
  _c_32 = Expr::create_sym<rftype::Func> (Not_Instantiated_Var);
  _c_33 = Expr::create<rftype::Word>("LSPLIT");
  _c_34 = Expr::create<rftype::Word>("lsplit_");
  _c_35 = Expr::create<rftype::Word>("RSPLIT");
  _c_36 = Expr::create<rftype::Word>("rsplit_");
  _c_37 = Expr::create_sym<rftype::Func> (Reclassify_Clash);
  _c_38 = Expr::create<rftype::Word>("FUNC");
  _c_39 = Expr::create<rftype::Word>("FUNC?");
  _c_40 = Expr::create<rftype::Word>("Length");
  _c_41 = Expr::create<rftype::Integer>("2");
  _c_42 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
