
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail {

RF_DECL (ASAIL_MAX);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Boxes_To_Vars);

RF_DECL (Create_Int_Var);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail {

RF_DECL (ASAIL_MIN);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Gener_Err_Var);

RF_DECL (Gener_Name);

RF_DECL (Gener_Subst_Vars);

RF_DECL (Gener_Var_Indices);

RF_DECL (Gener_Vars);

RF_DECL (Gener_Var_Names);

RF_DECL (Gener_Var_Assign);

RF_DECL (Gener_Len_Var);

RF_DECL (Decl_Var);

RF_DECL (Get_Var_Min);

RF_DECL (Get_Var_Max);

RF_DECL (IsSubstitutable_Var);

RF_DECL (IsVar);

RF_DECL (Print_Var);

RF_DECL (Normalize_Info);

RF_DECL (Init_Vars);

RF_DECL (Get_Var);

RF_DECL (Set_Var);

RF_DECL (Vars);

RF_DECL (Set_Var_MinBound);

RF_DECL (Set_Var_MaxBound);

RF_DECL (Vars_Decl);

RF_DECL (Vars_Reset);

RF_DECL (Vars_Print);

}

}

}

}

}

namespace refal {

namespace Arithm {

RF_DECL (Add);

}

}

namespace refal {

namespace Box {

RF_DECL (Box);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Vars_Set_State);

RF_DECL (Vars_Copy_State);

}

}

}

}

}

namespace refal {

namespace Box {

RF_DECL (Put);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace refal {

namespace List {

RF_DECL (Concat);

}

}

namespace refal {

namespace Table {

RF_DECL (Bind);

RF_DECL (Lookup);

RF_DECL (ClearTable);

}

}

namespace refal {

namespace List {

RF_DECL (Map);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace refal {

namespace Table {

RF_DECL (Values);

RF_DECL (Table);

}

}

namespace refal {

namespace Box {

RF_DECL (Get);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Reset_Var);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

static Expr State;

static Expr Var_Names;

static Expr Var_Indices;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_36;

static Expr _c_8;

static Expr _c_9;

static Expr _c_37;

static Expr _c_26;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_34;

static Expr _c_32;

static Expr _c_33;

static Expr _c_35;

RF_FUNC (IsVar, (RF_ARG _ge_arg1;;), RF_VOID)
  if (_ge_arg1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  if (_v_deref__arg1.get_len () != 2)
  {
    RF_RETFAIL;
  }
  if (!_v_deref__arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_tag;
  _vs_tag = Expr (_v_deref__arg1, 0, 1);
  Expr _vt_name;
  _vt_name = Expr (_v_deref__arg1, (0 + 1), 1);
  {
    {
      if (!_vs_tag.term_eq (_c_0, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_tag.term_eq (_c_1, 0))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_tag.term_eq (_c_2, 0))
      {
        goto _block1__branch3;
      }
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_vs_tag.term_eq (_c_3, 0))
      {
        goto _block1__branch4;
      }
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_vs_tag.term_eq (_c_4, 0))
      {
        goto _block1__branch5;
      }
      goto _block1;
    }
  _block1__branch5: {}
    if (!_vs_tag.term_eq (_c_5, 0))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
RF_END

RF_FUNC (Vars_Copy_State, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, State, _ge_auxcall1);
  RF_CALL (::refal::Box::Box, _ge_auxcall1, _v_res1);
RF_END

RF_FUNC (Vars_Set_State, (RF_ARG _gt_arg1;;), RF_VOID)
  if (!_gt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_state;
  _vs_state = Expr (_gt_arg1, 0, 1);
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, _vs_state, _ge_auxcall1);
  RF_TAILCALL (::refal::Box::Store, (State, _ge_auxcall1), /*void*/);
RF_END

RF_FUNC (Init_Vars, RF_VOID, RF_VOID)
  RF_TAILCALL (::refal::Box::Store, (State, empty), /*void*/);
RF_END

RF_FUNC (Normalize_Info, (RF_ARG _ve_info, _vt_var;;), RF_VOID)
  Expr _ge_info__1;
  {
    {
      if (_ve_info.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_info, 0, _ve__dollar_tmp_m_48_m_15, _v_lsplit__info);
      for ( ; ; RF_iter(_ve_info)++)
      {
        {
          if (!RF_iter(_ve_info))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__info.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len___dollar_tmp_m_48_m_32 = (_v_len1 - _v_len2);
          if (_v_lsplit__info.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__info (Expr (_v_lsplit__info, 0));
          int _v_len3 = _v_deref__lsplit__info.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          int _v_len__len = (_v_len3 - _v_len4);
          if (!_c_6.term_eq (_v_deref__lsplit__info, 0))
          {
            goto _continue1;
          }
          Expr _ve__dollar_tmp_m_48_m_32;
          _ve__dollar_tmp_m_48_m_32 = Expr (_v_lsplit__info, (0 + 1), _v_len___dollar_tmp_m_48_m_32);
          Expr _ve_len;
          _ve_len = Expr (_v_deref__lsplit__info, (0 + 1), _v_len__len);
          Expr _ge_info__3;
          {
            {
              if (_ve_info.get_len () < 1)
              {
                goto _block2__branch1;
              }
              RF_lsplit (_ve_info, 0, _ve_1, _v_lsplit__info2);
              for ( ; ; RF_iter(_ve_info)++)
              {
                {
                  if (!RF_iter(_ve_info))
                  {
                    goto _block2__branch1;
                  }
                  int _v_len5 = _v_lsplit__info2.get_len ();
                  int _v_len6 = 1;
                  if (_v_len5 < _v_len6)
                  {
                    goto _block2__branch1;
                  }
                  int _v_len__2 = (_v_len5 - _v_len6);
                  if (_v_lsplit__info2.symbol_at (0))
                  {
                    goto _continue2;
                  }
                  Expr _v_deref__lsplit__info2 (Expr (_v_lsplit__info2, 0));
                  int _v_len7 = _v_deref__lsplit__info2.get_len ();
                  int _v_len8 = 1;
                  if (_v_len7 < _v_len8)
                  {
                    goto _continue2;
                  }
                  int _v_len__min = (_v_len7 - _v_len8);
                  if (!_c_7.term_eq (_v_deref__lsplit__info2, 0))
                  {
                    goto _continue2;
                  }
                  Expr _ve_2;
                  _ve_2 = Expr (_v_lsplit__info2, (0 + 1), _v_len__2);
                  Expr _ve_min;
                  _ve_min = Expr (_v_deref__lsplit__info2, (0 + 1), _v_len__min);
                  {
                    {
                      if (_v_len__min != _v_len__len)
                      {
                        goto _block3__branch1;
                      }
                      if (!_ve_len.eq (_ve_min, 0))
                      {
                        goto _block3__branch1;
                      }
                      _ge_info__3 = _ve_info;
                      goto _block3;
                    }
                  _block3__branch1: {}
                    _ge_info__3 = ((_c_7 + _ve_len) () + _ve_1 + _ve_2);
                  }
                _block3: {}
                  goto _exit2;
                }
            _continue2: {}
              }
            _exit2: {}
              goto _block2;
            }
          _block2__branch1: {}
            _ge_info__3 = ((_c_7 + _ve_len) () + _ve_info);
          }
        _block2: {}
          {
            {
              if (_ge_info__3.get_len () < 1)
              {
                goto _block4__branch1;
              }
              RF_lsplit (_ge_info__3, 0, _ve_1, _v_lsplit__info__3);
              for ( ; ; RF_iter(_ge_info__3)++)
              {
                {
                  if (!RF_iter(_ge_info__3))
                  {
                    goto _block4__branch1;
                  }
                  int _v_len9 = _v_lsplit__info__3.get_len ();
                  int _v_len10 = 1;
                  if (_v_len9 < _v_len10)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len__22 = (_v_len9 - _v_len10);
                  if (_v_lsplit__info__3.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  Expr _v_deref__lsplit__info__3 (Expr (_v_lsplit__info__3, 0));
                  int _v_len11 = _v_deref__lsplit__info__3.get_len ();
                  int _v_len12 = 1;
                  if (_v_len11 < _v_len12)
                  {
                    goto _continue3;
                  }
                  int _v_len__max = (_v_len11 - _v_len12);
                  if (!_c_8.term_eq (_v_deref__lsplit__info__3, 0))
                  {
                    goto _continue3;
                  }
                  Expr _ve_2;
                  _ve_2 = Expr (_v_lsplit__info__3, (0 + 1), _v_len__22);
                  Expr _ve_max;
                  _ve_max = Expr (_v_deref__lsplit__info__3, (0 + 1), _v_len__max);
                  {
                    {
                      if (_v_len__max != _v_len__len)
                      {
                        goto _block5__branch1;
                      }
                      if (!_ve_len.eq (_ve_max, 0))
                      {
                        goto _block5__branch1;
                      }
                      _ge_info__1 = _ge_info__3;
                      goto _block5;
                    }
                  _block5__branch1: {}
                    _ge_info__1 = (_ve_1 + _ve_2 + (_c_8 + _ve_len) ());
                  }
                _block5: {}
                  goto _exit3;
                }
            _continue3: {}
              }
            _exit3: {}
              goto _block4;
            }
          _block4__branch1: {}
            _ge_info__1 = (_ge_info__3 + (_c_8 + _ve_len) ());
          }
        _block4: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _ge_info__1 = _ve_info;
  }
_block1: {}
  Expr _ge_info__1__2;
  {
    {
      if (_ge_info__1.get_len () < 1)
      {
        goto _block6__branch1;
      }
      RF_lsplit (_ge_info__1, 0, _ve__dollar_tmp_m_71_m_15, _v_lsplit__info__1);
      for ( ; ; RF_iter(_ge_info__1)++)
      {
        {
          if (!RF_iter(_ge_info__1))
          {
            goto _block6__branch1;
          }
          int _v_len13 = _v_lsplit__info__1.get_len ();
          int _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _block6__branch1;
          }
          int _v_len___dollar_tmp_m_71_m_25 = (_v_len13 - _v_len14);
          if (_v_lsplit__info__1.symbol_at (0))
          {
            goto _continue4;
          }
          Expr _v_deref__lsplit__info__1 (Expr (_v_lsplit__info__1, 0));
          int _v_len15 = _v_deref__lsplit__info__1.get_len ();
          int _v_len16 = 1;
          if (_v_len15 < _v_len16)
          {
            goto _continue4;
          }
          int _v_len___dollar_tmp_m_71_m_22 = (_v_len15 - _v_len16);
          if (!_c_7.term_eq (_v_deref__lsplit__info__1, 0))
          {
            goto _continue4;
          }
          Expr _ve__dollar_tmp_m_71_m_25;
          _ve__dollar_tmp_m_71_m_25 = Expr (_v_lsplit__info__1, (0 + 1), _v_len___dollar_tmp_m_71_m_25);
          Expr _ve__dollar_tmp_m_71_m_22;
          _ve__dollar_tmp_m_71_m_22 = Expr (_v_deref__lsplit__info__1, (0 + 1), _v_len___dollar_tmp_m_71_m_22);
          _ge_info__1__2 = _ge_info__1;
          goto _exit4;
        }
    _continue4: {}
      }
    _exit4: {}
      goto _block6;
    }
  _block6__branch1: {}
    Expr _vs_min;
    {
      {
        if (_vt_var.symbol_at (0))
        {
          goto _block7__branch1;
        }
        Expr _v_deref__var (Expr (_vt_var, 0));
        int _v_len17 = _v_deref__var.get_len ();
        int _v_len18 = 1;
        if (_v_len17 < _v_len18)
        {
          goto _block7__branch1;
        }
        int _v_len___dollar_tmp_m_73_m_14 = (_v_len17 - _v_len18);
        if (!_c_0.term_eq (_v_deref__var, 0))
        {
          goto _block7__branch1;
        }
        Expr _ve__dollar_tmp_m_73_m_14;
        _ve__dollar_tmp_m_73_m_14 = Expr (_v_deref__var, (0 + 1), _v_len___dollar_tmp_m_73_m_14);
        _vs_min = _c_9;
        goto _block7;
      }
    _block7__branch1: {}
      {
        if (_vt_var.symbol_at (0))
        {
          goto _block7__branch2;
        }
        Expr _v_deref__var2 (Expr (_vt_var, 0));
        int _v_len19 = _v_deref__var2.get_len ();
        int _v_len20 = 1;
        if (_v_len19 < _v_len20)
        {
          goto _block7__branch2;
        }
        int _v_len___dollar_tmp_m_74_m_14 = (_v_len19 - _v_len20);
        if (!_c_1.term_eq (_v_deref__var2, 0))
        {
          goto _block7__branch2;
        }
        Expr _ve__dollar_tmp_m_74_m_14;
        _ve__dollar_tmp_m_74_m_14 = Expr (_v_deref__var2, (0 + 1), _v_len___dollar_tmp_m_74_m_14);
        _vs_min = _c_9;
        goto _block7;
      }
    _block7__branch2: {}
      {
        if (_vt_var.symbol_at (0))
        {
          goto _block7__branch3;
        }
        Expr _v_deref__var3 (Expr (_vt_var, 0));
        int _v_len21 = _v_deref__var3.get_len ();
        int _v_len22 = 1;
        if (_v_len21 < _v_len22)
        {
          goto _block7__branch3;
        }
        int _v_len___dollar_tmp_m_75_m_14 = (_v_len21 - _v_len22);
        if (!_c_2.term_eq (_v_deref__var3, 0))
        {
          goto _block7__branch3;
        }
        Expr _ve__dollar_tmp_m_75_m_14;
        _ve__dollar_tmp_m_75_m_14 = Expr (_v_deref__var3, (0 + 1), _v_len___dollar_tmp_m_75_m_14);
        _vs_min = _c_9;
        goto _block7;
      }
    _block7__branch3: {}
      {
        if (_vt_var.symbol_at (0))
        {
          goto _block7__branch4;
        }
        Expr _v_deref__var4 (Expr (_vt_var, 0));
        int _v_len23 = _v_deref__var4.get_len ();
        int _v_len24 = 1;
        if (_v_len23 < _v_len24)
        {
          goto _block7__branch4;
        }
        int _v_len___dollar_tmp_m_76_m_14 = (_v_len23 - _v_len24);
        if (!_c_3.term_eq (_v_deref__var4, 0))
        {
          goto _block7__branch4;
        }
        Expr _ve__dollar_tmp_m_76_m_14;
        _ve__dollar_tmp_m_76_m_14 = Expr (_v_deref__var4, (0 + 1), _v_len___dollar_tmp_m_76_m_14);
        _vs_min = _c_10;
        goto _block7;
      }
    _block7__branch4: {}
      if (_vt_var.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__var5 (Expr (_vt_var, 0));
      int _v_len25 = _v_deref__var5.get_len ();
      int _v_len26 = 1;
      if (_v_len25 < _v_len26)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len___dollar_tmp_m_77_m_14 = (_v_len25 - _v_len26);
      if (!_c_4.term_eq (_v_deref__var5, 0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve__dollar_tmp_m_77_m_14;
      _ve__dollar_tmp_m_77_m_14 = Expr (_v_deref__var5, (0 + 1), _v_len___dollar_tmp_m_77_m_14);
      _vs_min = _c_10;
    }
  _block7: {}
    _ge_info__1__2 = (_ge_info__1 + (_c_7 + _vs_min) ());
  }
_block6: {}
  Expr _ge_info__1__2__3;
  {
    {
      {
        {
          if (_vt_var.symbol_at (0))
          {
            goto _block9__branch1;
          }
          Expr _v_deref__var6 (Expr (_vt_var, 0));
          int _v_len27 = _v_deref__var6.get_len ();
          int _v_len28 = 1;
          if (_v_len27 < _v_len28)
          {
            goto _block9__branch1;
          }
          int _v_len___dollar_tmp_m_86_m_23 = (_v_len27 - _v_len28);
          if (!_c_0.term_eq (_v_deref__var6, 0))
          {
            goto _block9__branch1;
          }
          Expr _ve__dollar_tmp_m_86_m_23;
          _ve__dollar_tmp_m_86_m_23 = Expr (_v_deref__var6, (0 + 1), _v_len___dollar_tmp_m_86_m_23);
          goto _block9;
        }
      _block9__branch1: {}
        if (_vt_var.symbol_at (0))
        {
          goto _block8__branch1;
        }
        Expr _v_deref__var7 (Expr (_vt_var, 0));
        int _v_len29 = _v_deref__var7.get_len ();
        int _v_len30 = 1;
        if (_v_len29 < _v_len30)
        {
          goto _block8__branch1;
        }
        int _v_len___dollar_tmp_m_86_m_33 = (_v_len29 - _v_len30);
        if (!_c_1.term_eq (_v_deref__var7, 0))
        {
          goto _block8__branch1;
        }
        Expr _ve__dollar_tmp_m_86_m_33;
        _ve__dollar_tmp_m_86_m_33 = Expr (_v_deref__var7, (0 + 1), _v_len___dollar_tmp_m_86_m_33);
      }
    _block9: {}
      {
        {
          if (_ge_info__1__2.get_len () < 1)
          {
            goto _block10__branch1;
          }
          RF_lsplit (_ge_info__1__2, 0, _ve__dollar_tmp_m_88_m_19, _v_lsplit__info__1__2);
          for ( ; ; RF_iter(_ge_info__1__2)++)
          {
            {
              if (!RF_iter(_ge_info__1__2))
              {
                goto _block10__branch1;
              }
              int _v_len31 = _v_lsplit__info__1__2.get_len ();
              int _v_len32 = 1;
              if (_v_len31 < _v_len32)
              {
                goto _block10__branch1;
              }
              int _v_len___dollar_tmp_m_88_m_29 = (_v_len31 - _v_len32);
              if (_v_lsplit__info__1__2.symbol_at (0))
              {
                goto _continue5;
              }
              Expr _v_deref__lsplit__info__1__2 (Expr (_v_lsplit__info__1__2, 0));
              int _v_len33 = _v_deref__lsplit__info__1__2.get_len ();
              int _v_len34 = 1;
              if (_v_len33 < _v_len34)
              {
                goto _continue5;
              }
              int _v_len___dollar_tmp_m_88_m_26 = (_v_len33 - _v_len34);
              if (!_c_8.term_eq (_v_deref__lsplit__info__1__2, 0))
              {
                goto _continue5;
              }
              Expr _ve__dollar_tmp_m_88_m_29;
              _ve__dollar_tmp_m_88_m_29 = Expr (_v_lsplit__info__1__2, (0 + 1), _v_len___dollar_tmp_m_88_m_29);
              Expr _ve__dollar_tmp_m_88_m_26;
              _ve__dollar_tmp_m_88_m_26 = Expr (_v_deref__lsplit__info__1__2, (0 + 1), _v_len___dollar_tmp_m_88_m_26);
              _ge_info__1__2__3 = _ge_info__1__2;
              goto _exit5;
            }
        _continue5: {}
          }
        _exit5: {}
          goto _block10;
        }
      _block10__branch1: {}
        _ge_info__1__2__3 = (_ge_info__1__2 + _c_11);
      }
    _block10: {}
      goto _block8;
    }
  _block8__branch1: {}
    {
      {
        if (_ge_info__1__2.get_len () < 1)
        {
          goto _block11__branch1;
        }
        RF_lsplit (_ge_info__1__2, 0, _ve__dollar_tmp_m_92_m_17, _v_lsplit__info__1__22);
        for ( ; ; RF_iter(_ge_info__1__2)++)
        {
          {
            if (!RF_iter(_ge_info__1__2))
            {
              goto _block11__branch1;
            }
            int _v_len35 = _v_lsplit__info__1__22.get_len ();
            int _v_len36 = 1;
            if (_v_len35 < _v_len36)
            {
              goto _block11__branch1;
            }
            int _v_len___dollar_tmp_m_92_m_33 = (_v_len35 - _v_len36);
            if (_v_lsplit__info__1__22.symbol_at (0))
            {
              goto _continue6;
            }
            Expr _v_deref__lsplit__info__1__22 (Expr (_v_lsplit__info__1__22, 0));
            int _v_len37 = _v_deref__lsplit__info__1__22.get_len ();
            int _v_len38 = 1;
            if (_v_len37 < _v_len38)
            {
              goto _continue6;
            }
            int _v_len___dollar_tmp_m_92_m_30 = (_v_len37 - _v_len38);
            if (!_c_12.term_eq (_v_deref__lsplit__info__1__22, 0))
            {
              goto _continue6;
            }
            Expr _ve__dollar_tmp_m_92_m_33;
            _ve__dollar_tmp_m_92_m_33 = Expr (_v_lsplit__info__1__22, (0 + 1), _v_len___dollar_tmp_m_92_m_33);
            Expr _ve__dollar_tmp_m_92_m_30;
            _ve__dollar_tmp_m_92_m_30 = Expr (_v_deref__lsplit__info__1__22, (0 + 1), _v_len___dollar_tmp_m_92_m_30);
            _ge_info__1__2__3 = _ge_info__1__2;
            goto _exit6;
          }
      _continue6: {}
        }
      _exit6: {}
        goto _block11;
      }
    _block11__branch1: {}
      Expr _gs_auxcall1;
      RF_CALL (::refal::Table::Table, /*void*/, _gs_auxcall1);
      Expr _gs_auxcall2;
      RF_CALL (::refal::Table::Table, /*void*/, _gs_auxcall2);
      _ge_info__1__2__3 = (_ge_info__1__2 + (_c_12 + _gs_auxcall1) () + (_c_13 + _gs_auxcall2) ());
    }
  _block11: {}
  }
_block8: {}
  Expr _ge_info__1__2__3__4;
  {
    {
      if (_ge_info__1__2__3.get_len () < 1)
      {
        goto _block12__branch1;
      }
      RF_lsplit (_ge_info__1__2__3, 0, _ve__dollar_tmp_m_101_m_15, _v_lsplit__info__1__2__3);
      for ( ; ; RF_iter(_ge_info__1__2__3)++)
      {
        {
          if (!RF_iter(_ge_info__1__2__3))
          {
            goto _block12__branch1;
          }
          int _v_len39 = _v_lsplit__info__1__2__3.get_len ();
          int _v_len40 = 1;
          if (_v_len39 < _v_len40)
          {
            goto _block12__branch1;
          }
          int _v_len___dollar_tmp_m_101_m_28 = (_v_len39 - _v_len40);
          if (_v_lsplit__info__1__2__3.symbol_at (0))
          {
            goto _continue7;
          }
          Expr _v_deref__lsplit__info__1__2__3 (Expr (_v_lsplit__info__1__2__3, 0));
          int _v_len41 = _v_deref__lsplit__info__1__2__3.get_len ();
          int _v_len42 = 1;
          if (_v_len41 < _v_len42)
          {
            goto _continue7;
          }
          int _v_len___dollar_tmp_m_101_m_25 = (_v_len41 - _v_len42);
          if (!_c_6.term_eq (_v_deref__lsplit__info__1__2__3, 0))
          {
            goto _continue7;
          }
          Expr _ve__dollar_tmp_m_101_m_28;
          _ve__dollar_tmp_m_101_m_28 = Expr (_v_lsplit__info__1__2__3, (0 + 1), _v_len___dollar_tmp_m_101_m_28);
          Expr _ve__dollar_tmp_m_101_m_25;
          _ve__dollar_tmp_m_101_m_25 = Expr (_v_deref__lsplit__info__1__2__3, (0 + 1), _v_len___dollar_tmp_m_101_m_25);
          _ge_info__1__2__3__4 = _ge_info__1__2__3;
          goto _exit7;
        }
    _continue7: {}
      }
    _exit7: {}
      goto _block12;
    }
  _block12__branch1: {}
    {
      if (_ge_info__1__2__3.get_len () < 1)
      {
        goto _block12__branch2;
      }
      if (_ge_info__1__2__3.get_len () > ((_ge_info__1__2__3.get_len () - 1) + (_ge_info__1__2__3.get_len () - 1) + 1))
      {
        goto _block12__branch2;
      }
      if (_ge_info__1__2__3.get_len () < 1)
      {
        goto _block12__branch2;
      }
      if (_ge_info__1__2__3.get_len () > ((_ge_info__1__2__3.get_len () - 1) + (_ge_info__1__2__3.get_len () - 1) + 1))
      {
        goto _block12__branch2;
      }
      RF_lsplit (_ge_info__1__2__3, 0, _ve__dollar_tmp_m_102_m_15, _v_lsplit__info__1__2__32);
      for ( ; ; RF_iter(_ge_info__1__2__3)++)
      {
        {
          if (!RF_iter(_ge_info__1__2__3))
          {
            goto _block12__branch2;
          }
          int _v_len43 = _v_lsplit__info__1__2__32.get_len ();
          int _v_len44 = 1;
          if (_v_len43 < _v_len44)
          {
            goto _block12__branch2;
          }
          int _v_len___dollar_tmp_m_102_m_29 = (_v_len43 - _v_len44);
          if (_v_lsplit__info__1__2__32.symbol_at (0))
          {
            goto _continue8;
          }
          Expr _v_deref__lsplit__info__1__2__32 (Expr (_v_lsplit__info__1__2__32, 0));
          if (_v_deref__lsplit__info__1__2__32.get_len () != 2)
          {
            goto _continue8;
          }
          if (!_c_8.term_eq (_v_deref__lsplit__info__1__2__32, 0))
          {
            goto _continue8;
          }
          if (!_v_deref__lsplit__info__1__2__32.symbol_at ((0 + 1)))
          {
            goto _continue8;
          }
          Expr _ve__dollar_tmp_m_102_m_29;
          _ve__dollar_tmp_m_102_m_29 = Expr (_v_lsplit__info__1__2__32, (0 + 1), _v_len___dollar_tmp_m_102_m_29);
          Expr _vs_max;
          _vs_max = Expr (_v_deref__lsplit__info__1__2__32, (0 + 1), 1);
          RF_lsplit (_ge_info__1__2__3, 0, _ve__dollar_tmp_m_102_m_41, _v_lsplit__info__1__2__33);
          for ( ; ; RF_iter(_ge_info__1__2__3)++)
          {
            {
              if (!RF_iter(_ge_info__1__2__3))
              {
                goto _continue8;
              }
              int _v_len45 = _v_lsplit__info__1__2__33.get_len ();
              int _v_len46 = 1;
              if (_v_len45 < _v_len46)
              {
                goto _continue8;
              }
              int _v_len___dollar_tmp_m_102_m_55 = (_v_len45 - _v_len46);
              if (_v_lsplit__info__1__2__33.symbol_at (0))
              {
                goto _continue9;
              }
              Expr _v_deref__lsplit__info__1__2__33 (Expr (_v_lsplit__info__1__2__33, 0));
              if (_v_deref__lsplit__info__1__2__33.get_len () != 2)
              {
                goto _continue9;
              }
              if (!_c_7.term_eq (_v_deref__lsplit__info__1__2__33, 0))
              {
                goto _continue9;
              }
              if (!_vs_max.term_eq (_v_deref__lsplit__info__1__2__33, (0 + 1)))
              {
                goto _continue9;
              }
              Expr _ve__dollar_tmp_m_102_m_55;
              _ve__dollar_tmp_m_102_m_55 = Expr (_v_lsplit__info__1__2__33, (0 + 1), _v_len___dollar_tmp_m_102_m_55);
              _ge_info__1__2__3__4 = (_ge_info__1__2__3 + (_c_6 + _vs_max) ());
              goto _exit9;
            }
        _continue9: {}
          }
        _exit9: {}
          goto _exit8;
        }
    _continue8: {}
      }
    _exit8: {}
      goto _block12;
    }
  _block12__branch2: {}
    _ge_info__1__2__3__4 = _ge_info__1__2__3;
  }
_block12: {}
  Expr _ge_info__1__2__3__4__5;
  {
    {
      if (_ge_info__1__2__3__4.get_len () < 1)
      {
        goto _block13__branch1;
      }
      RF_lsplit (_ge_info__1__2__3__4, 0, _ve__dollar_tmp_m_110_m_15, _v_lsplit__info__1__2__3__4);
      for ( ; ; RF_iter(_ge_info__1__2__3__4)++)
      {
        {
          if (!RF_iter(_ge_info__1__2__3__4))
          {
            goto _block13__branch1;
          }
          int _v_len47 = _v_lsplit__info__1__2__3__4.get_len ();
          int _v_len48 = 1;
          if (_v_len47 < _v_len48)
          {
            goto _block13__branch1;
          }
          int _v_len___dollar_tmp_m_110_m_28 = (_v_len47 - _v_len48);
          if (_v_lsplit__info__1__2__3__4.symbol_at (0))
          {
            goto _continue10;
          }
          Expr _v_deref__lsplit__info__1__2__3__4 (Expr (_v_lsplit__info__1__2__3__4, 0));
          int _v_len49 = _v_deref__lsplit__info__1__2__3__4.get_len ();
          int _v_len50 = 1;
          if (_v_len49 < _v_len50)
          {
            goto _continue10;
          }
          int _v_len___dollar_tmp_m_110_m_25 = (_v_len49 - _v_len50);
          if (!_c_6.term_eq (_v_deref__lsplit__info__1__2__3__4, 0))
          {
            goto _continue10;
          }
          Expr _ve__dollar_tmp_m_110_m_28;
          _ve__dollar_tmp_m_110_m_28 = Expr (_v_lsplit__info__1__2__3__4, (0 + 1), _v_len___dollar_tmp_m_110_m_28);
          Expr _ve__dollar_tmp_m_110_m_25;
          _ve__dollar_tmp_m_110_m_25 = Expr (_v_deref__lsplit__info__1__2__3__4, (0 + 1), _v_len___dollar_tmp_m_110_m_25);
          _ge_info__1__2__3__4__5 = _ge_info__1__2__3__4;
          goto _exit10;
        }
    _continue10: {}
      }
    _exit10: {}
      goto _block13;
    }
  _block13__branch1: {}
    {
      if (_ge_info__1__2__3__4.get_len () < 1)
      {
        goto _block13__branch2;
      }
      RF_lsplit (_ge_info__1__2__3__4, 0, _ve__dollar_tmp_m_111_m_15, _v_lsplit__info__1__2__3__42);
      for ( ; ; RF_iter(_ge_info__1__2__3__4)++)
      {
        {
          if (!RF_iter(_ge_info__1__2__3__4))
          {
            goto _block13__branch2;
          }
          int _v_len51 = _v_lsplit__info__1__2__3__42.get_len ();
          int _v_len52 = 1;
          if (_v_len51 < _v_len52)
          {
            goto _block13__branch2;
          }
          int _v_len___dollar_tmp_m_111_m_40 = (_v_len51 - _v_len52);
          if (!_c_14.term_eq (_v_lsplit__info__1__2__3__42, 0))
          {
            goto _continue11;
          }
          Expr _ve__dollar_tmp_m_111_m_40;
          _ve__dollar_tmp_m_111_m_40 = Expr (_v_lsplit__info__1__2__3__42, (0 + 1), _v_len___dollar_tmp_m_111_m_40);
          _ge_info__1__2__3__4__5 = (_ge_info__1__2__3__4 + (_c_6 + (_c_15 + _vt_var) ()) ());
          goto _exit11;
        }
    _continue11: {}
      }
    _exit11: {}
      goto _block13;
    }
  _block13__branch2: {}
    _ge_info__1__2__3__4__5 = _ge_info__1__2__3__4;
  }
_block13: {}
  RF_TAILCALL (::refal::Box::Put, (State, (_vt_var + _ge_info__1__2__3__4__5) ()), /*void*/);
RF_END

RF_FUNC (Set_Var, (RF_ARG _ve_info, _vt_var;;), RF_VOID)
  Expr _ge_info__1;
  Expr _gt_var__1;
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, State, _v_Get1);
      if (_v_Get1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_v_Get1, 0, _v_rsplit__Get1, _ve_2);
      for ( ; ; RF_iter(_v_Get1)--)
      {
        {
          if (!RF_iter(_v_Get1))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_rsplit__Get1.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__1 = (_v_len1 - _v_len2);
          if (_v_rsplit__Get1.symbol_at ((0 + _v_len__1)))
          {
            goto _continue1;
          }
          Expr _v_deref__rsplit__Get1 (Expr (_v_rsplit__Get1, (0 + _v_len__1)));
          int _v_len3 = _v_deref__rsplit__Get1.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          int _v_len__old__info = (_v_len3 - _v_len4);
          if (!_vt_var.term_eq (_v_deref__rsplit__Get1, 0))
          {
            goto _continue1;
          }
          Expr _ve_1;
          _ve_1 = Expr (_v_rsplit__Get1, 0, _v_len__1);
          Expr _ve_old__info;
          _ve_old__info = Expr (_v_deref__rsplit__Get1, (0 + 1), _v_len__old__info);
          Expr _ge_info__2 (_ve_info);
          Expr _ve_new__info;
          for ( ; ; )
          {
            {
              if (_ve_old__info.get_len () != 0)
              {
                goto _iter1;
              }
              RF_CALL (::refal::Box::Store, (State, (_ve_1 + _ve_2)), /*void*/);
              _ge_info__1 = (_ge_info__2 + _ve_new__info);
              _gt_var__1 = _vt_var;
              goto _exit__iter1;
            }
          _iter1: {}
            int _v_len5 = _ve_old__info.get_len ();
            int _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__rest = (_v_len5 - _v_len6);
            if (_ve_old__info.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__old__info (Expr (_ve_old__info, 0));
            int _v_len7 = _v_deref__old__info.get_len ();
            int _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__val = (_v_len7 - _v_len8);
            Expr _ve_rest;
            _ve_rest = Expr (_ve_old__info, (0 + 1), _v_len__rest);
            Expr _vt_key;
            _vt_key = Expr (_v_deref__old__info, 0, 1);
            Expr _ve_val;
            _ve_val = Expr (_v_deref__old__info, (0 + 1), _v_len__val);
            Expr _ge_info__2__5;
            Expr _vt_item;
            {
              {
                if (_ge_info__2.get_len () < 1)
                {
                  goto _block3__branch1;
                }
                RF_lsplit (_ge_info__2, 0, _ve_3, _v_lsplit__info__2);
                for ( ; ; RF_iter(_ge_info__2)++)
                {
                  {
                    if (!RF_iter(_ge_info__2))
                    {
                      goto _block3__branch1;
                    }
                    int _v_len9 = _v_lsplit__info__2.get_len ();
                    int _v_len10 = 1;
                    if (_v_len9 < _v_len10)
                    {
                      goto _block3__branch1;
                    }
                    int _v_len__4 = (_v_len9 - _v_len10);
                    if (_v_lsplit__info__2.symbol_at (0))
                    {
                      goto _continue2;
                    }
                    Expr _v_deref__lsplit__info__2 (Expr (_v_lsplit__info__2, 0));
                    int _v_len11 = _v_deref__lsplit__info__2.get_len ();
                    int _v_len12 = 1;
                    if (_v_len11 < _v_len12)
                    {
                      goto _continue2;
                    }
                    int _v_len__new__val = (_v_len11 - _v_len12);
                    if (!_vt_key.term_eq (_v_deref__lsplit__info__2, 0))
                    {
                      goto _continue2;
                    }
                    Expr _ve_4;
                    _ve_4 = Expr (_v_lsplit__info__2, (0 + 1), _v_len__4);
                    Expr _ve_new__val;
                    _ve_new__val = Expr (_v_deref__lsplit__info__2, (0 + 1), _v_len__new__val);
                    _ge_info__2__5 = (_ve_3 + _ve_4);
                    _vt_item = (_vt_key + _ve_new__val) ();
                    goto _exit2;
                  }
              _continue2: {}
                }
              _exit2: {}
                goto _block3;
              }
            _block3__branch1: {}
              _ge_info__2__5 = _ge_info__2;
              _vt_item = (_vt_key + _ve_val) ();
            }
          _block3: {}
            _ve_old__info = _ve_rest;
            _ge_info__2 = _ge_info__2__5;
            _ve_new__info = (_ve_new__info + _vt_item);
          }
        _exit__iter1: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _ge_info__1 = _ve_info;
    _gt_var__1 = _vt_var;
  }
_block1: {}
  RF_TAILCALL (Normalize_Info, (_ge_info__1, _gt_var__1), /*void*/);
RF_END

RF_FUNC (Get_Var, (RF_ARG _gt_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  if ((_ge_arg2.get_len () + 1) != 2)
  {
    RF_RETFAIL;
  }
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2));
  Expr _vt_key;
  _vt_key = Expr (_v_compose1, 0, 1);
  Expr _vt_var;
  _vt_var = Expr (_v_compose1, (0 + 1), 1);
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, State, _v_Get1);
  if (_v_Get1.get_len () < 1)
  {
    RF_RETFAIL;
  }
  RF_rsplit (_v_Get1, 0, _v_rsplit__Get1, _ve_2);
  for ( ; ; RF_iter(_v_Get1)--)
  {
    {
      if (!RF_iter(_v_Get1))
      {
        RF_RETFAIL;
      }
      int _v_len1 = _v_rsplit__Get1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_RETFAIL;
      }
      int _v_len__1 = (_v_len1 - _v_len2);
      if (_v_rsplit__Get1.symbol_at ((0 + _v_len__1)))
      {
        goto _continue1;
      }
      Expr _v_deref__rsplit__Get1 (Expr (_v_rsplit__Get1, (0 + _v_len__1)));
      int _v_len3 = _v_deref__rsplit__Get1.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _continue1;
      }
      int _v_len__info = (_v_len3 - _v_len4);
      if (!_vt_var.term_eq (_v_deref__rsplit__Get1, 0))
      {
        goto _continue1;
      }
      Expr _ve_1;
      _ve_1 = Expr (_v_rsplit__Get1, 0, _v_len__1);
      Expr _ve_info;
      _ve_info = Expr (_v_deref__rsplit__Get1, (0 + 1), _v_len__info);
      {
        {
          if (_v_len__info < 1)
          {
            goto _block1__branch1;
          }
          RF_lsplit (_ve_info, 0, _ve__dollar_tmp_m_135_m_15, _v_lsplit__info);
          for ( ; ; RF_iter(_ve_info)++)
          {
            {
              if (!RF_iter(_ve_info))
              {
                goto _block1__branch1;
              }
              int _v_len5 = _v_lsplit__info.get_len ();
              int _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block1__branch1;
              }
              int _v_len___dollar_tmp_m_135_m_31 = (_v_len5 - _v_len6);
              if (_v_lsplit__info.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__info (Expr (_v_lsplit__info, 0));
              int _v_len7 = _v_deref__lsplit__info.get_len ();
              int _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _continue2;
              }
              int _v_len__val = (_v_len7 - _v_len8);
              if (!_vt_key.term_eq (_v_deref__lsplit__info, 0))
              {
                goto _continue2;
              }
              Expr _ve__dollar_tmp_m_135_m_31;
              _ve__dollar_tmp_m_135_m_31 = Expr (_v_lsplit__info, (0 + 1), _v_len___dollar_tmp_m_135_m_31);
              Expr _ve_val;
              _ve_val = Expr (_v_deref__lsplit__info, (0 + 1), _v_len__val);
              _v_res1 = _ve_val;
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _block1;
        }
      _block1__branch1: {}
        _v_res1 = empty;
      }
    _block1: {}
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Set_Var_MaxBound, (RF_ARG _vt_var, _vs_idx, _ve_bound;;), RF_VOID)
  Expr _v_Get__Var1;
  if (!RF_CALL (Get_Var, (_c_12, _vt_var), _v_Get__Var1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Get__Var1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get__Var1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_tab;
  _vs_tab = Expr (_v_Get__Var1, 0, 1);
  RF_TAILCALL (::refal::Table::Bind, (_vs_tab, _vs_idx, _ve_bound), /*void*/);
RF_END

RF_FUNC (Set_Var_MinBound, (RF_ARG _vt_var, _vs_idx, _ve_bound;;), RF_VOID)
  Expr _v_Get__Var1;
  if (!RF_CALL (Get_Var, (_c_13, _vt_var), _v_Get__Var1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Get__Var1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get__Var1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_tab;
  _vs_tab = Expr (_v_Get__Var1, 0, 1);
  RF_TAILCALL (::refal::Table::Bind, (_vs_tab, _vs_idx, _ve_bound), /*void*/);
RF_END

RF_FUNC (Get_Var_Max, (RF_ARG _vt_var;;), (RF_RES _v_res1;;))
  Expr _v_Get__Var1;
  if (!RF_CALL (Get_Var, (_c_12, _vt_var), _v_Get__Var1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Get__Var1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get__Var1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_tab;
  _vs_tab = Expr (_v_Get__Var1, 0, 1);
  Expr _ge_auxcall1;
  if (!RF_CALL (Get_Var, (_c_8, _vt_var), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ge_auxcall2;
  RF_CALL (::refal::Table::Values, _vs_tab, _ge_auxcall2);
  Expr _ge_auxcall3;
  RF_CALL (::refal::List::Concat, _ge_auxcall2, _ge_auxcall3);
  RF_TAILCALL (org::refal::plus::compiler::rfp_asail::ASAIL_MIN, (_ge_auxcall1 + _ge_auxcall3), _v_res1);
RF_END

RF_FUNC (Get_Var_Min, (RF_ARG _vt_var;;), (RF_RES _v_res1;;))
  Expr _v_Get__Var1;
  if (!RF_CALL (Get_Var, (_c_13, _vt_var), _v_Get__Var1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_Get__Var1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get__Var1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_tab;
  _vs_tab = Expr (_v_Get__Var1, 0, 1);
  Expr _ge_auxcall1;
  if (!RF_CALL (Get_Var, (_c_7, _vt_var), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ge_auxcall2;
  RF_CALL (::refal::Table::Values, _vs_tab, _ge_auxcall2);
  Expr _ge_auxcall3;
  RF_CALL (::refal::List::Concat, _ge_auxcall2, _ge_auxcall3);
  RF_TAILCALL (org::refal::plus::compiler::rfp_asail::ASAIL_MAX, (_ge_auxcall1 + _ge_auxcall3), _v_res1);
RF_END

RF_FUNC (Vars_Reset, (RF_ARG _ve_vars;;), RF_VOID)
  Expr _v_Map1;
  if (!RF_CALL (::refal::List::Map, (_c_16, empty, _ve_vars), _v_Map1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len1 = _v_Map1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len___dollar_tmp_m_159_m_50 = (_v_len1 - _v_len2);
  Expr _ve__dollar_tmp_m_159_m_50;
  _ve__dollar_tmp_m_159_m_50 = Expr (_v_Map1, 0, _v_len___dollar_tmp_m_159_m_50);
RF_END

RF_FUNC (Reset_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_var;
  _vt_var = Expr (_ge_arg1, 0, 1);
  Expr _ge_auxalt1;
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, State, _v_Get1);
      if (_v_Get1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_v_Get1, 0, _v_rsplit__Get1, _ve_2);
      for ( ; ; RF_iter(_v_Get1)--)
      {
        {
          if (!RF_iter(_v_Get1))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_rsplit__Get1.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__1 = (_v_len1 - _v_len2);
          if (_v_rsplit__Get1.symbol_at ((0 + _v_len__1)))
          {
            goto _continue1;
          }
          Expr _v_deref__rsplit__Get1 (Expr (_v_rsplit__Get1, (0 + _v_len__1)));
          int _v_len3 = _v_deref__rsplit__Get1.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          int _v_len__info = (_v_len3 - _v_len4);
          if (!_vt_var.term_eq (_v_deref__rsplit__Get1, 0))
          {
            goto _continue1;
          }
          Expr _ve_1;
          _ve_1 = Expr (_v_rsplit__Get1, 0, _v_len__1);
          Expr _ve_info;
          _ve_info = Expr (_v_deref__rsplit__Get1, (0 + 1), _v_len__info);
          RF_CALL (::refal::Box::Store, (State, (_ve_1 + _ve_2)), /*void*/);
          _ge_auxalt1 = _ve_info;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _ge_auxalt1 = empty;
  }
_block1: {}
  Expr _ve_decl;
  {
    {
      if (_ge_auxalt1.get_len () < 1)
      {
        goto _block2__branch1;
      }
      RF_lsplit (_ge_auxalt1, 0, _ve__dollar_tmp_m_169_m_6, _v_lsplit__auxalt1);
      for ( ; ; RF_iter(_ge_auxalt1)++)
      {
        {
          if (!RF_iter(_ge_auxalt1))
          {
            goto _block2__branch1;
          }
          int _v_len5 = _v_lsplit__auxalt1.get_len ();
          int _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch1;
          }
          int _v_len___dollar_tmp_m_169_m_22 = (_v_len5 - _v_len6);
          if (_v_lsplit__auxalt1.symbol_at (0))
          {
            goto _continue2;
          }
          Expr _v_deref__lsplit__auxalt1 (Expr (_v_lsplit__auxalt1, 0));
          if (_v_deref__lsplit__auxalt1.get_len () != 2)
          {
            goto _continue2;
          }
          if (!_c_17.term_eq (_v_deref__lsplit__auxalt1, 0))
          {
            goto _continue2;
          }
          if (!_v_deref__lsplit__auxalt1.symbol_at ((0 + 1)))
          {
            goto _continue2;
          }
          Expr _ve__dollar_tmp_m_169_m_22;
          _ve__dollar_tmp_m_169_m_22 = Expr (_v_lsplit__auxalt1, (0 + 1), _v_len___dollar_tmp_m_169_m_22);
          Expr _gs_decl__3;
          _gs_decl__3 = Expr (_v_deref__lsplit__auxalt1, (0 + 1), 1);
          _ve_decl = (_c_17 + _gs_decl__3) ();
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _block2;
    }
  _block2__branch1: {}
    int _v_len7 = _ge_auxalt1.get_len ();
    int _v_len8 = 0;
    if (_v_len7 < _v_len8)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len___dollar_tmp_m_170_m_6 = (_v_len7 - _v_len8);
    Expr _ve__dollar_tmp_m_170_m_6;
    _ve__dollar_tmp_m_170_m_6 = Expr (_ge_auxalt1, 0, _v_len___dollar_tmp_m_170_m_6);
    _ve_decl = empty;
  }
_block2: {}
  RF_CALL (Normalize_Info, ((_c_14 + _ve_decl), _vt_var), /*void*/);
  _v_res1 = empty;
RF_END

RF_FUNC (Gener_Len_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_var;
  _vt_var = Expr (_ge_arg1, 0, 1);
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, State, _v_Get1);
  if (_v_Get1.get_len () < 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_rsplit (_v_Get1, 0, _v_rsplit__Get1, _ve_2);
  for ( ; ; RF_iter(_v_Get1)--)
  {
    {
      if (!RF_iter(_v_Get1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len1 = _v_rsplit__Get1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__1 = (_v_len1 - _v_len2);
      if (_v_rsplit__Get1.symbol_at ((0 + _v_len__1)))
      {
        goto _continue1;
      }
      Expr _v_deref__rsplit__Get1 (Expr (_v_rsplit__Get1, (0 + _v_len__1)));
      int _v_len3 = _v_deref__rsplit__Get1.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _continue1;
      }
      int _v_len__info = (_v_len3 - _v_len4);
      if (!_vt_var.term_eq (_v_deref__rsplit__Get1, 0))
      {
        goto _continue1;
      }
      Expr _ve_1;
      _ve_1 = Expr (_v_rsplit__Get1, 0, _v_len__1);
      Expr _ve_info;
      _ve_info = Expr (_v_deref__rsplit__Get1, (0 + 1), _v_len__info);
      RF_CALL (Set_Var, (_ve_info, (_c_5 + _vt_var) ()), /*void*/);
      _v_res1 = (_c_5 + _vt_var) ();
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Vars_Print, (RF_ARG _ve_vars;;), (RF_RES _v_res1;;))
  _v_res1 = _ve_vars;
RF_END

RF_FUNC (Print_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _vt_1;
      _vt_1 = Expr (_ge_arg1, 0, 1);
      _v_res1 = _vt_1;
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
    if (_v_deref__arg1.get_len () != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v_deref__arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v_deref__arg1.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_tag;
    _vs_tag = Expr (_v_deref__arg1, 0, 1);
    Expr _vs_box;
    _vs_box = Expr (_v_deref__arg1, (0 + 1), 1);
    _v_res1 = (_vs_tag + _vs_box) ();
  }
_block1: {}
RF_END

RF_FUNC (Vars_Decl, (RF_ARG _vs_type, _ve_vars;;), (RF_RES _v_res1;;))
  if (!RF_CALL (::refal::List::Map, (_c_18, _vs_type, _ve_vars), _v_res1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
RF_END

RF_FUNC (Decl_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_type;
  _vs_type = Expr (_ge_arg1, 0, 1);
  Expr _vt_var;
  _vt_var = Expr (_ge_arg1, (0 + 1), 1);
  {
    {
      Expr _v_Get__Var1;
      if (!RF_CALL (Get_Var, (_c_17, _vt_var), _v_Get__Var1))
      {
        goto _block1__branch1;
      }
      if (_v_Get__Var1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Get__Var1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_box;
      _vs_box = Expr (_v_Get__Var1, 0, 1);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ge_auxcall1;
    RF_CALL (Print_Var, _vt_var, _ge_auxcall1);
    Expr _vs_decl;
    RF_CALL (::refal::Box::Box, (_c_19 + _vs_type + _ge_auxcall1) (), _vs_decl);
    RF_CALL (Set_Var, ((_c_17 + _vs_decl) (), _vt_var), /*void*/);
    _v_res1 = (_c_20 + _vs_decl) ();
  }
_block1: {}
RF_END

RF_FUNC (Create_Int_Var, (RF_ARG _ve_prefix, _vt_var, _ve_expr;;), (RF_RES _v_res1, _v_res2;;))
  Expr _vt_int__var;
  {
    {
      if (!_vt_var.term_eq (_c_21, 0))
      {
        goto _block1__branch1;
      }
      Expr _gs_auxcall1;
      RF_CALL (::refal::Box::Box, (_c_10 + _ve_prefix), _gs_auxcall1);
      _vt_int__var = (_c_4 + _gs_auxcall1) ();
      goto _block1;
    }
  _block1__branch1: {}
    Expr _gs_auxcall2;
    RF_CALL (::refal::Box::Box, (_c_9 + _ve_prefix + _vt_var), _gs_auxcall2);
    _vt_int__var = (_c_4 + _gs_auxcall2) ();
  }
_block1: {}
  _v_res1 = (_c_22 + _vt_int__var) ();
  _v_res2 = (_c_19 + (_c_22 + _vt_int__var) () + _ve_expr) ();
RF_END

RF_FUNC (Gener_Vars, (RF_ARG _ve_format, _ve_prefix;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ve_format.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__Fe = (_v_len1 - _v_len2);
      if (_ve_format.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__format (Expr (_ve_format, 0));
      if (_v_deref__format.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_deref__format.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_Fe;
      _ve_Fe = Expr (_ve_format, (0 + 1), _v_len__Fe);
      Expr _vs_tag;
      _vs_tag = Expr (_v_deref__format, 0, 1);
      {
        {
          {
            {
              if (!_vs_tag.term_eq (_c_3, 0))
              {
                goto _block3__branch1;
              }
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (!_vs_tag.term_eq (_c_2, 0))
              {
                goto _block3__branch2;
              }
              goto _block3;
            }
          _block3__branch2: {}
            {
              if (!_vs_tag.term_eq (_c_1, 0))
              {
                goto _block3__branch3;
              }
              goto _block3;
            }
          _block3__branch3: {}
            if (!_vs_tag.term_eq (_c_0, 0))
            {
              goto _block2__branch1;
            }
          }
        _block3: {}
          Expr _gs_auxcall1;
          RF_CALL (::refal::Box::Box, (_c_10 + _ve_prefix), _gs_auxcall1);
          Expr _v_Gener__Vars1;
          RF_CALL (Gener_Vars, (_ve_Fe, _ve_prefix), _v_Gener__Vars1);
          _v_res1 = ((_vs_tag + _gs_auxcall1) () + _v_Gener__Vars1);
          goto _block2;
        }
      _block2__branch1: {}
        Expr _gs_auxcall2;
        RF_CALL (::refal::Box::Box, (_c_9 + _ve_prefix), _gs_auxcall2);
        Expr _v_Gener__Vars2;
        RF_CALL (Gener_Vars, (_ve_Fe, _ve_prefix), _v_Gener__Vars2);
        _v_res1 = ((_vs_tag + _gs_auxcall2) () + _v_Gener__Vars2);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len3 = _ve_format.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      int _v_len__2 = (_v_len3 - _v_len4);
      if (_ve_format.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__format2 (Expr (_ve_format, 0));
      int _v_len5 = _v_deref__format2.get_len ();
      int _v_len6 = 1;
      if (_v_len5 < (_v_len6 + 1))
      {
        goto _block1__branch2;
      }
      int _v_len__1 = (_v_len5 - _v_len6);
      if (!_c_23.term_eq (_v_deref__format2, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_2;
      _ve_2 = Expr (_ve_format, (0 + 1), _v_len__2);
      Expr _vv_1;
      _vv_1 = Expr (_v_deref__format2, (0 + 1), _v_len__1);
      Expr _ge_auxcall3;
      RF_CALL (Gener_Vars, (_vv_1, _ve_prefix), _ge_auxcall3);
      Expr _v_Gener__Vars3;
      RF_CALL (Gener_Vars, (_ve_2, _ve_prefix), _v_Gener__Vars3);
      _v_res1 = ((_c_23 + _ge_auxcall3) () + _v_Gener__Vars3);
      goto _block1;
    }
  _block1__branch2: {}
    {
      int _v_len7 = _ve_format.get_len ();
      int _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch3;
      }
      int _v_len__Fe2 = (_v_len7 - _v_len8);
      Expr _vt_Ft;
      _vt_Ft = Expr (_ve_format, 0, 1);
      Expr _ve_Fe;
      _ve_Fe = Expr (_ve_format, (0 + 1), _v_len__Fe2);
      Expr _v_Gener__Vars4;
      RF_CALL (Gener_Vars, (_ve_Fe, _ve_prefix), _v_Gener__Vars4);
      _v_res1 = (_vt_Ft + _v_Gener__Vars4);
      goto _block1;
    }
  _block1__branch3: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Gener_Err_Var, RF_VOID, (RF_RES _v_res1;;))
  Expr _gs_auxcall1;
  RF_CALL (::refal::Box::Box, _c_24, _gs_auxcall1);
  _v_res1 = (_c_3 + _gs_auxcall1) ();
RF_END

RF_FUNC (Gener_Subst_Vars, (RF_ARG _ve_format, _ve_prefix;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Gener_Vars, (_ve_format, (_c_25 + _ve_prefix)), _v_res1);
RF_END

RF_FUNC (IsSubstitutable_Var, (RF_ARG _ge_arg1;;), RF_VOID)
  if (_ge_arg1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  if (_v_deref__arg1.get_len () != 2)
  {
    RF_RETFAIL;
  }
  if (!_v_deref__arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  if (!_v_deref__arg1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_tag;
  _vs_tag = Expr (_v_deref__arg1, 0, 1);
  Expr _vs_box;
  _vs_box = Expr (_v_deref__arg1, (0 + 1), 1);
  {
    {
      if (!_vs_tag.term_eq (_c_3, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_tag.term_eq (_c_2, 0))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_tag.term_eq (_c_1, 0))
      {
        goto _block1__branch3;
      }
      goto _block1;
    }
  _block1__branch3: {}
    if (!_vs_tag.term_eq (_c_0, 0))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, _vs_box, _v_Get1);
  int _v_len1 = _v_Get1.get_len ();
  int _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len___dollar_tmp_m_254_m_28 = (_v_len1 - _v_len2);
  if (!_c_26.eq (_v_Get1, 0))
  {
    RF_RETFAIL;
  }
  Expr _ve__dollar_tmp_m_254_m_28;
  _ve__dollar_tmp_m_254_m_28 = Expr (_v_Get1, (0 + 1 + 1), _v_len___dollar_tmp_m_254_m_28);
RF_END

RF_FUNC (Gener_Var_Assign, (RF_ARG _gt_arg1, _ge_arg2;;), RF_VOID)
  if ((_ge_arg2.get_len () + 1) != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_compose1 ((_gt_arg1 + _ge_arg2));
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (Expr (_v_compose1, (0 + 1)));
  if (_v_deref__compose1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_var;
  _vt_var = Expr (_v_compose1, 0, 1);
  Expr _vs_tag;
  _vs_tag = Expr (_v_deref__compose1, 0, 1);
  Expr _vs_box;
  _vs_box = Expr (_v_deref__compose1, (0 + 1), 1);
  Expr _ge_auxcall1;
  RF_CALL (Print_Var, _vt_var, _ge_auxcall1);
  RF_CALL (::refal::Box::Store, (_vs_box, _ge_auxcall1), /*void*/);
  {
    {
      Expr _v_Get__Var1;
      if (!RF_CALL (Get_Var, (_c_17, _vt_var), _v_Get__Var1))
      {
        goto _block1__branch1;
      }
      if (_v_Get__Var1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Get__Var1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs__dollar_tmp_m_272_m_29;
      _vs__dollar_tmp_m_272_m_29 = Expr (_v_Get__Var1, 0, 1);
      Expr _v_Get__Var2;
      if (!RF_CALL (Get_Var, (_c_17, (_vs_tag + _vs_box) ()), _v_Get__Var2))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Get__Var2.get_len () != 1)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (!_v_Get__Var2.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_decl__box;
      _vs_decl__box = Expr (_v_Get__Var2, 0, 1);
      RF_TAILCALL (::refal::Box::Store, (_vs_decl__box, empty), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    Expr _ge_auxcall2;
    if (!RF_CALL (Get_Var, (_c_17, (_vs_tag + _vs_box) ()), _ge_auxcall2))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    RF_TAILCALL (Set_Var, ((_c_17 + _ge_auxcall2) (), _vt_var), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Gener_Var_Names, (RF_ARG _ve_xpr;;), (RF_RES _v_res1;;))
  RF_CALL (::refal::Box::Store, (Var_Names, empty), /*void*/);
  RF_CALL (::refal::Table::ClearTable, Var_Indices, /*void*/);
  RF_TAILCALL (Boxes_To_Vars, _ve_xpr, _v_res1);
RF_END

RF_FUNC (Boxes_To_Vars, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__xpr = (_v_len1 - _v_len2);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
      if (_v_deref__arg1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (!_v_deref__arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_xpr;
      _ve_xpr = Expr (_ge_arg1, (0 + 1), _v_len__xpr);
      Expr _vs_tag;
      _vs_tag = Expr (_v_deref__arg1, 0, 1);
      Expr _vs_box;
      _vs_box = Expr (_v_deref__arg1, (0 + 1), 1);
      {
        {
          if (!_vs_tag.term_eq (_c_3, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (!_vs_tag.term_eq (_c_2, 0))
          {
            goto _block2__branch2;
          }
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (!_vs_tag.term_eq (_c_1, 0))
          {
            goto _block2__branch3;
          }
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (!_vs_tag.term_eq (_c_0, 0))
          {
            goto _block2__branch4;
          }
          goto _block2;
        }
      _block2__branch4: {}
        if (!_vs_tag.term_eq (_c_4, 0))
        {
          goto _block1__branch1;
        }
      }
    _block2: {}
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, _vs_box, _v_Get1);
      {
        {
          int _v_len3 = _v_Get1.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block3__branch1;
          }
          int _v_len__name = (_v_len3 - _v_len4);
          if (!_c_10.term_eq (_v_Get1, 0))
          {
            goto _block3__branch1;
          }
          Expr _ve_name;
          _ve_name = Expr (_v_Get1, (0 + 1), _v_len__name);
          Expr _ge_name__5;
          {
            {
              int _v_len5 = _v_len__name;
              int _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block4__branch1;
              }
              int _v_len__n = (_v_len5 - _v_len6);
              if (!_c_25.term_eq (_ve_name, 0))
              {
                goto _block4__branch1;
              }
              Expr _ve_n;
              _ve_n = Expr (_ve_name, (0 + 1), _v_len__n);
              _ge_name__5 = _ve_n;
              goto _block4;
            }
          _block4__branch1: {}
            _ge_name__5 = _ve_name;
          }
        _block4: {}
          Expr _gs_auxcall1;
          RF_CALL (::refal::Convert::ToWord, _ge_name__5, _gs_auxcall1);
          Expr _gs_auxcall2;
          RF_CALL (Gener_Name, (_c_27, _gs_auxcall1), _gs_auxcall2);
          Expr _vt_var ((_c_4 + _gs_auxcall2 ()) ());
          RF_CALL (::refal::Box::Store, (_vs_box, _vt_var), /*void*/);
          Expr _v_Boxes__To__Vars1;
          RF_CALL (Boxes_To_Vars, _ve_xpr, _v_Boxes__To__Vars1);
          _v_res1 = (_vt_var + _v_Boxes__To__Vars1);
          goto _block3;
        }
      _block3__branch1: {}
        {
          int _v_len7 = _v_Get1.get_len ();
          int _v_len8 = 2;
          if (_v_len7 < _v_len8)
          {
            goto _block3__branch2;
          }
          int _v_len__prefix = (_v_len7 - _v_len8);
          if (!_c_9.term_eq (_v_Get1, 0))
          {
            goto _block3__branch2;
          }
          Expr _ve_prefix;
          _ve_prefix = Expr (_v_Get1, (0 + 1), _v_len__prefix);
          Expr _vt_var;
          _vt_var = Expr (_v_Get1, (0 + 1 + _v_len__prefix), 1);
          Expr _v_Boxes__To__Vars2;
          RF_CALL (Boxes_To_Vars, _vt_var, _v_Boxes__To__Vars2);
          Expr _ve_name;
          {
            {
              if (_v_Boxes__To__Vars2.get_len () != 1)
              {
                goto _block5__branch1;
              }
              if (_v_Boxes__To__Vars2.symbol_at (0))
              {
                goto _block5__branch1;
              }
              Expr _v_deref__Boxes__To__Vars2 (Expr (_v_Boxes__To__Vars2, 0));
              if (_v_deref__Boxes__To__Vars2.get_len () != 2)
              {
                goto _block5__branch1;
              }
              if (_v_deref__Boxes__To__Vars2.symbol_at ((0 + 1)))
              {
                goto _block5__branch1;
              }
              Expr _v_deref__deref__Boxes__To__Vars2 (Expr (_v_deref__Boxes__To__Vars2, (0 + 1)));
              int _v_len9 = _v_deref__deref__Boxes__To__Vars2.get_len ();
              int _v_len10 = 1;
              if (_v_len9 < _v_len10)
              {
                goto _block5__branch1;
              }
              int _v_len___dollar_tmp_m_304_m_18 = (_v_len9 - _v_len10);
              if (!_c_28.term_eq (_v_deref__Boxes__To__Vars2, 0))
              {
                goto _block5__branch1;
              }
              if (!_v_deref__deref__Boxes__To__Vars2.symbol_at ((0 + _v_len___dollar_tmp_m_304_m_18)))
              {
                goto _block5__branch1;
              }
              Expr _ve__dollar_tmp_m_304_m_18;
              _ve__dollar_tmp_m_304_m_18 = Expr (_v_deref__deref__Boxes__To__Vars2, 0, _v_len___dollar_tmp_m_304_m_18);
              Expr _gs_name__6;
              _gs_name__6 = Expr (_v_deref__deref__Boxes__To__Vars2, (0 + _v_len___dollar_tmp_m_304_m_18), 1);
              _ve_name = _gs_name__6;
              goto _block5;
            }
          _block5__branch1: {}
            if (_v_Boxes__To__Vars2.get_len () != 1)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (_v_Boxes__To__Vars2.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__Boxes__To__Vars22 (Expr (_v_Boxes__To__Vars2, 0));
            if (_v_deref__Boxes__To__Vars22.get_len () != 2)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (_v_deref__Boxes__To__Vars22.symbol_at ((0 + 1)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__deref__Boxes__To__Vars22 (Expr (_v_deref__Boxes__To__Vars22, (0 + 1)));
            int _v_len11 = _v_deref__deref__Boxes__To__Vars22.get_len ();
            int _v_len12 = 0;
            if (_v_len11 < _v_len12)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__name__6 = (_v_len11 - _v_len12);
            if (!_v_deref__Boxes__To__Vars22.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vs__dollar_tmp_m_305_m_13;
            _vs__dollar_tmp_m_305_m_13 = Expr (_v_deref__Boxes__To__Vars22, 0, 1);
            Expr _ge_name__6;
            _ge_name__6 = Expr (_v_deref__deref__Boxes__To__Vars22, 0, _v_len__name__6);
            _ve_name = _ge_name__6;
          }
        _block5: {}
          Expr _gs_auxcall3;
          RF_CALL (::refal::Convert::ToWord, (_ve_prefix + _ve_name), _gs_auxcall3);
          Expr _gs_auxcall4;
          RF_CALL (Gener_Name, (_c_29, _gs_auxcall3), _gs_auxcall4);
          Expr _gt_var__5 ((_c_4 + _gs_auxcall4 ()) ());
          RF_CALL (::refal::Box::Store, (_vs_box, _gt_var__5), /*void*/);
          Expr _v_Boxes__To__Vars3;
          RF_CALL (Boxes_To_Vars, _ve_xpr, _v_Boxes__To__Vars3);
          _v_res1 = (_gt_var__5 + _v_Boxes__To__Vars3);
          goto _block3;
        }
      _block3__branch2: {}
        {
          if (_v_Get1.get_len () != 1)
          {
            goto _block3__branch3;
          }
          if (!_c_24.term_eq (_v_Get1, 0))
          {
            goto _block3__branch3;
          }
          Expr _v_Boxes__To__Vars4;
          RF_CALL (Boxes_To_Vars, _ve_xpr, _v_Boxes__To__Vars4);
          _v_res1 = (_c_30 + _v_Boxes__To__Vars4);
          goto _block3;
        }
      _block3__branch3: {}
        if (_v_Get1.get_len () != 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vt_var;
        _vt_var = Expr (_v_Get1, 0, 1);
        RF_TAILCALL (Boxes_To_Vars, (_vt_var + _ve_xpr), _v_res1);
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len13 = _ge_arg1.get_len ();
      int _v_len14 = 1;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch2;
      }
      int _v_len__xpr2 = (_v_len13 - _v_len14);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (Expr (_ge_arg1, 0));
      if (_v_deref__arg12.get_len () != 2)
      {
        goto _block1__branch2;
      }
      if (!_c_20.term_eq (_v_deref__arg12, 0))
      {
        goto _block1__branch2;
      }
      if (!_v_deref__arg12.symbol_at ((0 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _ve_xpr;
      _ve_xpr = Expr (_ge_arg1, (0 + 1), _v_len__xpr2);
      Expr _vs_decl;
      _vs_decl = Expr (_v_deref__arg12, (0 + 1), 1);
      Expr _ge_auxcall5;
      RF_CALL (::refal::Box::Get, _vs_decl, _ge_auxcall5);
      RF_TAILCALL (Boxes_To_Vars, (_ge_auxcall5 + _ve_xpr), _v_res1);
      goto _block1;
    }
  _block1__branch2: {}
    {
      int _v_len15 = _ge_arg1.get_len ();
      int _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch3;
      }
      int _v_len__2 = (_v_len15 - _v_len16);
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__arg13 (Expr (_ge_arg1, 0));
      int _v_len17 = _v_deref__arg13.get_len ();
      int _v_len18 = 0;
      if (_v_len17 < _v_len18)
      {
        goto _block1__branch3;
      }
      int _v_len__1 = (_v_len17 - _v_len18);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__2);
      Expr _ve_1;
      _ve_1 = Expr (_v_deref__arg13, 0, _v_len__1);
      Expr _ge_auxcall6;
      RF_CALL (Boxes_To_Vars, _ve_1, _ge_auxcall6);
      Expr _v_Boxes__To__Vars5;
      RF_CALL (Boxes_To_Vars, _ve_2, _v_Boxes__To__Vars5);
      _v_res1 = (_ge_auxcall6 () + _v_Boxes__To__Vars5);
      goto _block1;
    }
  _block1__branch3: {}
    {
      int _v_len19 = _ge_arg1.get_len ();
      int _v_len20 = 1;
      if (_v_len19 < _v_len20)
      {
        goto _block1__branch4;
      }
      int _v_len__xpr3 = (_v_len19 - _v_len20);
      Expr _vt_erm;
      _vt_erm = Expr (_ge_arg1, 0, 1);
      Expr _ve_xpr;
      _ve_xpr = Expr (_ge_arg1, (0 + 1), _v_len__xpr3);
      Expr _v_Boxes__To__Vars6;
      RF_CALL (Boxes_To_Vars, _ve_xpr, _v_Boxes__To__Vars6);
      _v_res1 = (_vt_erm + _v_Boxes__To__Vars6);
      goto _block1;
    }
  _block1__branch4: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Gener_Name, (RF_ARG _vs_Isform__one, _vs_name;;), (RF_RES _v_res1;;))
  Expr _ge_auxalt1;
  {
    {
      if (!RF_CALL (::refal::Table::Lookup, (Var_Indices, _vs_name), _ge_auxalt1))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    _ge_auxalt1 = _c_10;
  }
_block1: {}
  if (_ge_auxalt1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_auxalt1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx;
  _vs_idx = Expr (_ge_auxalt1, 0, 1);
  RF_CALL (::refal::Arithm::Add, (_vs_idx, _c_9), _vs_idx);
  RF_CALL (::refal::Table::Bind, (Var_Indices, _vs_name, _vs_idx), /*void*/);
  Expr _ge_idx__2;
  {
    {
      {
        if (!_vs_Isform__one.term_eq (_c_27, 0))
        {
          goto _negation1;
        }
        goto _block2__branch1;
      }
    _negation1: {}
      if (!_vs_idx.term_eq (_c_9, 0))
      {
        goto _block2__branch1;
      }
      _ge_idx__2 = empty;
      goto _block2;
    }
  _block2__branch1: {}
    _ge_idx__2 = _vs_idx;
  }
_block2: {}
  Expr _vs_n;
  RF_CALL (::refal::Convert::ToWord, (_vs_name + _ge_idx__2), _vs_n);
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, Var_Names, _v_Get1);
      if (_v_Get1.get_len () < 1)
      {
        goto _block4__branch1;
      }
      RF_rsplit (_v_Get1, 0, _v_rsplit__Get1, _ve__dollar_tmp_m_334_m_34);
      for ( ; ; RF_iter(_v_Get1)--)
      {
        {
          if (!RF_iter(_v_Get1))
          {
            goto _block4__branch1;
          }
          int _v_len1 = _v_rsplit__Get1.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block4__branch1;
          }
          int _v_len___dollar_tmp_m_334_m_28 = (_v_len1 - _v_len2);
          if (!_vs_n.term_eq (_v_rsplit__Get1, (0 + _v_len___dollar_tmp_m_334_m_28)))
          {
            goto _continue1;
          }
          Expr _ve__dollar_tmp_m_334_m_28;
          _ve__dollar_tmp_m_334_m_28 = Expr (_v_rsplit__Get1, 0, _v_len___dollar_tmp_m_334_m_28);
          RF_TAILCALL (Gener_Name, (_vs_Isform__one, _vs_name), _v_res1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block4;
    }
  _block4__branch1: {}
    RF_CALL (::refal::Box::Put, (Var_Names, _vs_n), /*void*/);
    _v_res1 = _vs_n;
  }
_block4: {}
RF_END

RF_FUNC (Gener_Var_Indices, (RF_ARG _vs_num, _ve_Format, _ve_prefix;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = _ve_Format.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_Ft;
      _vt_Ft = Expr (_ve_Format, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_Format, (0 + 1), _v_len__rest);
      {
        {
          if (!_vt_Ft.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _vs_ObjectSymbol;
          _vs_ObjectSymbol = Expr (_vt_Ft, 0, 1);
          Expr _v_Gener__Var__Indices1;
          RF_CALL (Gener_Var_Indices, (_vs_num, _ve_rest, _ve_prefix), (_v_Gener__Var__Indices1, _v_res2));
          _v_res1 = (_vt_Ft + _v_Gener__Var__Indices1);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_Ft.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Ft (Expr (_vt_Ft, 0));
          int _v_len3 = _v_deref__Ft.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch2;
          }
          int _v_len___dollar_tmp_m_351_m_11 = (_v_len3 - _v_len4);
          if (!_c_28.term_eq (_v_deref__Ft, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve__dollar_tmp_m_351_m_11;
          _ve__dollar_tmp_m_351_m_11 = Expr (_v_deref__Ft, (0 + 1), _v_len___dollar_tmp_m_351_m_11);
          Expr _v_Gener__Var__Indices2;
          RF_CALL (Gener_Var_Indices, (_vs_num, _ve_rest, _ve_prefix), (_v_Gener__Var__Indices2, _v_res2));
          _v_res1 = (_vt_Ft + _v_Gener__Var__Indices2);
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_Ft.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__Ft2 (Expr (_vt_Ft, 0));
          int _v_len5 = _v_deref__Ft2.get_len ();
          int _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch3;
          }
          int _v_len__name = (_v_len5 - _v_len6);
          if (!_c_31.term_eq (_v_deref__Ft2, 0))
          {
            goto _block2__branch3;
          }
          Expr _ve_name;
          _ve_name = Expr (_v_deref__Ft2, (0 + 1), _v_len__name);
          Expr _v_Gener__Var__Indices3;
          RF_CALL (Gener_Var_Indices, (_vs_num, _ve_rest, _ve_prefix), (_v_Gener__Var__Indices3, _v_res2));
          _v_res1 = ((_c_28 + _ve_name) () + _v_Gener__Var__Indices3);
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_Ft.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__Ft3 (Expr (_vt_Ft, 0));
          int _v_len7 = _v_deref__Ft3.get_len ();
          int _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch4;
          }
          int _v_len__Fe = (_v_len7 - _v_len8);
          if (!_c_23.term_eq (_v_deref__Ft3, 0))
          {
            goto _block2__branch4;
          }
          Expr _ve_Fe;
          _ve_Fe = Expr (_v_deref__Ft3, (0 + 1), _v_len__Fe);
          Expr _ve_xpr;
          Expr _gs_num__4;
          RF_CALL (Gener_Var_Indices, (_vs_num, _ve_Fe, _ve_prefix), (_ve_xpr, _gs_num__4));
          Expr _v_Gener__Var__Indices4;
          RF_CALL (Gener_Var_Indices, (_gs_num__4, _ve_rest, _ve_prefix), (_v_Gener__Var__Indices4, _v_res2));
          _v_res1 = ((_c_23 + _ve_xpr) () + _v_Gener__Var__Indices4);
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_Ft.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__Ft4 (Expr (_vt_Ft, 0));
          if (_v_deref__Ft4.get_len () != 1)
          {
            goto _block2__branch5;
          }
          if (!_v_deref__Ft4.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _vs_VariableTag;
          _vs_VariableTag = Expr (_v_deref__Ft4, 0, 1);
          Expr _vt_var ((_vs_VariableTag + _c_32 + (_ve_prefix + _vs_num) ()) ());
          Expr _gs_num__4;
          RF_CALL (::refal::Arithm::Add, (_vs_num, _c_9), _gs_num__4);
          Expr _v_Gener__Var__Indices5;
          RF_CALL (Gener_Var_Indices, (_gs_num__4, _ve_rest, _ve_prefix), (_v_Gener__Var__Indices5, _v_res2));
          _v_res1 = (_vt_var + _v_Gener__Var__Indices5);
          goto _block2;
        }
      _block2__branch5: {}
        if (_vt_Ft.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__Ft5 (Expr (_vt_Ft, 0));
        int _v_len9 = _v_deref__Ft5.get_len ();
        int _v_len10 = 1;
        if (_v_len9 < _v_len10)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__Name = (_v_len9 - _v_len10);
        if (!_v_deref__Ft5.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_VariableTag;
        _vs_VariableTag = Expr (_v_deref__Ft5, 0, 1);
        Expr _ve_Name;
        _ve_Name = Expr (_v_deref__Ft5, (0 + 1), _v_len__Name);
        Expr _v_Gener__Var__Indices6;
        RF_CALL (Gener_Var_Indices, (_vs_num, _ve_rest, _ve_prefix), (_v_Gener__Var__Indices6, _v_res2));
        _v_res1 = (_vt_Ft + _v_Gener__Var__Indices6);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = _vs_num;
  }
_block1: {}
RF_END

RF_FUNC (Vars, (RF_ARG _ve_expr;;), (RF_RES _v_res1;;))
  Expr _ge_expr__0 (_ve_expr);
  Expr _ve_vars;
  for ( ; ; )
  {
    {
      if (_ge_expr__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_vars;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1 = _ge_expr__0.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_first;
    _vt_first = Expr (_ge_expr__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_expr__0, (0 + 1), _v_len__rest);
    Expr _ve_var;
    {
      {
        if (!_vt_first.symbol_at (0))
        {
          goto _block2__branch1;
        }
        Expr _vs_ObjectSymbol;
        _vs_ObjectSymbol = Expr (_vt_first, 0, 1);
        _ve_var = empty;
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__first (Expr (_vt_first, 0));
        if (_v_deref__first.get_len () != 2)
        {
          goto _block2__branch2;
        }
        if (!_c_28.term_eq (_v_deref__first, 0))
        {
          goto _block2__branch2;
        }
        Expr _vt_Name;
        _vt_Name = Expr (_v_deref__first, (0 + 1), 1);
        _ve_var = empty;
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch3;
        }
        Expr _v_deref__first2 (Expr (_vt_first, 0));
        if (_v_deref__first2.get_len () != 2)
        {
          goto _block2__branch3;
        }
        if (!_c_31.term_eq (_v_deref__first2, 0))
        {
          goto _block2__branch3;
        }
        Expr _vt_Name;
        _vt_Name = Expr (_v_deref__first2, (0 + 1), 1);
        _ve_var = empty;
        goto _block2;
      }
    _block2__branch3: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch4;
        }
        Expr _v_deref__first3 (Expr (_vt_first, 0));
        if (_v_deref__first3.get_len () != 2)
        {
          goto _block2__branch4;
        }
        if (!_c_33.term_eq (_v_deref__first3, 0))
        {
          goto _block2__branch4;
        }
        Expr _vt_Name;
        _vt_Name = Expr (_v_deref__first3, (0 + 1), 1);
        _ve_var = empty;
        goto _block2;
      }
    _block2__branch4: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch5;
        }
        Expr _v_deref__first4 (Expr (_vt_first, 0));
        int _v_len3 = _v_deref__first4.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch5;
        }
        int _v_len__ResultExpression = (_v_len3 - _v_len4);
        if (!_c_23.term_eq (_v_deref__first4, 0))
        {
          goto _block2__branch5;
        }
        Expr _ve_ResultExpression;
        _ve_ResultExpression = Expr (_v_deref__first4, (0 + 1), _v_len__ResultExpression);
        RF_CALL (Vars, _ve_ResultExpression, _ve_var);
        goto _block2;
      }
    _block2__branch5: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch6;
        }
        Expr _v_deref__first5 (Expr (_vt_first, 0));
        int _v_len5 = _v_deref__first5.get_len ();
        int _v_len6 = 3;
        if (_v_len5 < _v_len6)
        {
          goto _block2__branch6;
        }
        int _v_len__ResultExpression2 = (_v_len5 - _v_len6);
        if (_v_deref__first5.symbol_at ((0 + 1)))
        {
          goto _block2__branch6;
        }
        Expr _v_deref__deref__first5 (Expr (_v_deref__first5, (0 + 1)));
        int _v_len7 = _v_deref__deref__first5.get_len ();
        int _v_len8 = 2;
        if (_v_len7 < _v_len8)
        {
          goto _block2__branch6;
        }
        int _v_len___dollar_tmp_m_379_m_28 = (_v_len7 - _v_len8);
        if (_v_deref__deref__first5.symbol_at ((0 + 1)))
        {
          goto _block2__branch6;
        }
        Expr _v_deref__deref__deref__first5 (Expr (_v_deref__deref__first5, (0 + 1)));
        int _v_len9 = _v_deref__deref__deref__first5.get_len ();
        int _v_len10 = 0;
        if (_v_len9 < _v_len10)
        {
          goto _block2__branch6;
        }
        int _v_len___dollar_tmp_m_379_m_25 = (_v_len9 - _v_len10);
        if (!_c_35.term_eq (_v_deref__first5, 0))
        {
          goto _block2__branch6;
        }
        if (!_c_34.term_eq (_v_deref__deref__first5, 0))
        {
          goto _block2__branch6;
        }
        Expr _vt_Fname;
        _vt_Fname = Expr (_v_deref__first5, (0 + 1 + 1), 1);
        Expr _ve_ResultExpression;
        _ve_ResultExpression = Expr (_v_deref__first5, (0 + 1 + 1 + 1), _v_len__ResultExpression2);
        Expr _ve__dollar_tmp_m_379_m_28;
        _ve__dollar_tmp_m_379_m_28 = Expr (_v_deref__deref__first5, (0 + 1 + 1), _v_len___dollar_tmp_m_379_m_28);
        Expr _ve__dollar_tmp_m_379_m_25;
        _ve__dollar_tmp_m_379_m_25 = Expr (_v_deref__deref__deref__first5, 0, _v_len___dollar_tmp_m_379_m_25);
        RF_CALL (Vars, _ve_ResultExpression, _ve_var);
        goto _block2;
      }
    _block2__branch6: {}
      {
        if (_vt_first.symbol_at (0))
        {
          goto _block2__branch7;
        }
        Expr _v_deref__first6 (Expr (_vt_first, 0));
        int _v_len11 = _v_deref__first6.get_len ();
        int _v_len12 = 2;
        if (_v_len11 < _v_len12)
        {
          goto _block2__branch7;
        }
        int _v_len__ResultExpression3 = (_v_len11 - _v_len12);
        if (!_c_35.term_eq (_v_deref__first6, 0))
        {
          goto _block2__branch7;
        }
        Expr _vt_Fname;
        _vt_Fname = Expr (_v_deref__first6, (0 + 1), 1);
        Expr _ve_ResultExpression;
        _ve_ResultExpression = Expr (_v_deref__first6, (0 + 1 + 1), _v_len__ResultExpression3);
        RF_CALL (Vars, _ve_ResultExpression, _ve_var);
        goto _block2;
      }
    _block2__branch7: {}
      Expr _gt_var__4;
      _gt_var__4 = Expr (_vt_first, 0, 1);
      _ve_var = _gt_var__4;
    }
  _block2: {}
    _ge_expr__0 = _ve_rest;
    _ve_vars = (_ve_vars + _ve_var);
  }
_exit__iter1: {}
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

static void init_ () {
  State = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"State");
  Var_Names = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Var_Names");
  Var_Indices = new rftype::StaticObject<rftype::Table>(L"Var_Indices");
  _c_0 = Expr::create<rftype::Word>("SVAR");
  _c_1 = Expr::create<rftype::Word>("TVAR");
  _c_2 = Expr::create<rftype::Word>("VVAR");
  _c_3 = Expr::create<rftype::Word>("EVAR");
  _c_4 = Expr::create<rftype::Word>("VAR");
  _c_5 = Expr::create<rftype::Word>("Len-Var");
  _c_6 = Expr::create<rftype::Word>("Length");
  _c_7 = Expr::create<rftype::Word>("Min");
  _c_36 = Expr::create<rftype::Word>("Max") + Expr::create<rftype::Integer>("1");
  _c_8 = Expr (_c_36, 0, 1);
  _c_9 = Expr (_c_36, 1, 1);
  _c_37 = Expr::create<rftype::Word>("Subst");
  _c_26 = Expr::create<rftype::Integer>("0") + (_c_37) ();
  _c_10 = Expr (_c_26, 0, 1);
  _c_11 = (_c_36) ();
  _c_12 = Expr::create<rftype::Word>("MaxBounds");
  _c_13 = Expr::create<rftype::Word>("MinBounds");
  _c_14 = (Expr::create<rftype::Word>("Instantiated?") + Expr::create<rftype::Word>("True")) ();
  _c_15 = Expr::create<rftype::Word>("LENGTH");
  _c_16 = Expr::create_sym<rftype::Func> (Reset_Var);
  _c_17 = Expr::create<rftype::Word>("Decl");
  _c_18 = Expr::create_sym<rftype::Func> (Decl_Var);
  _c_19 = Expr::create<rftype::Word>("DECL");
  _c_20 = Expr::create<rftype::Word>("Declare");
  _c_21 = Expr::create<rftype::Word>("Aux");
  _c_22 = Expr::create<rftype::Word>("INT");
  _c_23 = Expr::create<rftype::Word>("PAREN");
  _c_24 = Expr::create<rftype::Integer>("2");
  _c_25 = Expr (_c_26, 1, 1);
  _c_27 = Expr::create<rftype::Word>("From-One");
  _c_28 = Expr::create<rftype::Word>("REF");
  _c_29 = Expr::create<rftype::Word>("From-Two");
  _c_30 = Expr::create<rftype::Word>("ERROR-EXPR");
  _c_31 = Expr::create<rftype::Word>("CONST");
  _c_34 = Expr::create<rftype::Word>("PRAGMA");
  _c_32 = (_c_34) ();
  _c_33 = Expr::create<rftype::Word>("STATIC");
  _c_35 = Expr::create<rftype::Word>("CALL");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
