// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Access 
{

RF_FUNC (L, (RF_ARG s_Left, e_Exp;;), (RF_RES t_SubExp;;))

  Term* p_Left = s_Left.get_first();

  size_t left = 0;

  if (p_Left->get_type() == type_int32)
  {
    intptr_t l = static_cast<Int32*>(p_Left)->to_int();
    if (l < 0 || uintptr_t(l) > SIZE_MAX) 
      RF_LIB_ERROR("Invalid argument");
    left = l;
  }
  else
  if (p_Left->get_type() == type_int)
  {
    Integer* Left = static_cast<Integer*>(p_Left);
    if (Left->cmp(0) < 0 || Left->cmp(SIZE_MAX) > 0) 
      RF_LIB_ERROR("Invalid argument");
    else {
      intptr_t l = Left->to_int();
      left = l;
    }
  }
  else
    RF_LIB_ERROR("Invalid argument");

  if (e_Exp.get_len() == 0 || left > e_Exp.get_len() - 1)
    RF_RETFAIL;

  t_SubExp = Expr(e_Exp, left, 1);

RF_END

}

}

