// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Access 
{

RF_FUNC (Left, (RF_ARG s_Left, s_Len, e_Exp;;), (RF_RES e_SubExp;;))
 
  Term* p_Left = s_Left.get_first();
  Term* p_Len  = s_Len.get_first();
  
  size_t length = 0;
  size_t left = 0;

  if (p_Left->get_type() == type_int32)
  {
    intptr_t l = static_cast<Int32*>(p_Left)->to_int();
    if (l < 0 || uintptr_t(l) > SIZE_MAX)
      RF_LIB_ERROR("Invalid argument");
    left = l;
  }
  else 
  if (p_Left->get_type() == type_int) {
    Integer* Left = static_cast<Integer*>(p_Left);
    if (Left->cmp(0) < 0 || Left->cmp(SIZE_MAX) > 0) 
      RF_LIB_ERROR("Invalid argument");
    else {
      intptr_t l = Left->to_int();
      left = l;
    }
  }
  else
  {
    RF_LIB_ERROR("Invalid argument");
  }

  if (p_Len->get_type() == type_int32)
  {
    intptr_t l = static_cast<Int32*>(p_Len)->to_int();
    if (l < 0 || uintptr_t(l) > SIZE_MAX)
      RF_LIB_ERROR("Invalid argument");
    length = l;
  }
  else 
  if (p_Len->get_type() == type_int) {
    Integer* Len = static_cast<Integer*>(p_Len);
    if (Len->cmp(0) < 0 || Len->cmp(SIZE_MAX) > 0) 
      RF_LIB_ERROR("Invalid argument");
    else {
      intptr_t len = Len->to_int();
      length = len;
    }
  }
  else
  {
    RF_LIB_ERROR("Invalid argument");
  }
   
  if (length > e_Exp.get_len())
    RF_RETFAIL;
  if (left > e_Exp.get_len() - length)
    RF_RETFAIL;
  
   e_SubExp = Expr(e_Exp, left, length);

RF_END
}  
}
