// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Access 
{

RF_FUNC (Middle, (RF_ARG s_Left, s_Right, e_Exp;;), (RF_RES e_SubExp;;))

  Term* p_Left  = s_Left.get_first();
  Term* p_Right = s_Right.get_first(); 

  size_t left = 0;
  size_t right = 0;

  if (p_Left->get_type() == type_int32)
  {
    intptr_t l = static_cast<Int32*>(p_Left)->to_int();
    if (l < 0 || uintptr_t(l) > SIZE_MAX)
      RF_LIB_ERROR("Invalid argument");
    left = l;
  }
  else 
  if (p_Left->get_type() == type_int) {
    Integer* Left = static_cast<Integer*>(p_Left);
    if (Left->cmp(0) < 0 || Left->cmp(SIZE_MAX) > 0) 
      RF_LIB_ERROR("Invalid argument");
    else {
      intptr_t l = Left->to_int();
      left = l;
    }
  }
  else
    RF_LIB_ERROR("Invalid argument");

  if (p_Right->get_type() == type_int32)
  {
    intptr_t r = static_cast<Int32*>(p_Right)->to_int();
    if (r < 0 || uintptr_t(r) > SIZE_MAX)
      RF_LIB_ERROR("Invalid argument");
    right = r;
  }
  else 
  if (p_Right->get_type() == type_int) {
    Integer* Right = static_cast<Integer*>(p_Right);
    if (Right->cmp(0) < 0 || Right->cmp(SIZE_MAX) > 0) 
      RF_LIB_ERROR("Invalid argument");
    else {
      intptr_t r = Right->to_int();
      right = r;
    }
  }
  else
    RF_LIB_ERROR("Invalid argument");

  if (left > e_Exp.get_len())
    RF_RETFAIL;
  if (right > e_Exp.get_len() - left)
    RF_RETFAIL;

  e_SubExp = Expr(e_Exp, left, e_Exp.get_len() - right - left);

RF_END
}
}
