// $Source$
// $Revision: 2630 $
// $Date: 2007-04-05 19:10:59 +0400 (Чт, 05 апр 2007) $
// $Author: yura $

#include <rf_core.hh>
#include <rf_integer.ih>

#ifndef RFRT_WITHOUT_GMP

namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Arithm
{

RF_FUNC (Sub, (RF_ARG s_Int1, s_Int2;;), (RF_RES s_Res;;))

  Term* p_Int1 = s_Int1.get_first();
  Term* p_Int2 = s_Int2.get_first();

  if (p_Int1->get_type() == type_int) {
    Integer* i1 = static_cast<Integer*>(p_Int1);
    if (p_Int2->get_type() == type_int) {
      Integer* i2 = static_cast<Integer*>(p_Int2);
      s_Res = Integer::create_expr((*i1) - (*i2));
    } else {
      RF_LIB_ERROR("Invalid argument");
    }
  } else {
    RF_LIB_ERROR("Invalid argument");
  }
RF_END
}

}

#endif // !defined RFRT_WITHOUT_GMP
