// $Id: read_dir.cc 2630 2007-04-05 15:10:59Z yura $

#include <rf_core.hh>
#include "lib_error.hh"
#include "dir_symbol.hh"

namespace refal
{

using namespace rfrt;

namespace Dir
{

RF_FUNC (ReadDir, (RF_ARG _dir;;), (RF_RES _filename;;))
  if (_dir.get_len() == 1)
  {
    Term* p = _dir.get_first();
    RF_SYMBOL(rftype::Dir)* d_x = p->cast_to<RF_SYMBOL(rftype::Dir)>();
    if (d_x)
    {
      rftype::Dir* d = d_x->get_obj_ptr();
      try
      {
        char* name = d->read();
        if (name)
        {
          _filename = Char::create_expr(name);
          return true;
        }
        RF_RETFAIL;
      }
      catch (pxx::SysError const& err)
      {
        throw_rf_error(L"ReadDir", err.get_code());
      }
    }
  }
  RF_LIB_ERROR(L"Invalid argument");
RF_END

}

}
