// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include <rf_core.hh>
#include <stdlib.h>
#include <limits.h>

namespace refal
{
using namespace rfrt;
using namespace rftype;

namespace Dos
{

RF_FUNC (Arg, (RF_ARG s_Num;;), (RF_RES e_Arg;;))
  if (s_Num.get_len() == 1 ) {
    Term* p = s_Num.get_first();
    int n;
    if (p->get_type() == type_int32) {
      n = static_cast<Int32*>(p)->to_int();
      if (n < 0) RF_LIB_ERROR ("Invalid Argument");
    } else
    if (p->get_type() == type_int) {
      rftype::Integer* num = p->cast_to<rftype::Integer>(type_int);
      if (num != null && num->cmp(0) >= 0 && num->cmp(INT_MAX) <= 0) {
        n = num->to_int();
      } else {
        RF_LIB_ERROR ("Invalid Argument");
      }
    } else {
      RF_LIB_ERROR ("Invalid Argument");
    }
    if (n < argc) {
      e_Arg = Char::create_expr(argv[n]);
    } else {
      e_Arg = empty;
    }
    return true;
  }
  RF_LIB_ERROR ("Invalid Argument");
RF_END

}

}


