
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Class {

RF_DECL (IsWord);

RF_DECL (IsChannel);

}

}

namespace refal {

namespace Lexer {

namespace Lexer {

RF_DECL (IsRead_Term);

}

}

}

namespace refal {

namespace StdIO {

RF_DECL (IsEof);

RF_DECL (CloseChannel);

}

}

namespace refal {

namespace Error {

RF_DECL (Lib_Error);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrimCloseChannel);

RF_DECL (PrimRead);

RF_DECL (PrimOpenFile);

RF_DECL (Read);

RF_DECL (ReadChar);

RF_DECL (ReadCh);

RF_DECL (PrimRead_0);

RF_DECL (ReadLine);

RF_DECL (Read_Main);

RF_DECL (ReadLineCh);

}

}

namespace refal {

namespace Stream {

namespace Stream {

RF_DECL (Getc);

RF_DECL (Get_Line);

}

}

}

namespace refal {

namespace StdIO {

RF_DECL (ReadCharCh);

RF_DECL (OpenFile);

}

}

namespace refal {

namespace Stream {

namespace StreamErr {

RF_DECL (Errors);

}

}

}

namespace refal {

namespace Stream {

namespace Stream {

RF_DECL (Stream);

}

}

}

namespace refal {

namespace Table {

RF_DECL (Lookup);

RF_DECL (Unbind);

RF_DECL (Bind);

}

}

namespace refal {

namespace Stream {

namespace Stream {

RF_DECL (IsEnd_of_Stream);

}

}

}

namespace refal {

namespace StdIO {

extern Expr StdIn;

extern Expr StdOut;

extern Expr StdErr;

Expr ReadChunkSize;

static Expr Buffers;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

RF_FUNC (OpenFile, (RF_ARG _vs_channel, _ve_file, _vs_mode;;), RF_VOID)
  {
    {
      {
        if (!RF_CALL (refal::Class::IsChannel, _vs_channel, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_TAILCALL (refal::Error::Lib_Error, (_c_0, _c_1), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    {
      {
        if (!RF_CALL (refal::Class::IsWord, _vs_mode, /*void*/))
        {
          goto _negation2;
        }
        goto _block1__branch2;
      }
    _negation2: {}
      RF_TAILCALL (refal::Error::Lib_Error, (_c_0, _c_2), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    if (!RF_CALL (PrimOpenFile, (_vs_channel, _ve_file, _vs_mode), /*void*/))
    {
      RF_RETFAIL;
    }
    Expr _gs_auxcall1;
    RF_CALL (refal::Stream::Stream::Stream, (_c_3, (_vs_channel + ReadChunkSize)), _gs_auxcall1);
    RF_TAILCALL (refal::Table::Bind, (Buffers, _vs_channel, _gs_auxcall1), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (CloseChannel, (RF_ARG _vs_channel;;), RF_VOID)
  {
    {
      {
        if (!RF_CALL (refal::Class::IsChannel, _vs_channel, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_TAILCALL (refal::Error::Lib_Error, (_c_4, _c_1), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (PrimCloseChannel, _vs_channel, /*void*/);
    RF_TAILCALL (refal::Table::Unbind, (Buffers, _vs_channel), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (IsEof, (RF_ARG _vs_channel;;), RF_VOID)
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (refal::Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if (_v_Lookup1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream;
      _vs_tream = Expr (_v_Lookup1, 0, 1);
      RF_TAILCALL (refal::Stream::Stream::IsEnd_of_Stream, _vs_tream, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_TAILCALL (refal::Error::Lib_Error, (_c_5, _c_6), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (ReadCharCh, (RF_ARG _vs_channel;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (refal::Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if (_v_Lookup1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream;
      _vs_tream = Expr (_v_Lookup1, 0, 1);
      Expr _v_Getc1;
      if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
      {
        RF_RETFAIL;
      }
      if (!_v_Getc1.symbol_at (0))
      {
        RF_RETFAIL;
      }
      Expr _vs_char;
      _vs_char = Expr (_v_Getc1, 0, 1);
      _v_res1 = _vs_char;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_7, _c_6), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (ReadChar, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (ReadCharCh, StdIn, _v_res1);
RF_END

RF_FUNC (ReadLineCh, (RF_ARG _vs_channel;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (refal::Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if (_v_Lookup1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream;
      _vs_tream = Expr (_v_Lookup1, 0, 1);
      Expr _v_Get__Line1;
      RF_CALL (refal::Stream::Stream::Get_Line, _vs_tream, _v_Get__Line1);
      {
        {
          int _v_len1;
          _v_len1 = _v_Get__Line1.get_len ();
          int _v_len2;
          _v_len2 = 2;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch1;
          }
          int _v_len__line;
          _v_len__line = (_v_len1 - _v_len2);
          if (!_c_8.eq (_v_Get__Line1, (0 + _v_len__line)))
          {
            goto _block2__branch1;
          }
          Expr _ve_line;
          _ve_line = Expr (_v_Get__Line1, 0, _v_len__line);
          _v_res1 = _ve_line;
          goto _block2;
        }
      _block2__branch1: {}
        {
          int _v_len3;
          _v_len3 = _v_Get__Line1.get_len ();
          int _v_len4;
          _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch2;
          }
          int _v_len__line2;
          _v_len__line2 = (_v_len3 - _v_len4);
          if (!_c_9.term_eq (_v_Get__Line1, (0 + _v_len__line2)))
          {
            goto _block2__branch2;
          }
          Expr _ve_line;
          _ve_line = Expr (_v_Get__Line1, 0, _v_len__line2);
          _v_res1 = _ve_line;
          goto _block2;
        }
      _block2__branch2: {}
        {
          int _v_len5;
          _v_len5 = _v_Get__Line1.get_len ();
          int _v_len6;
          _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch3;
          }
          int _v_len__line3;
          _v_len__line3 = (_v_len5 - _v_len6);
          if (!_c_10.term_eq (_v_Get__Line1, (0 + _v_len__line3)))
          {
            goto _block2__branch3;
          }
          Expr _ve_line;
          _ve_line = Expr (_v_Get__Line1, 0, _v_len__line3);
          _v_res1 = _ve_line;
          goto _block2;
        }
      _block2__branch3: {}
        int _v_len7;
        _v_len7 = _v_Get__Line1.get_len ();
        int _v_len8;
        _v_len8 = 0;
        if (_v_len7 < (_v_len8 + 1))
        {
          RF_RETFAIL;
        }
        int _v_len__line4;
        _v_len__line4 = (_v_len7 - _v_len8);
        Expr _vv_line;
        _vv_line = Expr (_v_Get__Line1, 0, _v_len__line4);
        _v_res1 = _vv_line;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_11, _c_6), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (ReadLine, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (ReadLineCh, StdIn, _v_res1);
RF_END

RF_FUNC (ReadCh, (RF_ARG _vs_channel;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Read_Main, (_c_12, _vs_channel), _v_res1);
RF_END

RF_FUNC (Read, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (Read_Main, (_c_13, StdIn), _v_res1);
RF_END

RF_FUNC (Read_Main, (RF_ARG _vs_fname, _vs_channel;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Lookup1;
      if (!RF_CALL (refal::Table::Lookup, (Buffers, _vs_channel), _v_Lookup1))
      {
        goto _block1__branch1;
      }
      if (_v_Lookup1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream;
      _vs_tream = Expr (_v_Lookup1, 0, 1);
      Expr _ve_result;
      {
        {
          if (!RF_CALL (refal::Lexer::Lexer::IsRead_Term, _vs_tream, _ve_result))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        _ve_result = empty;
      }
    _block2: {}
      {
        Expr _v_Errors1;
        RF_CALL (refal::Stream::StreamErr::Errors, /*void*/, _v_Errors1);
        int _v_len1;
        _v_len1 = _v_Errors1.get_len ();
        int _v_len2;
        _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block3__branch1;
        }
        int _v_len___dollar_tmp_m_86_m_46;
        _v_len___dollar_tmp_m_86_m_46 = (_v_len1 - _v_len2);
        if (_v_Errors1.symbol_at (0))
        {
          goto _block3__branch1;
        }
        Expr _v_deref__Errors1;
        _v_deref__Errors1 = Expr (_v_Errors1, 0);
        if (_v_deref__Errors1.get_len () != 3)
        {
          goto _block3__branch1;
        }
        if (_v_deref__Errors1.symbol_at ((0 + 1 + 1)))
        {
          goto _block3__branch1;
        }
        Expr _v_deref__deref__Errors1;
        _v_deref__deref__Errors1 = Expr (_v_deref__Errors1, (0 + 1 + 1));
        int _v_len3;
        _v_len3 = _v_deref__deref__Errors1.get_len ();
        int _v_len4;
        _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _block3__branch1;
        }
        int _v_len__message;
        _v_len__message = (_v_len3 - _v_len4);
        Expr _ve__dollar_tmp_m_86_m_46;
        _ve__dollar_tmp_m_86_m_46 = Expr (_v_Errors1, (0 + 1), _v_len___dollar_tmp_m_86_m_46);
        Expr _vt_name;
        _vt_name = Expr (_v_deref__Errors1, 0, 1);
        Expr _vt_pos;
        _vt_pos = Expr (_v_deref__Errors1, (0 + 1), 1);
        Expr _ve_message;
        _ve_message = Expr (_v_deref__deref__Errors1, 0, _v_len__message);
        RF_CALL (refal::Error::Lib_Error, ((_c_14 + _vs_fname), _ve_message), /*void*/);
        RF_RETFAIL;
      }
    _block3__branch1: {}
      if (_ve_result.get_len () != 1)
      {
        RF_RETFAIL;
      }
      Expr _vt_erm;
      _vt_erm = Expr (_ve_result, 0, 1);
      _v_res1 = _vt_erm;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, ((_c_14 + _vs_fname), _c_6), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (PrimRead_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_15);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_15);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_15);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, (0 + 1), 1);
  RF_TAILCALL (PrimRead, (_v_stub1, _v_stub2), _v_res1);
RF_END

}

}

namespace refal {

namespace StdIO {

static void init_ () {
//  StdIn = new rftype::StaticObject<rftype::Channel>(L"StdIn");
//  StdOut = new rftype::StaticObject<rftype::Channel>(L"StdOut");
//  StdErr = new rftype::StaticObject<rftype::Channel>(L"StdErr");
  ReadChunkSize = Expr::create<rftype::Integer>("64");
  Buffers = new rftype::StaticObject<rftype::Table>(L"Buffers");
  _c_0 = Expr::create<rftype::Word>("StdIO") + Expr::create<rftype::Word>("OpenFile");
  _c_1 = Expr::create<rftype::Word>("Arg 1 is not a Channel");
  _c_2 = Expr::create<rftype::Word>("Arg 3 is not a Word");
  _c_3 = Expr::create_sym<rftype::Func> (PrimRead_0);
  _c_4 = Expr::create<rftype::Word>("StdIO") + Expr::create<rftype::Word>("CloseChannel");
  _c_5 = Expr::create<rftype::Word>("StdIO") + Expr::create<rftype::Word>("IsEof");
  _c_6 = Expr::create<rftype::Word>("Channel is not open");
  _c_7 = Expr::create<rftype::Word>("StdIO") + Expr::create<rftype::Word>("ReadCharCh");
  _c_8 = rftype::Char::create_expr (L"\r\n");
  _c_9 = Expr (_c_8, 1, 1);
  _c_10 = Expr (_c_8, 0, 1);
  _c_11 = Expr::create<rftype::Word>("StdIO") + Expr::create<rftype::Word>("ReadLineCh");
  _c_12 = Expr::create<rftype::Word>("ReadCh");
  _c_13 = Expr::create<rftype::Word>("Read");
  _c_14 = Expr (_c_5, 0, 1);
  _c_15 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

static void init_StdIn_ ()
{
  Expr _v_Stream1;
  RF_CALL (refal::Stream::Stream::Stream, (_c_3, (StdIn + Expr::create<Integer>(1))), _v_Stream1);
  RF_CALL (Table::Bind, (Buffers, StdIn, _v_Stream1), /*void*/);
}

static rfrt::InitStdIn init_StdIn_registrator_ (init_StdIn_);

}

}
