#include <rf_core.hh>
#include <pxx_string.ih>
#include <stdio.h>
#include <errno.h>
#include <ctype.h>

namespace refal
{

using namespace rfrt;

namespace StdIO
{

RF_FUNC (PrimOpenFile, (RF_ARG _channel, _fname, _mode;;), RF_VOID)
  WString ws = (WString)_fname;
  size_t len = wcstombs(null, ws.get_data(), 0);
  if (len == (size_t)(-1)) {
    throw Word::create_expr(L"Open-File") +
      Word::create_expr(L"Invalid filename");
  }
  char* fname = static_cast<char*>(alloca(len + 1));
  wcstombs(fname, ws.get_data(), len + 1);
  fname[len] = 0;
  Channel* ch = _channel.get_first()->cast_to<Channel>(type_channel);
  ws = (WString)_mode;
  len = wcstombs(null, ws.get_data(), 0);
  if (len == (size_t)(-1)) {
    throw Word::create_expr(L"Open-File") +
      Word::create_expr(L"Invalid mode");
  }
  char* mode = static_cast<char*>(alloca(len + 1));
  wcstombs(mode, ws.get_data(), len + 1);
  mode[len] = 0;
  mode[0] = tolower(mode[0]);
  bool res = ch->open(fname, mode);
  if (!res) {
    RF_RETFAIL;
//    throw Expr::create<Word>(L"Open-File") +
//      Expr::create<Word>(L"Can't open file") + _fname + _mode +
//      Expr::create<Integer>(errno);
  }
RF_END

}
}
