// $Id: prim_read.cc 2630 2007-04-05 15:10:59Z yura $

#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace StdIO
{

RF_FUNC (PrimRead, (RF_ARG _channel, _n;;), (RF_RES _chars;;))
  FILE* fp   = _channel.get_first()->cast_to<Channel>(type_channel)->get_fp();
  Term* p    = _n.get_first();
  unsigned n = p->get_type() == type_int32 ?
               p->cast_to<Int32>(type_int32)->to_int() :
               p->cast_to<Integer>(type_int)->to_int();
  wchar_t* s = static_cast<wchar_t*>(alloca(n * sizeof(wchar_t)));
  unsigned i = 0;
  while (i < n)
  {
    wint_t w = getwc(fp);
    if (w == WEOF)
    {
      if (i) break;
      RF_RETFAIL;
    }
    s[i++] = w;
  }
  _chars = Expr::create_seq<Char>(s, i);
RF_END

}
}
