#include <rf_core.hh>
#include <stdio.h>

using namespace rfrt;

namespace refal
{

namespace StdIO
{

RF_DECL(PrintCh);
RF_DECL(PrintLnCh);

RF_FUNC (PrintCh, (RF_ARG _channel, _expr;;), RF_VOID)
  if (_channel.get_len() == 1) {
    Term* p = _channel.get_first();
    Channel* ch = p->cast_to<Channel>(type_channel);
    if (ch) {
      FILE* fp = ch->get_fp();
      if (fp == NULL) {
        throw Word::create_expr(L"PrintCh") +
          Word::create_expr(L"Channel is not open");
      }
      if (!_expr.print(fp)) {
        throw Word::create_expr(L"PrintCh") +
          Word::create_expr(L"Expr::print() failed");
      }
      return true;
    }
  }
  throw Word::create_expr(L"PrintCh") +
    Word::create_expr(L"Arg 1 should be a Channel object");
RF_END

RF_FUNC (PrintLnCh, (RF_ARG _channel, _expr;;), RF_VOID)
  RF_CALL(PrintCh, (_channel, _expr), /*void*/);
  RF_CALL(PrintCh, (_channel, Char::create_expr("\n")), /*void*/);
RF_END

}
}
