
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Access {

RF_DECL (Left);

RF_DECL (Length);

}

}

namespace refal {

namespace Apply {

RF_DECL (Apply);

}

}

namespace refal {

namespace Box {

RF_DECL (Box);

}

}

namespace refal {

namespace Access {

RF_DECL (Middle);

}

}

namespace refal {

namespace Class {

RF_DECL (IsChannel);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

RF_DECL (Get);

}

}

namespace refal {

namespace Compare {

RF_DECL (Ge);

}

}

namespace refal {

namespace Error {

RF_DECL (Lib_Error);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrimCloseChannel);

RF_DECL (PrimRead);

RF_DECL (PrimOpenFile);

RF_DECL (Channel);

}

}

namespace refal {

namespace Class {

RF_DECL (IsFunc);

}

}

namespace refal {

namespace Stream {

namespace Stream {

RF_DECL (File_Close);

RF_DECL (Get_Delim);

RF_DECL (Get_While);

RF_DECL (Get_Line);

RF_DECL (Gets);

RF_DECL (Not_EOL);

RF_DECL (IsEnd_of_Stream);

RF_DECL (Getc);

RF_DECL (File_Open);

RF_DECL (Read_Expr);

RF_DECL (PrimRead_0);

RF_DECL (Scanc);

RF_DECL (StdIStream);

RF_DECL (Read_Expr_0);

RF_DECL (Ungets);

}

}

}

namespace refal {

namespace StdIO {

extern Expr ReadChunkSize;

extern Expr StdIn;

}

}

namespace refal {

namespace Stream {

namespace Stream {

RF_DECL (Stream);

RF_DECL (Not_EOL_0);

RF_DECL (Expr_Open);

}

}

}

namespace refal {

namespace Stream {

namespace Stream {

static Expr StdIStream_Box;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

RF_FUNC (Stream, (RF_ARG _vs_func, _ve_args;;), (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (refal::Class::IsFunc, _vs_func, /*void*/))
      {
        goto _negation1;
      }
      goto _block1__branch1;
    }
  _negation1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_0, _c_1), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1__branch1: {}
  RF_TAILCALL (refal::Box::Box, (_c_2 + (_vs_func + _ve_args) ()), _v_res1);
RF_END

RF_FUNC (Read_Expr, (RF_ARG _vs_box;;), (RF_RES _v_res1;;))
  Expr _v_Get1;
  RF_CALL (refal::Box::Get, _vs_box, _v_Get1);
  int _v_len1;
  _v_len1 = _v_Get1.get_len ();
  int _v_len2;
  _v_len2 = 0;
  if (_v_len1 < (_v_len2 + 1))
  {
    RF_RETFAIL;
  }
  int _v_len__expr;
  _v_len__expr = (_v_len1 - _v_len2);
  Expr _vv_expr;
  _vv_expr = Expr (_v_Get1, 0, _v_len__expr);
  RF_CALL (refal::Box::Store, (_vs_box, empty), /*void*/);
  _v_res1 = _vv_expr;
RF_END

RF_FUNC (Expr_Open, (RF_ARG _ve_xpr;;), (RF_RES _v_res1;;))
  Expr _vs_box;
  RF_CALL (refal::Box::Box, _ve_xpr, _vs_box);
  RF_TAILCALL (Stream, (_c_3, _vs_box), _v_res1);
RF_END

RF_FUNC (File_Open, (RF_ARG _ve_filename;;), (RF_RES _v_res1;;))
  Expr _vs_channel;
  RF_CALL (refal::StdIO::Channel, /*void*/, _vs_channel);
  if (!RF_CALL (refal::StdIO::PrimOpenFile, (_vs_channel, _ve_filename, _c_4), /*void*/))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_TAILCALL (Stream, (_c_5, (_vs_channel + refal::StdIO::ReadChunkSize)), _v_res1);
RF_END

RF_FUNC (File_Close, (RF_ARG _vs_tream;;), RF_VOID)
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, _vs_tream, _v_Get1);
      if (_v_Get1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__Get1;
      _v_deref__Get1 = Expr (_v_Get1, 0);
      Expr _v_deref__Get12;
      _v_deref__Get12 = Expr (_v_Get1, (0 + 1));
      int _v_len1;
      _v_len1 = _v_deref__Get12.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__args;
      _v_len__args = (_v_len1 - _v_len2);
      int _v_len3;
      _v_len3 = _v_deref__Get1.get_len ();
      int _v_len4;
      _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__buf;
      _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref__Get12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf;
      _ve_buf = Expr (_v_deref__Get1, 0, _v_len__buf);
      Expr _vs_func;
      _vs_func = Expr (_v_deref__Get12, 0, 1);
      Expr _ve_args;
      _ve_args = Expr (_v_deref__Get12, (0 + 1), _v_len__args);
      {
        {
          int _v_len5;
          _v_len5 = _v_len__args;
          int _v_len6;
          _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch1;
          }
          int _v_len__rest;
          _v_len__rest = (_v_len5 - _v_len6);
          if (!_ve_args.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _vs_ch;
          _vs_ch = Expr (_ve_args, 0, 1);
          Expr _ve_rest;
          _ve_rest = Expr (_ve_args, (0 + 1), _v_len__rest);
          if (!RF_CALL (refal::Class::IsChannel, _vs_ch, /*void*/))
          {
            goto _block2__branch1;
          }
          RF_TAILCALL (refal::StdIO::PrimCloseChannel, _vs_ch, /*void*/);
          goto _block2;
        }
      _block2__branch1: {}
        RF_CALL (refal::Error::Lib_Error, (_c_6, _c_7), /*void*/);
        RF_FUNC_ERROR (unexpected_fail);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_6, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (StdIStream, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, StdIStream_Box, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_tream;
      _vs_tream = Expr (_v_Get1, 0, 1);
      _v_res1 = _vs_tream;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vs_tream;
    RF_CALL (Stream, (_c_5, _c_9), _vs_tream);
    RF_CALL (refal::Box::Store, (StdIStream_Box, _vs_tream), /*void*/);
    _v_res1 = _vs_tream;
  }
_block1: {}
RF_END

RF_FUNC (Getc, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Gets1;
  if (!RF_CALL (Gets, (_vs_tream, _c_10), _v_Gets1))
  {
    RF_RETFAIL;
  }
  if (_v_Gets1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  Expr _vt_erm;
  _vt_erm = Expr (_v_Gets1, 0, 1);
  _v_res1 = _vt_erm;
RF_END

RF_FUNC (Gets, (RF_ARG _vs_tream, _vs_n;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, _vs_tream, _v_Get1);
      if (_v_Get1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__Get1;
      _v_deref__Get1 = Expr (_v_Get1, 0);
      Expr _v_deref__Get12;
      _v_deref__Get12 = Expr (_v_Get1, (0 + 1));
      int _v_len1;
      _v_len1 = _v_deref__Get12.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__args;
      _v_len__args = (_v_len1 - _v_len2);
      int _v_len3;
      _v_len3 = _v_deref__Get1.get_len ();
      int _v_len4;
      _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__buf;
      _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref__Get12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf;
      _ve_buf = Expr (_v_deref__Get1, 0, _v_len__buf);
      Expr _vs_func;
      _vs_func = Expr (_v_deref__Get12, 0, 1);
      Expr _ve_args;
      _ve_args = Expr (_v_deref__Get12, (0 + 1), _v_len__args);
      for ( ; ; )
      {
        {
          Expr _gs_auxcall1;
          RF_CALL (refal::Access::Length, _ve_buf, _gs_auxcall1);
          if (!RF_CALL (refal::Compare::Ge, (_gs_auxcall1, _vs_n), /*void*/))
          {
            goto _iter1;
          }
          Expr _ge_auxcall2;
          if (!RF_CALL (refal::Access::Middle, (_vs_n, _c_11, _ve_buf), _ge_auxcall2))
          {
            RF_RETFAIL;
          }
          RF_CALL (refal::Box::Store, (_vs_tream, (_ge_auxcall2 () + (_vs_func + _ve_args) ())), /*void*/);
          RF_TAILCALL (refal::Access::Left, (_c_11, _vs_n, _ve_buf), _v_res1);
          goto _exit__iter1;
        }
      _iter1: {}
        {
          {
            Expr _v_Apply1;
            if (!RF_CALL (refal::Apply::Apply, (_vs_func, _ve_args), _v_Apply1))
            {
              goto _block2__branch1;
            }
            _ve_buf = (_ve_buf + _v_Apply1);
            goto _block2;
          }
        _block2__branch1: {}
          RF_CALL (refal::Box::Store, (_vs_tream, (_ve_buf () + (_vs_func + _ve_args) ())), /*void*/);
          RF_RETFAIL;
        }
      _block2: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_12, _c_8), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Ungets, (RF_ARG _vs_tream, _ve_xpr;;), RF_VOID)
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, _vs_tream, _v_Get1);
      if (_v_Get1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__Get1;
      _v_deref__Get1 = Expr (_v_Get1, 0);
      Expr _v_deref__Get12;
      _v_deref__Get12 = Expr (_v_Get1, (0 + 1));
      int _v_len1;
      _v_len1 = _v_deref__Get12.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__args;
      _v_len__args = (_v_len1 - _v_len2);
      int _v_len3;
      _v_len3 = _v_deref__Get1.get_len ();
      int _v_len4;
      _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__buf;
      _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref__Get12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf;
      _ve_buf = Expr (_v_deref__Get1, 0, _v_len__buf);
      Expr _vs_func;
      _vs_func = Expr (_v_deref__Get12, 0, 1);
      Expr _ve_args;
      _ve_args = Expr (_v_deref__Get12, (0 + 1), _v_len__args);
      RF_TAILCALL (refal::Box::Store, (_vs_tream, ((_ve_xpr + _ve_buf) () + (_vs_func + _ve_args) ())), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_13, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (Scanc, (RF_ARG _vs_tream, _vt_1;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Getc1;
      if (!RF_CALL (Getc, _vs_tream, _v_Getc1))
      {
        goto _block1__branch1;
      }
      {
        {
          if (!_vt_1.term_eq (_v_Getc1, 0))
          {
            goto _block2__branch1;
          }
          _v_res1 = _vt_1;
          goto _block2;
        }
      _block2__branch1: {}
        Expr _vt_2;
        _vt_2 = Expr (_v_Getc1, 0, 1);
        RF_CALL (Ungets, (_vs_tream, _vt_2), /*void*/);
        _v_res1 = empty;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Get_Delim, (RF_ARG _vs_tream, _vt_delim;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, _vs_tream, _v_Get1);
      if (_v_Get1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__Get1;
      _v_deref__Get1 = Expr (_v_Get1, 0);
      Expr _v_deref__Get12;
      _v_deref__Get12 = Expr (_v_Get1, (0 + 1));
      int _v_len1;
      _v_len1 = _v_deref__Get12.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__args;
      _v_len__args = (_v_len1 - _v_len2);
      int _v_len3;
      _v_len3 = _v_deref__Get1.get_len ();
      int _v_len4;
      _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__buf;
      _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref__Get12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf;
      _ve_buf = Expr (_v_deref__Get1, 0, _v_len__buf);
      Expr _vs_func;
      _vs_func = Expr (_v_deref__Get12, 0, 1);
      Expr _ve_args;
      _ve_args = Expr (_v_deref__Get12, (0 + 1), _v_len__args);
      Expr _ve_str;
      _ve_str = empty;
      Expr _ve_Isstop;
      _ve_Isstop = empty;
      for ( ; ; )
      {
        {
          if (_ve_Isstop.get_len () != 1)
          {
            goto _iter1;
          }
          if (!_c_14.term_eq (_ve_Isstop, 0))
          {
            goto _iter1;
          }
          RF_CALL (refal::Box::Store, (_vs_tream, (_ve_buf () + (_vs_func + _ve_args) ())), /*void*/);
          _v_res1 = _ve_str;
          goto _exit__iter1;
        }
      _iter1: {}
        {
          {
            if (_ve_buf.get_len () < 1)
            {
              goto _block2__branch1;
            }
            RF_lsplit (_ve_buf, 0, _ve_1, _v_lsplit__buf);
            for ( ; ; RF_iter(_ve_buf)++)
            {
              {
                if (!RF_iter(_ve_buf))
                {
                  goto _block2__branch1;
                }
                int _v_len5;
                _v_len5 = _v_lsplit__buf.get_len ();
                int _v_len6;
                _v_len6 = 1;
                if (_v_len5 < _v_len6)
                {
                  goto _block2__branch1;
                }
                int _v_len__2;
                _v_len__2 = (_v_len5 - _v_len6);
                if (!_vt_delim.term_eq (_v_lsplit__buf, 0))
                {
                  goto _continue1;
                }
                Expr _ve_2;
                _ve_2 = Expr (_v_lsplit__buf, (0 + 1), _v_len__2);
                _ve_str = (_ve_str + _ve_1 + _vt_delim);
                _ve_buf = _ve_2;
                _ve_Isstop = _c_14;
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block2;
          }
        _block2__branch1: {}
          {
            Expr _ge_auxcall1;
            if (!RF_CALL (refal::Apply::Apply, (_vs_func, _ve_args), _ge_auxcall1))
            {
              goto _block2__branch2;
            }
            _ve_str = (_ve_str + _ve_buf);
            _ve_buf = _ge_auxcall1;
            _ve_Isstop = empty;
            goto _block2;
          }
        _block2__branch2: {}
          _ve_str = (_ve_str + _ve_buf);
          _ve_buf = empty;
          _ve_Isstop = _c_14;
        }
      _block2: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_15, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (Not_EOL, (RF_ARG _vt_1;;), RF_VOID)
  {
    {
      {
        if (!_vt_1.term_eq (_c_16, 0))
        {
          goto _block1__branch1;
        }
        goto _block1;
      }
    _block1__branch1: {}
      if (!_vt_1.term_eq (_c_17, 0))
      {
        goto _negation1;
      }
    }
  _block1: {}
    RF_RETFAIL;
  }
_negation1: {}
RF_END

RF_FUNC (Get_Line, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (Get_While, (_vs_tream, _c_18), _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (Scanc, (_vs_tream, _c_17), _ge_auxcall2);
  Expr _v_Scanc1;
  RF_CALL (Scanc, (_vs_tream, _c_16), _v_Scanc1);
  _v_res1 = (_ge_auxcall1 + _ge_auxcall2 + _v_Scanc1);
RF_END

RF_FUNC (Get_While, (RF_ARG _vs_tream, _vs_pred;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, _vs_tream, _v_Get1);
      if (_v_Get1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__Get1;
      _v_deref__Get1 = Expr (_v_Get1, 0);
      Expr _v_deref__Get12;
      _v_deref__Get12 = Expr (_v_Get1, (0 + 1));
      int _v_len1;
      _v_len1 = _v_deref__Get12.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__args;
      _v_len__args = (_v_len1 - _v_len2);
      int _v_len3;
      _v_len3 = _v_deref__Get1.get_len ();
      int _v_len4;
      _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__buf;
      _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref__Get12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf;
      _ve_buf = Expr (_v_deref__Get1, 0, _v_len__buf);
      Expr _vs_func;
      _vs_func = Expr (_v_deref__Get12, 0, 1);
      Expr _ve_args;
      _ve_args = Expr (_v_deref__Get12, (0 + 1), _v_len__args);
      Expr _ve_str;
      _ve_str = empty;
      Expr _ve_Isstop;
      _ve_Isstop = empty;
      for ( ; ; )
      {
        {
          if (_ve_Isstop.get_len () != 1)
          {
            goto _iter1;
          }
          if (!_c_14.term_eq (_ve_Isstop, 0))
          {
            goto _iter1;
          }
          RF_CALL (refal::Box::Store, (_vs_tream, (_ve_buf () + (_vs_func + _ve_args) ())), /*void*/);
          _v_res1 = _ve_str;
          goto _exit__iter1;
        }
      _iter1: {}
        {
          {
            int _v_len5;
            _v_len5 = _ve_buf.get_len ();
            int _v_len6;
            _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              goto _block2__branch1;
            }
            int _v_len__2;
            _v_len__2 = (_v_len5 - _v_len6);
            Expr _vt_1;
            _vt_1 = Expr (_ve_buf, 0, 1);
            Expr _ve_2;
            _ve_2 = Expr (_ve_buf, (0 + 1), _v_len__2);
            {
              {
                Expr _v_Apply1;
                if (!RF_CALL (refal::Apply::Apply, (_vs_pred, _vt_1), _v_Apply1))
                {
                  goto _block3__branch1;
                }
                int _v_len7;
                _v_len7 = _v_Apply1.get_len ();
                int _v_len8;
                _v_len8 = 0;
                if (_v_len7 < _v_len8)
                {
                  goto _block3__branch1;
                }
                int _v_len___dollar_tmp_m_134_m_30;
                _v_len___dollar_tmp_m_134_m_30 = (_v_len7 - _v_len8);
                Expr _ve__dollar_tmp_m_134_m_30;
                _ve__dollar_tmp_m_134_m_30 = Expr (_v_Apply1, 0, _v_len___dollar_tmp_m_134_m_30);
                _ve_str = (_ve_str + _vt_1);
                _ve_buf = _ve_2;
                _ve_Isstop = empty;
                goto _block3;
              }
            _block3__branch1: {}
              _ve_Isstop = _c_14;
            }
          _block3: {}
            goto _block2;
          }
        _block2__branch1: {}
          {
            Expr _ge_auxcall1;
            if (!RF_CALL (refal::Apply::Apply, (_vs_func, _ve_args), _ge_auxcall1))
            {
              goto _block2__branch2;
            }
            _ve_buf = _ge_auxcall1;
            _ve_Isstop = empty;
            goto _block2;
          }
        _block2__branch2: {}
          _ve_Isstop = _c_14;
        }
      _block2: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_19, _c_8), /*void*/);
    RF_FUNC_ERROR (unexpected_fail);
  }
_block1: {}
RF_END

RF_FUNC (IsEnd_of_Stream, (RF_ARG _vs_tream;;), RF_VOID)
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, _vs_tream, _v_Get1);
      if (_v_Get1.get_len () != 2)
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_Get1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__Get1;
      _v_deref__Get1 = Expr (_v_Get1, 0);
      Expr _v_deref__Get12;
      _v_deref__Get12 = Expr (_v_Get1, (0 + 1));
      int _v_len1;
      _v_len1 = _v_deref__Get12.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__args;
      _v_len__args = (_v_len1 - _v_len2);
      int _v_len3;
      _v_len3 = _v_deref__Get1.get_len ();
      int _v_len4;
      _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__buf;
      _v_len__buf = (_v_len3 - _v_len4);
      if (!_v_deref__Get12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_buf;
      _ve_buf = Expr (_v_deref__Get1, 0, _v_len__buf);
      Expr _vs_func;
      _vs_func = Expr (_v_deref__Get12, 0, 1);
      Expr _ve_args;
      _ve_args = Expr (_v_deref__Get12, (0 + 1), _v_len__args);
      {
        Expr _ge_buf__4;
        _ge_buf__4 = _ve_buf;
        for ( ; ; )
        {
          {
            int _v_len5;
            _v_len5 = _ge_buf__4.get_len ();
            int _v_len6;
            _v_len6 = 0;
            if (_v_len5 < (_v_len6 + 1))
            {
              goto _iter1;
            }
            int _v_len___dollar_tmp_m_155_m_18;
            _v_len___dollar_tmp_m_155_m_18 = (_v_len5 - _v_len6);
            Expr _vv__dollar_tmp_m_155_m_18;
            _vv__dollar_tmp_m_155_m_18 = Expr (_ge_buf__4, 0, _v_len___dollar_tmp_m_155_m_18);
            RF_CALL (refal::Box::Store, (_vs_tream, (_ge_buf__4 () + (_vs_func + _ve_args) ())), /*void*/);
            RF_RETFAIL;
          }
        _iter1: {}
          if (!RF_CALL (refal::Apply::Apply, (_vs_func, _ve_args), _ge_buf__4))
          {
            goto _block2__branch1;
          }
        }
      _exit__iter1: {}
      }
    _block2__branch1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Error::Lib_Error, (_c_20, _c_8), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Not_EOL_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_21);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  if (!RF_CALL (Not_EOL, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (PrimRead_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_21);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_21);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_21);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, (0 + 1), 1);
  RF_TAILCALL (refal::StdIO::PrimRead, (_v_stub1, _v_stub2), _v_res1);
RF_END

RF_FUNC (Read_Expr_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_21);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_21);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  if (!RF_CALL (Read_Expr, _v_stub1, _v_res1))
  {
    RF_RETFAIL;
  }
RF_END

}

}

}

namespace refal {

namespace StdIO {  extern AtStart init_StdIn;  }

namespace Stream {

namespace Stream {

static void init_ () {
  StdIO::init_StdIn.invoke();
  StdIStream_Box = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"StdIStream_Box");
  _c_0 = Expr::create<rftype::Word>("Stream") + Expr::create<rftype::Word>("Stream");
  _c_1 = Expr::create<rftype::Word>("Arg 1 is not a Function");
  _c_2 = (empty) ();
  _c_3 = Expr::create_sym<rftype::Func> (Read_Expr_0);
  _c_4 = Expr::create<rftype::Word>("R");
  _c_5 = Expr::create_sym<rftype::Func> (PrimRead_0);
  _c_6 = Expr::create<rftype::Word>("Stream") + Expr::create<rftype::Word>("File_Close");
  _c_7 = Expr::create<rftype::Word>("Arg 1 is not a Streamed File");
  _c_8 = Expr::create<rftype::Word>("Arg 1 is not a Stream");
  _c_9 = refal::StdIO::StdIn + Expr::create<rftype::Integer>("1");
  _c_10 = Expr (_c_9, 1, 1);
  _c_11 = Expr::create<rftype::Integer>("0");
  _c_12 = Expr::create<rftype::Word>("Stream") + Expr::create<rftype::Word>("Gets");
  _c_13 = Expr::create<rftype::Word>("Stream") + Expr::create<rftype::Word>("Ungets");
  _c_14 = Expr::create<rftype::Word>("Stop");
  _c_15 = Expr::create<rftype::Word>("Stream") + Expr::create<rftype::Word>("Get_Delim");
  _c_16 = rftype::Char::create_expr (L"\n");
  _c_17 = rftype::Char::create_expr (L"\r");
  _c_18 = Expr::create_sym<rftype::Func> (Not_EOL_0);
  _c_19 = Expr::create<rftype::Word>("Stream") + Expr::create<rftype::Word>("Get_While");
  _c_20 = Expr::create<rftype::Word>("Stream") + Expr::create<rftype::Word>("IsEnd_of_Stream");
  _c_21 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}
