#include <rf_core.hh>

namespace refal {

using namespace rfrt;

inline static void throw_rf_error (wchar_t const* _func, int _error)
{
  switch (_error)
  {
    case EACCES:  RF_LIB_ERROR_IN_FUNC(_func, L"Permission denied");
    case EBADF:   RF_LIB_ERROR_IN_FUNC(_func, L"Bad file number");
    case EMFILE:  RF_LIB_ERROR_IN_FUNC(_func, L"Too many open files");
    case ENFILE:  RF_LIB_ERROR_IN_FUNC(_func, L"File table overflow");
    case ENOENT:  RF_LIB_ERROR_IN_FUNC(_func, L"No such file or directory");
    case ENOMEM:  RF_LIB_ERROR_IN_FUNC(_func, L"Out of memory");
    case ENOTDIR: RF_LIB_ERROR_IN_FUNC(_func, L"Not a directory");
    default: throw;
  }
}

}
