#ifndef __pxx_exception_hh__
#define __pxx_exception_hh__

#include "stdio.h"

namespace pxx
{

class Exception
{

public:

  Exception () {}
  virtual ~Exception () {}
  virtual void print () = 0 ;

};

class UnknownError :
  public Exception
{
public:
  void print()
    { fprintf(stderr, "Unknown error occured\n"); }
};

class OutOfRange :
  public Exception
{
public:
  void print()
    { fprintf(stderr, "Index is out of range\n"); }
};

class InvalidCharConv :
  public Exception
{
public:
  void print()
    { fprintf(stderr, "Invalid character conversion\n"); }
};

}

#endif // __pxx_exception_hh__
