// $Id: rf_atstart.hh 2187 2006-12-15 00:17:56Z orlov $

#ifndef __rf_atstart_hh__
#define __rf_atstart_hh__

#include "rf_common.hh"

namespace rfrt
{

class AtStart;

class AtStart
{

  static AtStart* last;

  typedef void (*start_func_t)();
  start_func_t f;

public:

  static AtStart* first;

  AtStart* next;

  inline AtStart (start_func_t _f) :
    f(_f),
    next(null)
  {
    if (last)
      last->next = this;
    else
      first = this;
    last = this;
  }

  // For debugging purposes
  inline AtStart (start_func_t _f, char* _name) :
    f(_f),
    next(null)
  {
    printf("%s\n", _name);
    if (last)
      last->next = this;
    else
      first = this;
    last = this;
  }

  inline void invoke ()
  {
    if (f) {
      (*f)();
      f = null;
    }
  }

};


}

#endif // __rf_atstart_hh__
