// $Id: rf_expr_constr.hh 2187 2006-12-15 00:17:56Z orlov $

#ifndef __rf_expr_constr_hh__
#define __rf_expr_constr_hh__

namespace rfrt
{

using namespace rftype ;

class Expr;

template <term_class_t, class ObjClass>
class CreateExpr0;

template<class ObjClass>
class CreateExpr0<flat_term, ObjClass>
{
  Expr expr;
public:
  inline CreateExpr0 () : expr(1) {
    expr.flags |= FLAT_BIT;
    new(expr.first) ObjClass();
  };
  operator Expr () const { return expr; };
};

template<class ObjClass>
class CreateExpr0<short_term, ObjClass>
{
  Expr expr;
public:
  inline CreateExpr0 () : expr(1) {
    new(expr.first) ObjClass();
  };
  inline operator Expr () const { return expr; };
};

template<class ObjClass>
class CreateExpr0<object_term, ObjClass>
{
  Expr expr;
public:
  inline CreateExpr0 () : expr(new ObjClass()) {};
  inline operator Expr () const { return expr; };
};


template<term_class_t, class ObjClass, class CppType1>
class CreateExpr1;

template<class ObjClass, class CppType1>
class CreateExpr1<flat_term, ObjClass, CppType1>
{
  Expr expr;
public:
  inline CreateExpr1 (const CppType1& _arg1) : expr(1) {
    expr.flags |= FLAT_BIT;
    new(expr.first) ObjClass(_arg1);
  };
  inline operator Expr () const { return expr; };
};

template<class ObjClass, class CppType1>
class CreateExpr1<short_term, ObjClass, CppType1>
{
  Expr expr;
public:
  inline CreateExpr1 (const CppType1& _arg1) : expr(1) {
    new(expr.first) ObjClass(_arg1);
  };
  inline operator Expr () const { return expr; };
};

template<class ObjClass, class CppType1>
class CreateExpr1<object_term, ObjClass, CppType1>
{
  Expr expr;
public:
  inline CreateExpr1 (const CppType1& _arg1) : expr(new ObjClass(_arg1)) {};
  inline operator Expr () const { return expr; };
};


template<term_class_t, class ObjClass, class CppType1, class CppType2>
class CreateExpr2;

template<class ObjClass, class CppType1, class CppType2>
class CreateExpr2<flat_term, ObjClass, CppType1, CppType2>
{
  Expr expr;
public:
  inline CreateExpr2 (const CppType1& _arg1, const CppType2& _arg2) : expr(1) {
    expr.flags |= FLAT_BIT;
    new(expr.first) ObjClass(_arg1, _arg2);
  };
  inline operator Expr () const { return expr; };
};

template<class ObjClass, class CppType1, class CppType2>
class CreateExpr2<short_term, ObjClass, CppType1, CppType2>
{
  Expr expr;
public:
  inline CreateExpr2 (const CppType1& _arg1, const CppType2& _arg2) : expr(1) {
    new(expr.first) ObjClass(_arg1, _arg2);
  };
  inline operator Expr () const { return expr; };
};

template<class ObjClass, class CppType1, class CppType2>
class CreateExpr2<object_term, ObjClass, CppType1, CppType2>
{
  Expr expr;
public:
  inline CreateExpr2 (const CppType1& _arg1, const CppType2& _arg2) :
    expr(new ObjClass(_arg1, _arg2)) {};
  inline operator Expr () const { return expr; };
};

}

#endif // __rf_expr_constr_hh__
