#include "rf_integer.ih"

#ifndef RFRT_WITHOUT_GMP

namespace rftype
{

using namespace rfrt;

void Integer::ctor (Integer* _to, Integer const* _from)
{
  new(_to) Integer(*_from);
}

void Integer::dtor (Integer* _n)
{
  MpzContainer* p = static_cast<MpzContainer*>(_n->ptr_data2);
  if (p)
  {
    p->ref_count--;
    if (!p->ref_count)
    {
      mpz_clear(p->value);
      mpz_allocator->deallocate(p);
      p = null;
    }
  }
}

bool Integer::eq (Integer const* _n1, Integer const* _n2)
{
  return *_n1 == *_n2;
}

int Integer::compare (Integer const* _n1, Integer const* _n2)
{
  return _n1->cmp(*_n2);
}

//
// FIXME: Not implemented
uint32_t Integer::hash (Integer const* _n)
{
  (void)_n;
  return 0;
}

pxx::WString Integer::to_string (Integer const* _n)
{
  return (pxx::WString)(*_n);
}

short_type_funcs_t Integer::funcs = {
  0,
  (void (*)(Term*, Term const*))(Integer::ctor),
  (void (*)(Term*))(Integer::dtor),
  (bool (*)(Term const*, Term const*))(Integer::eq),
  (int (*)(Term const*, Term const*))(Integer::compare),
  (uint32_t (*)(Term const*))(Integer::hash),
  (pxx::WString (*)(Term const*))(Integer::to_string),
  null
};

}

#endif // !defined RFRT_WITHOUT_GMP
