// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include "rf_short_int.ih"
#include "rf_types.ih"
#include "rf_expr.ih"
#include "rf_char.ih"
#include "rf_word.ih"
#include "wchar.h"

namespace rftype
{

unsigned Int32::compute_max_len ()
{
  intptr_t i   = INTPTR_MAX / 10000;
  unsigned len = 4;
  for ( ; i; i /= 10) len++;
  return len;
}

const unsigned Int32::max_len = compute_max_len();

#if 0
Expr ShortInt::create_expr (Expr& _expr, int _flag)
{
  Term* p = _expr.get_first();
  Term* q = _expr.get_last();
  int d = 0;
  intptr_t n = 0;

  if (p->get_type() == type_short_int) {
    n = ((ShortInt*)p)->to_int();
    if (n < 0) {
      n = -n;
      d = -1;
      _flag = -1;
    }
    else {
      _flag = 1;
      d = 1;
    }
  }
  if (p->get_type() == type_word) {
    d = 0;
  }
  if (p->get_type() == type_char) {
    d = _flag;
  }

  for (p += _flag * d; p < q; p++) {
    if (p->get_type() == type_short_int) {
      intptr_t n_temp = ((ShortInt*)p)->to_int() / 10;
      intptr_t k      = 10;

      while (n_temp) {
        n_temp /= 10;
        k *= 10;
      }

      n = n * k + ((ShortInt*)p)->to_int();

    }
    if (p->get_type() == type_char) {
      if (((Char*)p)->is_digit())
        n = n * 10 + (((Char*)p)->to_wchar_t() - 48);
    }
    if (p->get_type() == type_word) {
      float n_word = 0;
      float k_word = 0.1;

      Word::NumIterator i = *((Word*)p);

      while (i.in_bounds()) {
        k_word *= 10;
        i++;
      }

      Word::NumIterator j = *((Word*)p);

      for (; j.in_bounds(); j++){
        n_word += (*j) * k_word;
        k_word /= 10;
      }
      n += size_t (n_word);
    }
  }
  if (-1 == _flag) n = -n;

  Expr e = Term::create_expr(1);
  new(e.get_first()) ShortInt(n);
  return e;
}
#endif

void Int32::ctor (Int32* _to, Int32 const* _from)
{
  _to->data1 = _from->data1;
  _to->uint_data2 = _from->uint_data2;
}

int Int32::compare (Int32 const* _shint1, Int32 const* _shint2)
{
  if (_shint1->int_data2 == _shint2->int_data2) return 0;
  else if (_shint1->int_data2 < _shint2->int_data2) return -1;
  else return 1;
}

uint32_t Int32::hash (Int32 const* _shint)
{
  return _shint->uint_data2;
}

pxx::WString Int32::to_string (Int32 const* _shint) {
  wchar_t* str = static_cast<wchar_t*>(alloca((max_len + 2) * sizeof(wchar_t)));
  if (!str) throw OutOfMemory();
  swprintf(str, max_len + 2, L"%d", _shint->int_data2);
  return pxx::WString(str);
}

short_type_funcs_t Int32::funcs = {
  0,
  null, // (void (*)(Term*, Term const*))(Int32::ctor),
  null, // ShortInt::dtor,
  null, // ShortInt::eq,
  (int (*)(Term const*, Term const*))(Int32::compare),
  (uint32_t (*)(Term const*))(Int32::hash),
  (pxx::WString (*)(Term const*))(Int32::to_string),
  null
};

}

